{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit phBabGridView_BA;

interface
uses
  Classes,SysUtils,Windows,ExtCtrls,phBabGridView,phBabGridContent,Graphics,
  BoldSystem,
  BoldSystemRT,
  BoldDefs,
  BoldElements,
  BoldAbstractListHandle,
  BoldListHandleFollower,
  BoldControlPack,
  BoldListControlPack,
  BoldControllerListControlPack,
  BoldGenericListControlPack,
  BoldListListControlPack,
  BoldStringControlPack,
  BoldNodeControlPack,
  BoldElementHandleFollower,
  BoldHandles{(*)}, BoldExpressionHandle,
  BoldAFP,
  BoldGUI,
  BoldUtils,
  BoldControlPackDefs;


type
  TBabGridView_BA     = class;
  TBoldBabGridFollowerController = class;
  TBoldBabGridNodeFollowerController = class;
  TBabGridHeaderCollection = class;
  TBabGridHeaderItem = class;
  TUserSizeItemWithName = class;





  TBabGridView_BA=class(TBabGridView_Custom)
  private
    function GetBoldHandle: TBoldElementHandle;
    procedure SetBoldHandle(const Value: TBoldElementHandle);
    procedure SetController(
      const Value: TBoldBabGridFollowerController);
    function AxisItemToNFC(
      theAxisItem: TAxisContentItem): TBoldBabGridNodeFollowerController;
    function SimpleCellFromFollower(
      Follower: TBoldFollower): TBabSimpleCell;
    function FollowerFromCell(theCell:TBabCell):TBoldFollower;
    procedure SetHeaderCollection(const Value: TBabGridHeaderCollection);
    procedure UpdateHeader;
(*    procedure UpdateCellSizes(theControlName: String; xSize,
      ySize: Integer);*)
    function GetUserSizeItem(theIsX:Boolean;theName: String): TUserSizeItemWithName;
    //procedure UpdateSizesFromHeader;

  protected
    fBoldCellProperties:TBoldBabGridFollowerController;
    fHandleFollower:TBoldElementHandleFollower;
    itsFirstProp:TLayoutProp;
    itsSecondProp:TLayoutProp;
    fBabGridHeaderCollection:TBabGridHeaderCollection;
    fInUpdateHeader:Boolean;
    fUpdateHeaderNeed:Boolean;
    fListOfUserSizeItems:TList; //Use list to syncronize all of same kind in aspect to size


    procedure OffscreenPaint;override;


    procedure _DisplayText(Follower: TBoldFollower); virtual;
    procedure _DisplayIcon(Follower: TBoldFollower); virtual;
    procedure _InsertNode(Follower: TBoldFollower); virtual;
    procedure _DeleteNode(Follower: TBoldFollower); virtual;



    function  _CreateCell(theCaller:TBabGridCell;theXAxisItem,theYAxisItem:TAxisContentItem):TBabCellType;
    procedure _InitContent(theBabGridView:TBabGridView_Custom;theBabSimpleCellStringData:TBabSimpleCellStringData);
    procedure _EditStop(theBabGridView:TBabGridView_Custom;theEditComponent:TComponent;theBabSimpleCellStringData:TBabSimpleCellStringData;var theText:String);
    procedure _AfterUserSize(theBabGridView:TBabGridView_Custom;theBabCell:TBabCell;theIsHorz:Boolean;theAxisContentItem:TAxisContentItem);

  public
    constructor Create(theOwner:TComponent);override;
    destructor Destroy;override;

    function  GetSelectedObjectsCount : integer;
    procedure GetSelectedObjects( theResultBOL : TBoldObjectList );
  published
    property BoldHandle: TBoldElementHandle read GetBoldHandle write SetBoldHandle;
    property BoldProperties: TBoldBabGridFollowerController read fBoldCellProperties write SetController;
    property HeaderCollection:TBabGridHeaderCollection read fBabGridHeaderCollection write SetHeaderCollection;
  end;

  TBabGridCellData_Plus=class(TBabSubGridCellData)
  protected
    itsCellFollower:TBoldFollower;
  public
    property CellFollower:TBoldFollower read itsCellFollower write itsCellFollower;
  end;


(***********)
  TBabGridHeaderCollection = class(TCollection)
  private
    fHorizontal: Boolean;
    fOwner:TPersistent;
    function GetHeaderItem(index: integer): TBabGridHeaderItem;
    procedure SetHeaderItem(index: integer;
      const Value: TBabGridHeaderItem);
  protected
  public
    function GetOwner:TPersistent;override;
    property Headers[index:integer]:TBabGridHeaderItem read GetHeaderItem write SetHeaderItem; default;
    //property Owner:TPersistent read fOwner write fOwner;
  published
    property Horizontal:Boolean read fHorizontal write fHorizontal;
  end;



  TUserSizeItemWithName=Class(TUserSizeItem)
  private
    fName: String;
    fIsX: Boolean;
  public
    property IsX:Boolean read fIsX write fIsX;
    property Name:String read fName write fname;
  end;

  TBabGridHeaderItem = class(TCollectionItem)
  private
    fText: String;
    fSizeControlName: String;
    fWidth: Integer;
    procedure SetHeaders(const Value: TBabGridHeaderCollection);
  protected
    fHeaders:TBabGridHeaderCollection;
  public
    constructor Create(Collection:TCollection);override;
    destructor Destroy;override;
  published
    property Text:String read fText write fText;
    property SizeControlName:String read fSizeControlName write fSizeControlName;
    property Width:Integer read fWidth write fWidth;
    property SubHeaders:TBabGridHeaderCollection read fHeaders write SetHeaders;
  end;

  {*******}
  TBoldBabGridFollowerController = class( TBoldTreeFollowerController )
  protected
    fDoBeforeDeleteItemBabGrid:TBoldFollowerEvent;
    fDoAfterAddItemBabGrid:TBoldFollowerEvent;

    function GetBoldNodeDescriptionsClass: TBoldNodeDescriptionsClass;override;

    procedure DoAfterInsertItemBabGrid(theFollower:TBoldFollower);
    procedure DoBeforeDeleteItemBabGrid(theFollower:TBoldFollower);

  public
    property OnBeforeDeleteItemBabGrid:TBoldFollowerEvent read fDoBeforeDeleteItemBabGrid write fDoBeforeDeleteItemBabGrid;
    property OnAfterAddItemBabGrid:TBoldFollowerEvent read fDoAfterAddItemBabGrid write fDoAfterAddItemBabGrid;
  end;

  TBoldBabGridNodeDescriptions=class(TBoldNodeDescriptions)
  protected
    function GetNodeDescriptionClass: TBoldNodeDescriptionClass;override;
  end;

  TBoldBabGridNodeDescription = class( TBoldNodeDescription )
  private
    fHorizontal: Boolean;
  protected
    function GetBoldNodeFollowerControllerClass: TBoldNodeFollowerControllerClass;override;
  public
    constructor Create( Collection: TCollection ); override;
  published
    property HorizontalSubLists:Boolean read fHorizontal write fHorizontal;
  end;

  TBoldBabGridNodeFollowerController=class(TBoldNodeFollowerController)
  protected
    fBoldBabGridNodeDescription:TBoldBabGridNodeDescription;
  public
    property BoldBabGridNodeDescription:TBoldBabGridNodeDescription read fBoldBabGridNodeDescription;
  end;



implementation





{ TBabGridView_BA }

constructor TBabGridView_BA.Create(theOwner: TComponent);
begin
  inherited;

  fBoldCellProperties := TBoldBabGridFollowerController.Create( Self );
  with fBoldCellProperties do
  begin
    OnAfterInsertItem := _InsertNode;
    OnBeforeDeleteItem := _DeleteNode;
    OnIconChanged := _DisplayIcon;
    OnTextChanged := _DisplayText;
  end;
  fHandleFollower := TBoldElementHandleFollower.Create(Owner, fBoldCellProperties);


  BabGridCellForViewer.FixedRows:=1;
  BabGridCellForViewer.FixedCols:=1;
  OnCreateCell:=_CreateCell;
  OnInitContent:=_InitContent;
  OnEditStop:=_EditStop;
  OnAfterUserSize:=_AfterUserSize;


  BabGridCellForViewer.BabGridCellDataClass:=TBabGridCellData_Plus;

  BabGridCellForViewer.AxisContentListX.AddNew(nil);
  BabGridCellForViewer.AxisContentListX.AddNew(nil);
  BabGridCellForViewer.AxisContentListY.AddNew(nil);

//Debug!!!!
  itsFirstProp:=TLayoutProp.Create;
  itsFirstProp.BackColor:=clGreen;

  itsSecondProp:=TLayoutProp.Create;
  itsSecondProp.BackColor:=clRed;
//Debug!!!!

  fBabGridHeaderCollection:=TBabGridHeaderCollection.Create(TBabGridHeaderItem);
  fBabGridHeaderCollection.fOwner:=self;
  fUpdateHeaderNeed:=TRUE;

  fListOfUserSizeItems:=TList.Create;
end;




destructor TBabGridView_BA.Destroy;
var
  i:integer;
begin
  FreeAndNil(fHandleFollower);
  FreeAndNil(fBoldCellProperties);
  FreeAndNil(fBabGridHeaderCollection);
  for i:=0 to fListOfUserSizeItems.Count-1 do
  begin
    TObject(fListOfUserSizeItems[i]).Free;
  end;
  FreeAndNil(fListOfUserSizeItems);
  inherited Destroy;
end;

function TBabGridView_BA.GetBoldHandle: TBoldElementHandle;
begin
  Assert(Assigned(fHandleFollower));
  Result := fHandleFollower.BoldHandle;
end;

procedure TBabGridView_BA.SetBoldHandle(
  const Value: TBoldElementHandle);
begin
  fHandleFollower.BoldHandle := value;
end;

function TBabGridView_BA.GetUserSizeItem(theIsX:Boolean;theName:String):TUserSizeItemWithName;
var
  i:integer;
begin
  result:=nil;
  if theName<>'' then
  begin
    for i:=0 to fListOfUserSizeItems.Count-1 do
    begin
      result:=TUserSizeItemWithName(fListOfUserSizeItems[i]);
      if (UpperCase(result.Name)=UpperCase(theName)) and
          (result.IsX=theIsX) then
        exit;
    end;

    result:=TUserSizeItemWithName.Create;
    fListOfUserSizeItems.Add(result);
    result.IsX:=theIsX;
    result.Name:=theName;
  end;
end;

procedure TBabGridView_BA.UpdateHeader;
  procedure localPopulate(theHeaderCell:TBabGridCell;theHeaderCollection:TBabGridHeaderCollection);
  var
    i,ii:integer;
    aHeader:TBabGridHeaderItem;
    aAxisContentItem:TAxisContentItem;
  begin
    for i:=0 to theHeaderCollection.Count-1 do
    begin
      if theHeaderCollection.Horizontal then
      begin
        aAxisContentItem:=theHeaderCell.AxisContentListX.AddNew(theHeaderCollection.Headers[i]);
        aAxisContentItem.UserSizeItem:=GetUserSizeItem(TRUE,theHeaderCollection.Headers[i].SizeControlName);
        if i=0 then
        begin
          aAxisContentItem:=theHeaderCell.AxisContentListY.AddNew(nil);
          aAxisContentItem.UserSizeItem:=GetUserSizeItem(FALSE,theHeaderCollection.Headers[i].SizeControlName);
        end;
      end
      else
      begin
        if i=0 then
        begin
          aAxisContentItem:=theHeaderCell.AxisContentListX.AddNew(nil);
          aAxisContentItem.UserSizeItem:=GetUserSizeItem(TRUE,theHeaderCollection.Headers[i].SizeControlName);
        end;
        aAxisContentItem:=theHeaderCell.AxisContentListY.AddNew(theHeaderCollection.Headers[i]);
        aAxisContentItem.UserSizeItem:=GetUserSizeItem(FALSE,theHeaderCollection.Headers[i].SizeControlName);
      end;
    end;



    for i:=0 to theHeaderCell.AxisContentListX.Count-1 do
    begin
      for ii:=0 to theHeaderCell.AxisContentListY.Count-1 do
      begin
        aHeader:=theHeaderCell.AxisContentListX.Items{(8)FIX: BoldObjects}[i].Value as TBabGridHeaderItem;
        if not Assigned(aHeader) then
          aHeader:=theHeaderCell.AxisContentListY.Items{(8)FIX: BoldObjects}[ii].Value as TBabGridHeaderItem;
        if theHeaderCell.CellMatris.getCell(i,ii) is TBabGridCell then
          localPopulate(theHeaderCell.CellMatris.getCell(i,ii) as TBabGridCell,aHeader.SubHeaders)
        else
          (theHeaderCell.CellMatris.getCell(i,ii).BabCellData as TBabSimpleCellStringData).Value:=aHeader.Text;
      end;
    end;

  end;
var
  aHeaderCell:TBabGridCell;
begin
  fInUpdateHeader:=TRUE;
  try
    if BabGridCellForViewer.FixedRows>0 then
    begin
      aHeaderCell:=BabGridCellForViewer.CellMatris.getCell(BabGridCellForViewer.FixedCols,0) as TBabGridCell;
      //aHeaderCell.AxisContentItemX.Clear;
      //aHeaderCell.AxisContentItemY.Clear;

      localPopulate(aHeaderCell,HeaderCollection);
    end;
  finally
    fInUpdateHeader:=FALSE;
  end;
end;


procedure TBabGridView_BA.SetController(
  const Value: TBoldBabGridFollowerController);
begin
  fBoldCellProperties.Assign(Value);
end;



procedure TBabGridView_BA._InitContent(theBabGridView: TBabGridView_Custom;
  theBabSimpleCellStringData: TBabSimpleCellStringData);
begin
  if (theBabSimpleCellStringData.BabCell.getGridCell=BabGridCellForViewer) and
    (theBabSimpleCellStringData.BabCell.AxisContentItemX.ListIndex<BabGridCellForViewer.FixedRows) then
    exit;
  theBabSimpleCellStringData.BabCell.LayoutProp:=itsSecondProp;
end;

procedure TBabGridView_BA.OffscreenPaint;
begin
  if fUpdateHeaderNeed then
    UpdateHeader;
  fUpdateHeaderNeed:=FALSE;
  inherited;
end;



procedure TBabGridView_BA._AfterUserSize(
  theBabGridView: TBabGridView_Custom; theBabCell: TBabCell;
  theIsHorz: Boolean; theAxisContentItem: TAxisContentItem);
var
  aHeader:TBabGridHeaderItem;
begin
  if (theBabCell.AxisContentItemX.Value is TBabGridHeaderItem) or
    (theBabCell.AxisContentItemY.Value is TBabGridHeaderItem) then
  begin
    aHeader:=theBabCell.AxisContentItemX.Value as TBabGridHeaderItem;
    if not Assigned(aHeader) then
      aHeader:=theBabCell.AxisContentItemY.Value as TBabGridHeaderItem;
    if aHeader is TBabGridHeaderItem then
    begin
    end;
  end;
end;

function TBabGridView_BA.AxisItemToNFC(theAxisItem:TAxisContentItem):TBoldBabGridNodeFollowerController;
begin
  result:=nil;
  if (theAxisItem.Value is TBoldFollower) then
    result:=((theAxisItem.Value as TBoldFollower).Controller as TBoldBabGridNodeFollowerController);
end;

function TBabGridView_BA._CreateCell(theCaller:TBabGridCell;theXAxisItem,theYAxisItem:TAxisContentItem):TBabCellType;
var
  aNFC:TBoldBabGridNodeFollowerController;
  aHeader:TBabGridHeaderItem;
begin
  result:=babCellTypeGrid;

  if fInUpdateHeader then
  begin

    aHeader:=theXAxisItem.Value as TBabGridHeaderItem;
    if not Assigned(aHeader) then
      aHeader:=theYAxisItem.Value as TBabGridHeaderItem;

    if Assigned(aHeader) then
    begin
      if aHeader.SubHeaders.Count=0 then
        result:=babCellTypeSimple
      else
        result:=babCellTypeGrid;
    end;
    
  end
  else
  begin
    aNFC:=AxisItemToNFC(theYAxisItem);
    if not Assigned(aNFC) then
      aNFC:=AxisItemToNFC(theXAxisItem);

    if Assigned(aNFC) and
      (aNFC.BoldBabGridNodeDescription.ListController.Parts.Count=0) then
      result:=babCellTypeSimple;

    if (theXAxisItem.ListIndex<theCaller.FixedCols) then
    begin
      result:=babCellTypeSimple;
    end;
  end;
end;


procedure TBabGridView_BA._DeleteNode(Follower: TBoldFollower);
var
  aNodeToRemove:TAxisContentItem;
begin
  aNodeToRemove:=(Follower.ControlData as TAxisContentItem);
  aNodeToRemove.AxisContentList.Drop(aNodeToRemove.ListIndex);
end;

procedure TBabGridView_BA._DisplayIcon(Follower: TBoldFollower);
begin

end;

function TBabGridView_BA.FollowerFromCell(theCell:TBabCell):TBoldFollower;
begin
  result:=nil;

  if theCell.AxisContentItemX.Value is TBoldFollower then
    result:=theCell.AxisContentItemX.Value as TBoldFollower
  else
  if theCell.AxisContentItemY.Value is TBoldFollower then
    result:=theCell.AxisContentItemY.Value as TBoldFollower
end;

function TBabGridView_BA.SimpleCellFromFollower(Follower: TBoldFollower):TBabSimpleCell;
var
  aAxisContentItem:TAxisContentItem;
  x,y:Integer;
  aCell:TBabCell;
begin
  result:=nil;
  if Follower.OwningFollower.ControlData is TAxisContentItem then
  begin
    aAxisContentItem:=Follower.OwningFollower.ControlData as TAxisContentItem;
    if aAxisContentItem.AxisContentList.getGridCell.AxisContentListX=aAxisContentItem.AxisContentList then
    begin
      x:=aAxisContentItem.ListIndex;
      y:=0;
    end
    else
    begin
      x:=0;
      y:=aAxisContentItem.ListIndex;
    end;
    aCell:=aAxisContentItem.AxisContentList.getGridCell.CellMatris.getCell(x,y);
    if aCell is TBabSimpleCell then
      result:=aCell as TBabSimpleCell;
  end;
end;

procedure TBabGridView_BA._EditStop(theBabGridView: TBabGridView_Custom;
  theEditComponent: TComponent;
  theBabSimpleCellStringData: TBabSimpleCellStringData;
  var theText: String);
var
  aCellFollower:TBoldFollower;
  aBoldStringFollowerController:TBoldStringFollowerController;
begin
  aCellFollower:=FollowerFromCell(theBabSimpleCellStringData.BabCell);

  aBoldStringFollowerController:=(aCellFollower.Controller as TBoldBabGridNodeFollowerController).Items{(8)FIX: BoldObjects}[BoldNodeTextIndex] as TBoldStringFollowerController;
  aBoldStringFollowerController.MayHaveChanged(theText, aCellFollower.SubFollowers[BoldNodeTextIndex]);
  aBoldStringFollowerController.SetAsString(theText, aCellFollower.SubFollowers[BoldNodeTextIndex]);
  aCellFollower.Apply;
end;

procedure TBabGridView_BA._DisplayText(Follower: TBoldFollower);
var
  aBabSimpleCell:TBabSimpleCell;
begin
  aBabSimpleCell:=SimpleCellFromFollower(Follower);
  if Assigned(aBabSimpleCell) and
  (aBabSimpleCell.AxisContentItemX.ListIndex>=aBabSimpleCell.getGridCell.FixedCols) then
  begin
    (aBabSimpleCell.BabCellData as TBabSimpleCellStringData).Value:=(Follower.Controller as TBoldStringFollowerController).GetCurrentAsString( Follower );
  end;
end;

procedure TBabGridView_BA._InsertNode(Follower: TBoldFollower);
var
  aParentNode,aNewNode,aTempNode:TAxisContentItem;
  aBabCell:TBabCell;
  aBabGridCell:TBabGridCell;
  aNFC,aMyNFC:TBoldBabGridNodeFollowerController;
begin
  aParentNode:=nil;
  if Assigned( Follower.owningFollower.owningFollower ) then
  begin
    aParentNode:=Follower.OwningFollower.OwningFollower.ControlData as TAxisContentItem;
  end;

  if Assigned(aParentNode) then
  begin
    aNFC:=AxisItemToNFC(aParentNode);
    aMyNFC:=(Follower.Controller as TBoldBabGridNodeFollowerController);
    aBabGridCell:=aParentNode.AxisContentList.getGridCell;
    aNewNode:=nil;


    if aBabGridCell.AxisContentListX=aParentNode.AxisContentList then
      aBabCell:=aBabGridCell.CellMatris.getCell(aParentNode.ListIndex,aBabGridCell.FixedRows) as TBabCell
    else
      aBabCell:=aBabGridCell.CellMatris.getCell(aBabGridCell.FixedCols,aParentNode.ListIndex) as TBabCell;

    if (aBabCell is TBabGridCell) then
    begin

      if aNFC.BoldBabGridNodeDescription.HorizontalSubLists then
      begin
        aNewNode:=(aBabCell as TBabGridCell).AxisContentListX.InsertNew(Follower.index,Follower);
        aNewNode.UserSizeItem:=GetUserSizeItem(TRUE,aMyNFC.BoldBabGridNodeDescription.Name);

        if (aBabCell as TBabGridCell).AxisContentListY.Count=0 then
        begin
          aTempNode:=(aBabCell as TBabGridCell).AxisContentListY.InsertNew(0,nil);
          aTempNode.UserSizeItem:=GetUserSizeItem(FALSE,aMyNFC.BoldBabGridNodeDescription.Name);
        end;
      end
      else
      begin
        if (aBabCell as TBabGridCell).AxisContentListX.Count=0 then
        begin
          aTempNode:=(aBabCell as TBabGridCell).AxisContentListX.InsertNew(0,nil);
          aTempNode.UserSizeItem:=GetUserSizeItem(TRUE,aMyNFC.BoldBabGridNodeDescription.Name);
        end;
        aNewNode:=(aBabCell as TBabGridCell).AxisContentListY.InsertNew(Follower.index,Follower);
        aNewNode.UserSizeItem:=GetUserSizeItem(FALSE,aMyNFC.BoldBabGridNodeDescription.Name);
      end;

    end;


  end
  else
  begin
    aNewNode:=BabGridCellForViewer.AxisContentListY.InsertNew(Follower.index+BabGridCellForViewer.FixedRows,Follower);
  end;


  if Assigned(aNewNode)then
  begin
    Follower.ControlData:=aNewNode;
    Follower.EnsureDisplayable;
  end;
end;

procedure TBabGridView_BA.SetHeaderCollection(
  const Value: TBabGridHeaderCollection);
begin
  fBabGridHeaderCollection.Assign(Value);
end;

(***  *)
function TBabGridView_BA.GetSelectedObjectsCount: integer;
var
  aList : TBoldObjectList;
begin
  aList := TBoldObjectList.Create;
  try
    GetSelectedObjects(aList);
    result := aList.Count;
  finally
    aList.Free;
  end;
end;

procedure TBabGridView_BA.GetSelectedObjects(theResultBOL: TBoldObjectList);
var
  i : integer;
  aFollower : TBoldFollower;
begin
  for i := 0 to fBabGridCellForViewer.AxisContentListY.Count-1 do
  begin
    aFollower := fBabGridCellForViewer.AxisContentListY.Items[i].Value as TBoldFollower;
    if Assigned(aFollower) and aFollower.Selected then
    begin
      if aFollower.Element is TBoldObject then
        theResultBOL.Add( aFollower.Element as TBoldObject );
    end;
  end;
end;

{ TBoldBabGridFollowerController }

procedure TBoldBabGridFollowerController.DoAfterInsertItemBabGrid(
  theFollower: TBoldFollower);
begin
  if Assigned( fDoAfterAddItemBabGrid ) then
    fDoAfterAddItemBabGrid( theFollower );
end;

procedure TBoldBabGridFollowerController.DoBeforeDeleteItemBabGrid(
  theFollower: TBoldFollower);
begin
  if Assigned( fDoBeforeDeleteItemBabGrid ) then
    fDoBeforeDeleteItemBabGrid( theFollower );
end;

function TBoldBabGridFollowerController.GetBoldNodeDescriptionsClass: TBoldNodeDescriptionsClass;
begin
  result:=TBoldBabGridNodeDescriptions;
end;

{ TBoldBabGridNodeDescriptions }

function TBoldBabGridNodeDescriptions.GetNodeDescriptionClass: TBoldNodeDescriptionClass;
begin
  result:=TBoldBabGridNodeDescription;
end;

{ TBoldBabGridNodeDescription }

constructor TBoldBabGridNodeDescription.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  (NodeFollowerController as TBoldBabGridNodeFollowerController).fBoldBabGridNodeDescription:=self;

end;

function TBoldBabGridNodeDescription.GetBoldNodeFollowerControllerClass: TBoldNodeFollowerControllerClass;
begin
  result:=TBoldBabGridNodeFollowerController;
end;


{ TBabGridHeaderCollection }

function TBabGridHeaderCollection.GetHeaderItem(
  index: integer): TBabGridHeaderItem;
begin
  result:=Items{(8)FIX: BoldObjects}[index] as TBabGridHeaderItem;
end;

function TBabGridHeaderCollection.GetOwner: TPersistent;
begin
  result:=fOwner;
end;

procedure TBabGridHeaderCollection.SetHeaderItem(index: integer;
  const Value: TBabGridHeaderItem);
begin
  Items{(8)FIX: BoldObjects}[index]:=Value;
end;

{ TBabGridHeaderItem }

constructor TBabGridHeaderItem.Create(Collection:TCollection);
begin
  inherited Create(Collection);
  fHeaders:=TBabGridHeaderCollection.Create(TBabGridHeaderItem);
  fHeaders.fOwner:=TBabGridHeaderCollection(Collection).Owner;
end;

destructor TBabGridHeaderItem.Destroy;
begin
  FreeAndNil(fHeaders);
  inherited;
end;


procedure TBabGridHeaderItem.SetHeaders(
  const Value: TBabGridHeaderCollection);
begin
  fHeaders.Assign(Value);
end;

end.
