unit phGantEditors;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  {$ifdef D6}
  DesignIntf,DesignEditors;
  {$else}
  DsgnIntf;
  {$endif}


type

  TphGant_WakeUpGlue = class(TComponentEditor)
  public
  {$ifdef D6}
    procedure Props(const Prop: IProperty);
  {$else}
    procedure Props(Prop: TPropertyEditor);
  {$endif}
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    //procedure Notification(AComponent: TComponent; Operation: TOperation); override;

  end;



implementation
uses
  phGant_BA,phGrid_BA_Editor,BoldNodeControlPack,Dialogs,phTreeNodeDescriptionEditor,
  TypInfo;



{ TphNodeDescriptionEditor }

  {$ifdef D6}
procedure TphGant_WakeUpGlue.Props(const Prop: IProperty);
  {$else}
procedure TphGant_WakeUpGlue.Props(Prop: TPropertyEditor);
  {$endif}
begin
  if Uppercase(Prop.GetName)='COLUMNS' then
  begin
    Prop.Edit;
  end;
  if Uppercase(Prop.GetName)='BOLDPROPERTIES' then
  begin
    Prop.Edit;
  end;
end;


procedure TphGant_WakeUpGlue.ExecuteVerb(Index: Integer);
var
  {$ifdef D6}
  Components: TDesignerSelections;
  {$else}
  Components: TDesignerSelectionList;
  {$endif}
begin
  case Index of
    0:TTreeNodeDescriptionEditor.Edit(Component,(Component as TphGant_BA).BoldProperties, Designer);
    1:
      begin
      {$ifdef D6}
        Components := TDesignerSelections.Create;
        try
          (Designer as IDesigner).GetSelections(Components);
      {$else}
        Components := TDesignerSelectionList.Create;
        try
          Components.Add( (Component as TphGant_BA).Grid_BA);
      {$endif}
          GetComponentProperties(Components, tkProperties, Designer, Props);
        finally
          Components.Free;
        end;
      end;
  end;
  Designer.Modified;
end;

function TphGant_WakeUpGlue.GetVerb(Index: Integer): string;
begin
  case Index of
    0:Result := '&Edit Node Descriptions...';
    1:Result := '&Columns...';
  end;
end;

function TphGant_WakeUpGlue.GetVerbCount: Integer;
begin
  Result := 2;
end;



(*procedure TphGant_WakeUpGlue.Notification(
  AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation=opRemove) then
  begin
    TTreeNodeDescriptionEditor.ClassNotification(AComponent);
  end;
end;  *)

end.

