(*
$Header: /Gemensamt/Tredjepart/PlexityHide/BA/phGant_BA.pas 33    01-10-04 13.23 Dthk $
*)
unit phGant_BA;

interface
uses
  phGant,Classes,phTree,ComCtrls,SysUtils,imgList,Windows,
  BoldElements,
  BoldHandles{(*)}, BoldExpressionHandle,
  BoldElementHandleFollower,
  BoldControlPack,
  BoldNumericControlPack,
  BoldStringControlPack,
  BoldFloatControlPack,
  BoldGenericListControlPack,
  BoldNodeControlPack,
  BoldControllerListControlPack,
  BoldSystemRT,
  phDataEntityPack,
  Graphics,
  Controls,
  phGridTree,
  BoldSystem,
  phGrid,
  phGrid_BA,
  BoldControlPackDefs;



type

  TphGant_BA=class;
  TGantTree_BA=class;
  TBoldGantTimeDef=class;
  TBoldGantTimeDefs=class;



  TBoldGantTimeDefs = class(TCollection)
  private
    fDoStartDateChanged: TBoldFollowerEvent;
    fDoStopDateChanged: TBoldFollowerEvent;
  protected
    fOwningComponent:TComponent;
    function GetOwner: TPersistent; override;
    procedure DoStartDateChanged(theFollower:TBoldFollower);
    procedure DoStopDateChanged(theFollower:TBoldFollower);
    function FindDefFromControllerList(theBoldControllerList:TBoldControllerList):TBoldGantTimeDef;
  public
    property OnStartDateChanged:TBoldFollowerEvent read fDoStartDateChanged write fDoStartDateChanged;
    property OnStopDateChanged:TBoldFollowerEvent read fDoStopDateChanged write fDoStopDateChanged;
  end;

  TOnUserInitTime=procedure(theGant:TphGant_ComBasic;theDataEntity:TphDataEntity_GantTime) of object;


  TBoldGantTimeDef = class( TCollectionItem )
  private
    fColor: TColor;
    fGantTimeStyle: TGantTimeStyle;
    fBoldControllerList:TBoldControllerList;
    fName:String;
    fLayer: Integer;
    fOnUserDrawTime: TOnUserDrawTime;
    fBottomInset: Integer;
    fTopInset: Integer;
    fFixedSize: Integer;
    fImageIndex: Integer;
    fOnUserInitTime: TOnUserInitTime;
    fCollisionDetect: Boolean;
    fValueTypeName: String;
    function _GetContextType: TBoldElementTypeInfo;
    procedure SetValueTypeName(const Value: String);
  protected
    function GetStartDateController: TBoldFloatFollowerController;
    function GetStopDateController: TBoldFloatFollowerController;
    procedure SetStartDateController(
      const Value: TBoldFloatFollowerController);
    procedure SetStopDateController(
      const Value: TBoldFloatFollowerController);

    function GetDisplayName: string; override;

  public
    constructor Create(theCollection:TCollection);override;
    destructor  Destroy;override;
    procedure   Assign(Source: TPersistent); override;
  published
    property Name:String read fName write fName;
    property Color:TColor read fColor write fColor;
    property Style:TGantTimeStyle read fGantTimeStyle write fGantTimeStyle;
    property Layer:Integer read fLayer write fLayer;


    property CollisionDetect:Boolean read fCollisionDetect write fCollisionDetect;
    property TopInset:Integer read fTopInset write fTopInset;
    property BottomInset:Integer read fBottomInset write fBottomInset;
    property FixedSize:Integer read fFixedSize write fFixedSize;
    property ImageIndex:Integer read fImageIndex write fImageIndex;
    property GantTimeStartDateController:TBoldFloatFollowerController read GetStartDateController write SetStartDateController;
    property GantTimeStopDateController:TBoldFloatFollowerController read GetStopDateController write SetStopDateController;
    property ValueTypeName : String read fValueTypeName write SetValueTypeName;

    property OnUserDrawTime:TOnUserDrawTime read fOnUserDrawTime write fOnUserDrawTime;
    property OnUserInitTime:TOnUserInitTime read fOnUserInitTime write fOnUserInitTime;
  end;



  TBoldGantFollowerController = class( TBoldTreeFollowerController )
  protected
    fDoBeforeDeleteItemGantTime:TBoldFollowerEvent;
    fDoAfterAddItemGantTime:TBoldFollowerEvent;

    function GetBoldNodeDescriptionsClass: TBoldNodeDescriptionsClass;override;

    procedure DoAfterInsertItemGantTime(theFollower:TBoldFollower);
    procedure DoBeforeDeleteItemGantTime(theFollower:TBoldFollower);

  public
    property OnBeforeDeleteItemGantTime:TBoldFollowerEvent read fDoBeforeDeleteItemGantTime write fDoBeforeDeleteItemGantTime;
    property OnAfterAddItemGantTime:TBoldFollowerEvent read fDoAfterAddItemGantTime write fDoAfterAddItemGantTime;
  end;

  TBoldGantNodeDescriptions=class(TBoldNodeDescriptions)
  protected
    function GetNodeDescriptionClass: TBoldNodeDescriptionClass;override;
  end;

  TBoldGantNodeDescription = class( TBoldNodeDescription )
  private
    fCollisionDetectionBetweenLayers: Boolean;
    function GetListControllerGantRow: TBoldGenericListController;
    procedure SetListControllerGantRow(
      const Value: TBoldGenericListController);
    function GetContextType: TBoldElementTypeInfo;
  protected
  public
    constructor Create( Collection: TCollection ); override;
  published
    property GantRowListController: TBoldGenericListController read GetListControllerGantRow write SetListControllerGantRow;


    property CollisionDetectionBetweenLayers:Boolean read fCollisionDetectionBetweenLayers write fCollisionDetectionBetweenLayers;
  end;






  TGantTree_BA = class(TGantTree)
  protected
    procedure Expand(Node: TTreeNode); override;
    procedure phCustomDrawItem(Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);override;
    procedure _OnBeforeCanEditItem(theObs:TphDataEntity);override;
  public
    constructor GantCreate(theOwner:TComponent;theGant:TphGant_ComBasic);
    destructor Destroy;override;
    procedure GetSelectedElements(theList: TBoldList);
  end;

  TphGant_BA=class(TphGant_ComBasic)
  private
    function GetBoldHandle: TBoldElementHandle;
    procedure SetBoldHandle(const Value: TBoldElementHandle);
    procedure SetTreeController(const Value: TBoldGantFollowerController);
    procedure SetBoldGantTimeDefs(const Value: TBoldGantTimeDefs);
    procedure _BeforeMakeUptoDate(aBoldFollower: TBoldFollower);
    function _OnGetContextType: TBoldElementTypeInfo;
    function GetGrid_BA: TphGrid_BA;
    function FindBoldGantNodeDescriptionFromController(
      aC: TBoldFollowerController): TBoldGantNodeDescription;
  protected
    fHandleFollower: TBoldElementHandleFollower;
    fTreeController: TBoldGantFollowerController;
    fBoldGantTimeDefs:TBoldGantTimeDefs;
    fCurrentlyExpandingNode : TphDataEntity_Tree;

    function  DoGetFollowerControllerForRowsByName(theName:String):TBoldFollowerController;


    function CreateTree(theOwner:TComponent):TGantTree;override;
    function CreateRow(theNode:TphDataEntity_Tree;theDataEntity_GridTreeNode:TphDataEntity_GridTreeNode):TGantRow;override;

    procedure _DisplayText(Follower: TBoldFollower); virtual;
    procedure _DisplayIcon(Follower: TBoldFollower); virtual;
    procedure _InsertNode(Follower: TBoldFollower); virtual;
    procedure _DeleteNode(Follower: TBoldFollower); virtual;

    procedure _OnChangeDataEntity_Tree(theTree:TObject;theDataEntity:TphDataEntity);
    procedure _OnChangeDataEntity_GantTime(theGant:TphGant_ComBasic;theDataEntity:TphDataEntity_GantTime);

    procedure _AfterInsertItemGantTime(theFollower:TBoldFollower);virtual;
    procedure _BeforeDeleteItemGantTime(theFollower:TBoldFollower);virtual;
    procedure _StartDateChanged(theFollower:TBoldFollower);virtual;
    procedure _StopDateChanged(theFollower:TBoldFollower);virtual;

    procedure _OnBeforeCanEditItem(theDataEntity: TphDataEntity);override;

    procedure UserDrawTime(theDataEntity: TphDataEntity_GantTime;theRect: TRect);override;

    procedure GantAreaStartDrag(Sender: TObject;var DragObject: TDragObject);override;
    procedure GantAreaEndDrag(Sender, Target: TObject; X, Y: Integer);override;

    function CreateGrid(theOwner: TComponent): TphGrid;override;
    procedure InitializeInConstructor;override;


  public
    procedure Initialize;override;
    destructor Destroy;override;

    class function DataEntityToElement(theDataEntity: TphDataEntity):TBoldElement;
    class function DataEntityToFollower(theDataEntity: TphDataEntity):TBoldFollower;

    property Grid_BA:TphGrid_BA read GetGrid_BA;
    property CurrentlyExpandingNode:TphDataEntity_Tree read fCurrentlyExpandingNode;

  published
    property Align;
    property PopupMenu;
    property PopupMenuGantArea;
    property PopupMenuTreeview;
    property PopupMenuScaler;

    property BoldHandle: TBoldElementHandle read GetBoldHandle  write SetBoldHandle;
    property BoldProperties: TBoldGantFollowerController read fTreeController write SetTreeController;
    property BoldGantTimeDefs:TBoldGantTimeDefs read fBoldGantTimeDefs write SetBoldGantTimeDefs;

    property    OnTimeChangeRow;
    property    OnTimeCopy;
    property    OnAlignNeed;


    property OnAfterAddGantRow;
    property OnChangeDataEntity_GantTime;
    property OnChangeDataEntity_Tree;

  end;



const
  BoldNodeListIndex_GantList=3;
  BoldNodeStartDateGantItem=0;
  BoldNodeStopDateGantItem=1;

implementation
uses
  BoldRootedHandles,phDataTraveser,BoldGUI,
  phTree_BA_Common;


type
  TphGrid_BAIG=class(TphGrid_BA)
  protected
    function GetFollowerIndexForColumns: Integer;override;
  end;

{ TGantTree_BA }

procedure TGantTree_BA.Expand(Node: TTreeNode);
begin
  TphTree_BA_Common.Expand(self,GetDataEntityFromNode(Node),BoldNodeListIndex_GantList);
  inherited Expand(Node);
end;

destructor TGantTree_BA.Destroy;
begin
  inherited;

end;

constructor TGantTree_BA.GantCreate(theOwner: TComponent;
  theGant: TphGant_ComBasic);
begin
  inherited GantCreate(theOwner,theGant);
end;

procedure TGantTree_BA.phCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  inherited phCustomDrawItem(Sender,Node,State,DefaultDraw);
  if Assigned(Parent) then // Should not be here, but
    ShowScrollBar(Handle,SB_VERT, FALSE);
end;

procedure TGantTree_BA._OnBeforeCanEditItem(theObs: TphDataEntity);
var
  aFollower:TBoldFollower;
begin
  aFollower:=TBoldFollower(theObs.UserReference);
  theObs.CanEdit:=(aFollower.Controller as TBoldNodeFollowerController).Items[BoldNodeTextIndex].MayModify(aFollower.SubFollowers[BoldNodeTextIndex]);
end;

procedure TGantTree_BA.GetSelectedElements(theList: TBoldList);
begin
  TphTree_BA_Common.GetSelectedElements(fListOfDataListListInstances,theList);
end;

{ TphGant_BA }

function TphGant_BA.CreateRow(theNode: TphDataEntity_Tree;theDataEntity_GridTreeNode:TphDataEntity_GridTreeNode): TGantRow;
begin
  result:=inherited CreateRow(theNode,theDataEntity_GridTreeNode);
end;

function TphGant_BA.CreateTree(theOwner: TComponent): TGantTree;
begin
  result:=TGantTree_BA.GantCreate(theOwner,self);
end;

destructor TphGant_BA.Destroy;
begin
  Destroying;
  FreeNotification(self);

  TphGrid_BAIG(Grid).CleanTreePropsFromColumnRefs(fTreeController);

  FreeAndNil(fTreeController);
  FreeAndNil(fHandleFollower);
  FreeAndNil(fBoldGantTimeDefs);
  inherited;

end;


procedure TphGant_BA.SetBoldHandle(const Value: TBoldElementHandle );
begin
  fHandleFollower.BoldHandle := value
end;

function TphGant_BA.GetBoldHandle: TBoldElementHandle;
begin
  Result := fHandleFollower.BoldHandle;
end;

procedure TphGant_BA.Initialize;
begin
  inherited;
  fTreeController := TBoldGantFollowerController.Create( Self );
  with fTreeController do
  begin
    OnAfterInsertItem := _InsertNode;
    OnBeforeDeleteItem := _DeleteNode;
    OnIconChanged := _DisplayIcon;
    OnTextChanged := _DisplayText;
    OnGetContextType := _OnGetContextType;
    BeforeMakeUptoDate := _BeforeMakeUptoDate;


    OnAfterAddItemGantTime:=_AfterInsertItemGantTime;
    OnBeforeDeleteItemGantTime:=_BeforeDeleteItemGantTime;
  end;
  fHandleFollower := TBoldElementHandleFollower.Create(Owner, fTreeController);
  fBoldGantTimeDefs:=TBoldGantTimeDefs.Create(TBoldGantTimeDef);
  with fBoldGantTimeDefs do
  begin
    fOwningComponent:=self;
    OnStartDateChanged:=_StartDateChanged;
    OnStopDateChanged:=_StopDateChanged;
  end;

  TreeView.OnValueChanged:=_OnChangeDataEntity_Tree;
  OnChangeDataEntity_GantTime:=_OnChangeDataEntity_GantTime;



end;



function TphGant_BA._OnGetContextType:TBoldElementTypeInfo;
begin
  if assigned( BoldHandle ) then
  begin
    if assigned( BoldHandle.StaticBoldType ) then
      result := BoldHandle.StaticBoldType
    else
      result := BoldHandle.StaticSystemTypeInfo
  end
  else
    result := nil;
end;

procedure TphGant_BA._BeforeMakeUptoDate(aBoldFollower:TBoldFollower);
begin
  if UseGridNotTree then
    TphGrid_BAIG(Grid)._BeforeMakeUptoDateTree(aBoldFollower)
  else
    if Assigned(aBoldFollower.OwningFollower) then
      fCurrentlyExpandingNode:=(aBoldFollower.OwningFollower.ControlData as TphDataEntity_Tree);
end;




procedure TphGant_BA.SetTreeController(
  const Value: TBoldGantFollowerController);
begin
  fTreeController.Assign(Value);
end;

procedure TphGant_BA._DeleteNode(Follower: TBoldFollower);
begin
  if UseGridNotTree then
    TphGrid_BAIG(Grid)._DeleteTreeRow(Follower)
  else
    TphTree_BA_Common._DeleteNode(TreeView,Follower,BoldNodeListIndex_GantList);
end;

procedure TphGant_BA._DisplayIcon(Follower: TBoldFollower);
begin
  if UseGridNotTree then
    TphGrid_BAIG(Grid).TreeDefinitionTextOrIconChanged(Follower)
  else
    TphTree_BA_Common._DisplayIcon(Follower);
end;

procedure TphGant_BA._DisplayText(Follower: TBoldFollower);
begin
  if UseGridNotTree then
    TphGrid_BAIG(Grid).TreeDefinitionTextOrIconChanged(Follower)
  else
    TphTree_BA_Common._DisplayText(TreeView,Follower,FALSE);
end;

procedure TphGant_BA._OnChangeDataEntity_Tree(theTree:TObject;theDataEntity:TphDataEntity);
begin
  TphTree_BA_Common._OnChangeDataEntity_Tree(theTree,theDataEntity);
end;

procedure TphGant_BA._InsertNode(Follower: TBoldFollower);
begin
  if UseGridNotTree then
    TphGrid_BAIG(Grid)._InsertTreeRow(Follower)
  else
    TphTree_BA_Common._InsertNode(TreeView,Follower,BoldNodeListIndex_GantList);
end;





procedure TphGant_BA._StartDateChanged(theFollower: TBoldFollower);
begin
  with (theFollower.owningFollower.ControlData as TphDataEntity_GantTime) do
  begin
    Start:=(theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower);
    Row.UpdateSubColumns;
  end;
  GA.Invalidate;

end;

procedure TphGant_BA._StopDateChanged(theFollower: TBoldFollower);
begin
  with (theFollower.owningFollower.ControlData as TphDataEntity_GantTime) do
  begin
    Stop:=(theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower);
    Row.UpdateSubColumns;
  end;
  GA.Invalidate;
end;

procedure TphGant_BA.SetBoldGantTimeDefs(const Value: TBoldGantTimeDefs);
begin
  fBoldGantTimeDefs.Assign(Value);
end;


function TphGant_BA.FindBoldGantNodeDescriptionFromController(aC:TBoldFollowerController):TBoldGantNodeDescription;
var
  i:integer;
begin
  result:=nil;
  for i:=0 to BoldProperties.NodeDescriptions.Count-1 do
  begin
    if BoldProperties.NodeDescriptions[i].NodeFollowerController=aC then
      result:=BoldProperties.NodeDescriptions[i] as TBoldGantNodeDescription;
  end;
end;

procedure TphGant_BA._AfterInsertItemGantTime(theFollower: TBoldFollower);
var
  aParentNode:TphDataEntity;
  aBoldGantTimeDef:TBoldGantTimeDef;
  aBoldGantNodeDescription:TBoldGantNodeDescription;
begin
  if Assigned( theFollower.owningFollower.owningFollower ) then
  begin
    aParentNode:=theFollower.owningFollower.owningFollower.ControlData as TphDataEntity;
    if Assigned(aParentNode) then
    begin

      aBoldGantTimeDef:=BoldGantTimeDefs.FindDefFromControllerList(theFollower.Controller as TBoldControllerList);
      aBoldGantNodeDescription:=FindBoldGantNodeDescriptionFromController(theFollower.OwningFollower.OwningFollower.Controller);


      if aParentNode is TphDataEntity_Tree then
      begin
        theFollower.ControlData:=AddGantTime(aParentNode as TphDataEntity_Tree,aBoldGantTimeDef.Layer);
      end
      else
      if aParentNode is TphDataEntity_GridTreeNode then
      begin
        theFollower.ControlData:=GridNode_AddGantTime(aParentNode as TphDataEntity_GridTreeNode,aBoldGantTimeDef.Layer);
      end;
      RowList.FindRowFromUntypedNode(aParentNode).CollisionDetection:=aBoldGantTimeDef.CollisionDetect;
      if Assigned(aBoldGantNodeDescription) then
        RowList.FindRowFromUntypedNode(aParentNode).CollisionDetectionBetweenLayers:=aBoldGantNodeDescription.CollisionDetectionBetweenLayers;

      with (theFollower.ControlData as TphDataEntity_GantTime) do
      begin
        Style:=aBoldGantTimeDef.Style;
        Color:=aBoldGantTimeDef.Color;
        TopInset:=aBoldGantTimeDef.TopInset;
        BottomInset:=aBoldGantTimeDef.BottomInset;
        FixedSize:=aBoldGantTimeDef.FixedSize;
        ImageIndex:=aBoldGantTimeDef.ImageIndex;
        UserReference:=theFollower;
      end;
      if Assigned(aBoldGantTimeDef.OnUserInitTime) then
        aBoldGantTimeDef.OnUserInitTime(self,(theFollower.ControlData as TphDataEntity_GantTime));

      (theFollower.Controller as TBoldControllerList).SetActiveRange( theFollower, 0, 1);

      theFollower.EnsureDisplayable;
      GA.Invalidate;
    end;
  end;
end;

procedure TphGant_BA._BeforeDeleteItemGantTime(theFollower: TBoldFollower);
begin
  if csDestroying in ComponentState then
    exit;
  RemoveGantTime((theFollower.ControlData as TphDataEntity_GantTime));
  GA.Invalidate;
end;

function TphGant_BA.DoGetFollowerControllerForRowsByName(
  theName: String): TBoldFollowerController;
var
  i:integer;
begin
  result:=nil;
  for i:=0 to BoldGantTimeDefs.Count-1 do
  begin
    if UpperCase((BoldGantTimeDefs.Items[i] as TBoldGantTimeDef).DisplayName)=UpperCase(theName) then
    begin
      result:=(BoldGantTimeDefs.Items[i] as TBoldGantTimeDef).fBoldControllerList;
    end;
  end;
end;

procedure TphGant_BA._OnChangeDataEntity_GantTime(
  theGant: TphGant_ComBasic; theDataEntity: TphDataEntity_GantTime);
var
  aFollower:TBoldFollower;
  aBoldControllerList:TBoldControllerList;
begin
  aFollower:=TBoldFollower(theDataEntity.UserReference);
  if Assigned(aFollower) then
  begin
    aBoldControllerList:=(aFollower.Controller as TBoldControllerList);
    try
      (aBoldControllerList.Items[0] as
            TBoldFloatFollowerController).SetAsFloat(theDataEntity.Start,aFollower);
      (aBoldControllerList.Items[1] as
            TBoldFloatFollowerController).SetAsFloat(theDataEntity.Stop,aFollower);
    finally
      // To catch any rendering snapping
      theDataEntity.Start:=(aBoldControllerList.Items[0] as
                                  TBoldFloatFollowerController).GetCurrentAsFloat(aFollower.SubFollowers[0]);
      theDataEntity.Stop:=(aBoldControllerList.Items[1] as
                                  TBoldFloatFollowerController).GetCurrentAsFloat(aFollower.SubFollowers[1]);
    end;

  end;
end;

procedure TphGant_BA._OnBeforeCanEditItem(theDataEntity: TphDataEntity);
var
  aBoldFollower:TBoldFollower;
  aBoldControllerList:TBoldControllerList;
begin
  inherited;
  aBoldFollower:=TBoldFollower((theDataEntity as TphDataEntity_GantTime).UserReference);
  aBoldControllerList:=aBoldFollower.Controller as TBoldControllerList;
  theDataEntity.CanEdit:=aBoldControllerList.Items[0].MayModify(aBoldFollower.SubFollowers[0]) and
                        aBoldControllerList.Items[0].MayModify(aBoldFollower.SubFollowers[1]);
end;

procedure TphGant_BA.UserDrawTime(theDataEntity: TphDataEntity_GantTime;
  theRect: TRect);
var
  aBoldGantTimeDef:TBoldGantTimeDef;
begin
  // inherited;
  aBoldGantTimeDef:=BoldGantTimeDefs.FindDefFromControllerList(TBoldFollower(theDataEntity.UserReference).Controller as TBoldControllerList);
  if Assigned(aBoldGantTimeDef) and Assigned(aBoldGantTimeDef.OnUserDrawTime) then
  begin
    aBoldGantTimeDef.OnUserDrawTime(self,theDataEntity,GA.OffscreenCanvas,theRect);
  end;
end;


class function TphGant_BA.DataEntityToElement(
  theDataEntity: TphDataEntity): TBoldElement;
begin
  result:=nil;
  if Assigned(theDataEntity) then
  begin
    result:=TBoldFollower(theDataEntity.UserReference).{(1)FIX: Value}Element;
  end;
end;

class function TphGant_BA.DataEntityToFollower(
  theDataEntity: TphDataEntity): TBoldFollower;
begin
  result:=nil;
  if Assigned(theDataEntity) then
  begin
    result:=TBoldFollower(theDataEntity.UserReference);
  end;
end;

procedure TphGant_BA.GantAreaEndDrag(Sender, Target: TObject; X,
  Y: Integer);
var
  aTrv:TDataListTrav;
begin
  inherited;
  aTrv:=TDataListTrav.CreateMultiList(AllDataEntities);
  try
    aTrv.First;
    while not aTrv.EOF do
    begin
      if aTrv.DataEntity.Selected and Assigned(aTrv.DataEntity.UserReference) then
      begin
        TBoldFollower(aTrv.DataEntity.UserReference).Controller.EndDrag;
      end;
      aTrv.Next;
    end;
  finally
    aTrv.Free;
  end;
end;

procedure TphGant_BA.GantAreaStartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  aTrv:TDataListTrav;
  aList: TBoldObjectList;
  aElement : TBoldElement;
begin
  inherited;
  aTrv:=TDataListTrav.CreateMultiList(AllDataEntities);
  aList := TBoldObjectList.Create;
  try
    aTrv.First;
    while not aTrv.EOF do
    begin
      if aTrv.DataEntity.Selected and Assigned(aTrv.DataEntity.UserReference) then
      begin
        aElement := DataEntityToElement(aTrv.DataEntity);
        if aElement is TBoldObject then
          aList.Add(aElement as TBoldObject);
      end;
      aTrv.Next;
    end;
    BoldGUIHandler.DraggedObjects.AddList(aList);
  finally
    aTrv.Free;
    FreeAndNil(aList);
  end;
end;

function TphGant_BA.CreateGrid(theOwner: TComponent): TphGrid;
begin
  result:=TphGrid_BAIG.Create(theOwner);
end;

function TphGant_BA.GetGrid_BA: TphGrid_BA;
begin
  result:=Grid as TphGrid_BA;
end;

procedure TphGant_BA.InitializeInConstructor;
begin
  inherited;
  Grid_BA.Columns_BA[0].TextAndIconFromTreeDef:=TRUE;
end;

{ TBoldGantFollowerController }



procedure TBoldGantFollowerController.DoAfterInsertItemGantTime(
  theFollower: TBoldFollower);
begin
  if Assigned( fDoAfterAddItemGantTime ) then
    fDoAfterAddItemGantTime( theFollower );
end;

procedure TBoldGantFollowerController.DoBeforeDeleteItemGantTime(
  theFollower: TBoldFollower);
begin
  if Assigned( FDoBeforeDeleteItemGantTime ) then
    FDoBeforeDeleteItemGantTime( theFollower );
end;



function TBoldGantFollowerController.GetBoldNodeDescriptionsClass: TBoldNodeDescriptionsClass;
begin
  result:=TBoldGantNodeDescriptions;
end;


{ TBoldGantNodeDescriptions }

function TBoldGantNodeDescriptions.GetNodeDescriptionClass: TBoldNodeDescriptionClass;
begin
  result:=TBoldGantNodeDescription;
end;

{ TBoldGantNodeDescription }


constructor TBoldGantNodeDescription.Create(Collection: TCollection);
var
  aListControllerGantRow:TBoldGenericListController;
  aOwningComponent:TComponent;
  aBoldGantFollowerController:TBoldGantFollowerController;
begin
  inherited Create(Collection);

  aBoldGantFollowerController:=((Collection as TBoldGantNodeDescriptions).GetOwner as TBoldGantFollowerController);
  aOwningComponent:=aBoldGantFollowerController.OwningComponent;
  aListControllerGantRow := TBoldGenericListController.Create( aOwningComponent, (aOwningComponent as TphGant_BA).DoGetFollowerControllerForRowsByName );
  with aListControllerGantRow do
  begin
    OnAfterInsertItem := aBoldGantFollowerController.DoAfterInsertItemGantTime;
    OnBeforeDeleteItem := aBoldGantFollowerController.DoBeforeDeleteItemGantTime;
    OnGetContextType :=   GetContextType;
  end;
  NodeFollowerController.Add( aListControllerGantRow );

end;

function TBoldGantNodeDescription.GetContextType: TBoldElementTypeInfo;
var
  ContextType : TBoldElementTypeInfo;
begin
  ContextType := ((Collection as TBoldGantNodeDescriptions).GetOwner as TBoldGantFollowerController).GetContextType;
  if assigned( ContextType ) then
    result := (ContextType.SystemTypeInfo as TBoldSystemTypeInfo).ElementTypeInfoByExpressionName[ContextTypeName]
  else
    result := nil;
end;


function TBoldGantNodeDescription.GetListControllerGantRow: TBoldGenericListController;
begin
  Result := NodeFollowerController.Items[BoldNodeListIndex_GantList] as TBoldGenericListController;
end;


procedure TBoldGantNodeDescription.SetListControllerGantRow(
  const Value: TBoldGenericListController);
begin
  GetListControllerGantRow.Assign( Value );
end;


{ TBoldGantTimeDef }

procedure TBoldGantTimeDef.Assign(Source: TPersistent);
begin
  inherited;
end;

constructor TBoldGantTimeDef.Create(theCollection: TCollection);
var
  aStartDateController,aStopDateController:TBoldFloatFollowerController;
  aOwningComponent:TComponent;
begin
  inherited Create(theCollection);
  aOwningComponent:=(Collection as TBoldGantTimeDefs).GetOwner as TComponent;
  fBoldControllerList:=TBoldControllerList.Create(aOwningComponent);


  aStartDateController:=TBoldFloatFollowerController.Create(aOwningComponent);
  aStartDateController.AfterMakeUptoDate:=(Collection as TBoldGantTimeDefs).DoStartDateChanged;
  aStartDateController.OnGetContextType:=_GetContextType;
  fBoldControllerList.Add( aStartDateController );


  aStopDateController:=TBoldFloatFollowerController.Create(aOwningComponent);
  aStopDateController.AfterMakeUptoDate:=(Collection as TBoldGantTimeDefs).DoStopDateChanged;
  aStopDateController.OnGetContextType:=_GetContextType;
  fBoldControllerList.Add( aStopDateController );

end;

destructor TBoldGantTimeDef.Destroy;
begin
  FreeAndNil(fBoldControllerList);
  inherited;
end;

function TBoldGantTimeDef._GetContextType:TBoldElementTypeInfo;
var
  aGantt:TphGant_BA;
begin
  aGantt:=(Collection as TBoldGantTimeDefs).GetOwner as TphGant_BA;

  result := nil;
  if Assigned(aGantt.BoldHandle) and
    Assigned(aGantt.BoldHandle.StaticSystemTypeInfo) then
  begin
    result:=aGantt.BoldHandle.StaticSystemTypeInfo.
                    ElementTypeInfoByExpressionName[ValueTypeName];
  end;
end;

procedure TBoldGantTimeDef.SetValueTypeName(const Value: String);
begin
  if value <> fValueTypeName then
  begin
    fValueTypeName := Value;
  end;
end;

function TBoldGantTimeDef.GetDisplayName: string;
begin
  result:=inherited GetDisplayName;
  if Name<>'' then
    result:=Name;
end;

function TBoldGantTimeDef.GetStartDateController: TBoldFloatFollowerController;
begin
  result:=(fBoldControllerList.Items[0] as TBoldFloatFollowerController);
end;


function TBoldGantTimeDef.GetStopDateController: TBoldFloatFollowerController;
begin
  result:=(fBoldControllerList.Items[1] as TBoldFloatFollowerController);
end;


procedure TBoldGantTimeDef.SetStartDateController(
  const Value: TBoldFloatFollowerController);
begin
  GetStartDateController.Assign(Value);
end;

procedure TBoldGantTimeDef.SetStopDateController(
  const Value: TBoldFloatFollowerController);
begin
  GetStopDateController.Assign(Value);
end;


{ TBoldGantTimeDefs }

procedure TBoldGantTimeDefs.DoStartDateChanged(theFollower: TBoldFollower);
begin
  if Assigned( fDoStartDateChanged ) then
    fDoStartDateChanged( theFollower );
end;

procedure TBoldGantTimeDefs.DoStopDateChanged(theFollower: TBoldFollower);
begin
  if Assigned( fDoStopDateChanged ) then
    fDoStopDateChanged( theFollower );
end;

function TBoldGantTimeDefs.FindDefFromControllerList(
  theBoldControllerList: TBoldControllerList): TBoldGantTimeDef;
var
  i:integer;
begin
  result:=nil;
  for i:=0 to Count-1 do
  begin
    if (Items[i] as TBoldGantTimeDef).fBoldControllerList=theBoldControllerList then
    begin
      result:=(Items[i] as TBoldGantTimeDef);
      exit;
    end;
  end;
end;

function TBoldGantTimeDefs.GetOwner: TPersistent;
begin
  result:=fOwningComponent;
end;

{ TphGrid_BAIG }

function TphGrid_BAIG.GetFollowerIndexForColumns: Integer;
begin
  result:=BoldNodeTextIndex+2; // Put the columns after the Gant time items controller
end;

(*
$History: phGant_BA.pas $
 * 
 * *****************  Version 33  *****************
 * User: Dthk         Date: 01-10-04   Time: 13.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Gridden ns frn Gant_BA, 
 * Uppstdning
 * 
 * *****************  Version 32  *****************
 * User: Dthk         Date: 01-10-02   Time: 17.42
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Lagt in Grid i BA
 *
 * *****************  Version 31  *****************
 * User: Dthk         Date: 01-08-08   Time: 13.20
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * GetSelectedElements in the tree
 * 
 * *****************  Version 30  *****************
 * User: Dthk         Date: 00-12-11   Time: 10.26
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Frndrard signatur
 * 
 * *****************  Version 29  *****************
 * User: Dthk         Date: 00-12-04   Time: 13.34
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Flyttat generella saker till phTree_BA_Common, och implementerad
 * HideNodeWithNoChildren ven fr Gantt
 * 
 * *****************  Version 28  *****************
 * User: Hasse        Date: 00-10-13   Time: 14.26
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * StartDrag/Endrag
 * 
 * *****************  Version 27  *****************
 * User: Hasse        Date: 00-10-12   Time: 12.47
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * ndrat stavning p CollitionDetect
 * 
 * *****************  Version 26  *****************
 * User: Hasse        Date: 00-05-31   Time: 15.54
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Nu funkar OCL-editorn!!!!
 * 
 * *****************  Version 25  *****************
 * User: Hasse        Date: 00-05-19   Time: 16.07
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Registrering flyttad till phRegStuff_BA.pas
 * 
 * *****************  Version 24  *****************
 * User: Hasse        Date: 00-05-19   Time: 12.31
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * CollitionDetect
 * 
 * *****************  Version 23  *****************
 * User: Hasse        Date: 00-03-27   Time: 10.39
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Anpassade till nya events
 * 
 * *****************  Version 22  *****************
 * User: Hasse        Date: 00-03-23   Time: 13.42
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * ven om abort i SetAsFloat s hmtas vrdet om frn renderern
 * 
 * *****************  Version 21  *****************
 * User: Hasse        Date: 00-02-25   Time: 11.30
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Trdet renderas med typinformation nu
 * 
 * *****************  Version 20  *****************
 * User: Hasse        Date: 00-02-18   Time: 14.25
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Publicerat OnAlignNeed
 * 
 * *****************  Version 19  *****************
 * User: Hasse        Date: 00-02-18   Time: 13.39
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Frga eftervrden direkt efter dom r satta fr att se till att det upp
 * to date
 * 
 * *****************  Version 18  *****************
 * User: Hasse        Date: 00-02-04   Time: 9.34
 * Updated in $/Riks/Komp/PlexityHide/BA
 * FixedSize
 * DrawImage
 * 
 * *****************  Version 17  *****************
 * User: Hasse        Date: 00-01-19   Time: 11.18
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Stdat bort konverteringskommentarer
 * 
 * *****************  Version 16  *****************
 * User: Janne        Date: 00-01-12   Time: 15.49
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Upddated to Bold 2.0.4
 * 
 * *****************  Version 15  *****************
 * User: Hasse        Date: 99-12-29   Time: 14.40
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Laft till phTree_BA
 * 
 * *****************  Version 14  *****************
 * User: Hasse        Date: 99-11-19   Time: 17.50
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Nya tidsritningsoperationer
 * 
 * *****************  Version 13  *****************
 * User: Hasse        Date: 99-11-17   Time: 14.36
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Konverteringsmetoder mellan Element,follower och DataEntity.
 * Publicerade popupmenyer
 * Std fr ordnade relationer i trdet
 * 
 * *****************  Version 12  *****************
 * User: Hasse        Date: 99-11-10   Time: 16.41
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Publiserat Align
 * 
 * *****************  Version 11  *****************
 * User: Hasse        Date: 99-11-08   Time: 15.58
 * Updated in $/Riks/Komp/PlexityHide/BA
 * djsaksasd
 *
 * *****************  Version 10  *****************
 * User: Hasse        Date: 99-11-08   Time: 15.57
 * Updated in $/Riks/Komp/PlexityHide/BA
*)


end.
