unit phGrid_BA;

interface
uses
  phBabGridView,phBabGridContent,phGrid,
  Windows,Messages,SysUtils,Classes,Graphics,Controls,StdCtrls,
  BoldSystem,
  BoldSystemRT,
  BoldDefs,
  BoldElements,
  BoldAbstractListHandle,
  BoldListHandleFollower,
  BoldControlPack,
  BoldListControlPack,
  BoldControllerListControlPack,
  BoldListListControlPack,
  BoldStringControlPack,
  BoldFloatControlPack,
  BoldAFP,
  BoldGUI,
  BoldUtils,
  BoldCheckboxStateControlPack,
  BoldExpressionHandle,
  BoldComboBox,
  Typinfo,
  BoldSubscription,
  ComCtrls,
  BoldGenericListControlPack,
  BoldCursorHandle,
  BoldDerivedHandle,
  BoldElementHandleFollower,
  phGridTree,BoldNodeControlPack,BoldNumericControlPack,BoldHandles,
  phEventHandling,
  BoldControlPackDefs,
  BoldControlsDefs,
  BoldReferenceHandle;

type
  TphGrid_BA=class;
  TphGrid_BA_Columns=class;
  TphGrid_BA_Column=class;
  TphGrid_BA_SubGrids=class;
  TphGrid_BA_SubGrid=class;



  TOnUserDecideMayModify=function (aGrid:TphGrid_BA;aColumn:TphGrid_BA_Column;aBabCell:TBabCell;aCellFollower:TBoldFollower;aDefaultResult:Boolean):Boolean of object;
  TOnComboEditApplyValue=procedure (aGrid:TphGrid_BA;aColumn:TphGrid_BA_Column;aBabCell:TBabCell;aCellFollower:TBoldFollower;aValue:TBoldElement) of object;
  TOnUserBeforeEnterEdit=procedure (aGrid:TphGrid_BA;aColumn:TphGrid_BA_Column;aBabCell:TBabCell;aCellFollower:TBoldFollower) of object;
  TOnTreeRowEvent=procedure (aGrid:TphGrid_BA;theFollower:TBoldFollower;dataEntity_GridTreeNode:TphDataEntity_GridTreeNode) of object;


  TBoldControllerList_COLUMNS=class(TBoldControllerList)
  public
    destructor Destroy;override;
  end;

  TBoldFollowerController_Hidden=class(TBoldFollowerController)
  public
    procedure DoMakeUptodateAndSubscribe(Follower: TBoldFollower; Subscribe: Boolean);override;
  end;

  TphGrid_BA=class(TphGrid)
  private
    fOnUserDecideMayModify: TOnUserDecideMayModify;
    fOnComboEditApplyValue: TOnComboEditApplyValue;
    fOnUserBeforeEnterEdit: TOnUserBeforeEnterEdit;
    fOnCellContentUpdate_Before: TOnCellEvent;
    fOnCellContentUpdate_After: TOnCellEvent;
    fBoldTreeProperties: TBoldTreeFollowerController;
    fBoldTreeHandleFollower:TBoldElementHandleFollower;
    fDeletionSubscriber:TBoldPassthroughSubscriber;
    fInitLevelsInTree: Integer;
    fExpandLevelsInTree: Integer;
    fTiedUpNilIfDeleteFollower:TBoldFollower; // In odd cases the row is destroyed by a reevaluation before we have called _AfterMakeCellUptoDate
    fCurrentlyExpandningTreeNode:TphDataEntity_GridTreeNode;
    fCurrentlyRenderingCell: TBabCell;
    fCurrentlyRenderingTreeNode: TphDataEntity_GridTreeNode;
    fSelectNewObject: Boolean;
    fLatestSeenFollower:TBoldFollower;
    fSelectNewObject_FirstInBatch: Boolean;
    fOnNewTreeRow: TOnTreeRowEvent;
    fInternalReferenceHandle:TBoldReferenceHandle;

    function GetHandleStaticType: TBoldElementTypeInfo;
    function GetBoldHandle: TBoldAbstractListHandle;
    procedure SetBoldHandle(const Value: TBoldAbstractListHandle);
    procedure DoOnInternalSelectionChanged(theEventListener:TSingleEventListener);
    procedure SetController(
      const Value: TBoldListAsFollowerListController);
    //function _OnSortCompare(Item1, Item2: TBoldElement): Integer;
    function CellFollowerToColumn(
      theCellFollower: TBoldFollower): TphGrid_BA_Column;
    function TieCellAndFollower(theFollower: TBoldFollower): TBabCell;
    procedure ReDistributeAllFollowers;
    procedure OnDeriveAndSubscribeMainGridList(Sender: TComponent;
      RootValue: TBoldElement; ResultElement: TBoldIndirectElement;
      Subscriber: TBoldSubscriber);
    procedure ReselectIfOnlyMoved(theObject: TObject);
   procedure RemovedSelectedElements_Clear;
    //function CompareList(aBoldList1, aBoldList2: TBoldList): Boolean;
    function CopyListType(aBoldList: TBoldList): TBoldList;
    procedure SetLastKnownOrgList(aBoldList: TBoldList);
    procedure SetLastKnownSortedList(aBoldList: TBoldList);
    //procedure SortList(aBoldList: TBoldList);
    procedure SelectionChanged(Data: TObject);
    function GetGrid_BA_Columns: TphGrid_BA_Columns;
    function ColToColBA(theCol: TphGrid_Column): TphGrid_BA_Column;
    function GetSubGrids_BA: TphGrid_BA_SubGrids;
    procedure SetBoldTreeProperties(
      const Value: TBoldTreeFollowerController);
    function GetBoldTreeElementHandle: TBoldElementHandle;
    procedure SetBoldTreeElementHandle(const Value: TBoldElementHandle);
    procedure _InsertTreeRow_Common(theFollower: TBoldFollower;
      theGridCell: TBabGridCell;theColumnsProps:TBoldControllerList);
    function Internal_ParentNodeFromUninitiatedFollower(
      theFollower: TBoldFollower): TphDataEntity_GridTreeNode;
    procedure OnNodeControllerDeletion(Originator: TObject;
      OriginalEvent: TBoldEvent; RequestedEvent: TBoldRequestedEvent);
    procedure CleanNodeFollowerControllerFromColumnRefs(
      nodeFollowerController: TBoldNodeFollowerController);
    procedure TreeRowManipulation(
      aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode;
      aInitLevelsInTree, aExpandLevelsInTree: Integer);
    procedure NodeHiding(
      aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode);
    procedure SelectLatestCreated_Async(sender: TObject);
    procedure DoAutoSelection(theFollower: TBoldFollower);
    procedure OnCellDeInit(theCell: TBabCell);
    function GetHandleStaticType_Tree: TBoldElementTypeInfo;
    procedure UpdateTreeColumnText(
      aNode: TphDataEntity_GridTreeNode;aText:String);
    procedure UpdateTextInTextCell(aCell: TBabCell; aText: String);
    procedure InitializeRenderingCell(theFollower: TBoldFollower);
    procedure _ExpandStateRestore_Async(aObject: TObject);
    procedure SaveSelectState_OnDelete(theFollower: TBoldFollower);
  protected
    fLastDeriveListCount:Integer;
    fCursorHandle:TBoldCursorHandle;
    fDerivedHandle:TBoldDerivedHandle;

    fBoldColumnsProperties:TBoldControllerList_COLUMNS;
    fBoldProperties:TBoldListAsFollowerListController;
    fHandleFollower:TBoldListHandleFollower;

    fInCommingHandle:TBoldAbstractListHandle;
    fRemovedSelectedElements:TList;
    fLastKnownOrgList:TBoldList;
    fLastKnownSortedList:TBoldList;

    procedure TreeDefinitionTextOrIconChanged(Follower: TBoldFollower);
    procedure CleanTreePropsFromColumnRefs(
      treeController: TBoldTreeFollowerController);
    function GetFollowerIndexForColumns: Integer;virtual;
    procedure DestroyColumns;override;
    function CreateColumnsCollection: TphGrid_Columns;override;
    function CreateSubGridsCollection: TphGrid_SubGrids;override;
    procedure SetHasHeaders(const Value: Boolean);override;
    procedure SetHasInfoCol(const Value: Boolean);override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;



    procedure _InsertRow(theFollower:TBoldFollower);
    procedure _DeleteRow(theFollower:TBoldFollower);

    procedure _InsertRowSubGrid(theFollower:TBoldFollower);
    procedure _DeleteRowSubGrid(theFollower:TBoldFollower);

    procedure _InsertCell(theFollower:TBoldFollower);
    procedure _DeleteCell(theFollower:TBoldFollower);


    procedure _DeleteTreeRow(theFollower: TBoldFollower);
    procedure _InsertTreeRow(theFollower: TBoldFollower);
    procedure _DeleteTreeRowSubGrid(theFollower: TBoldFollower);
    procedure _InsertTreeRowSubGrid(theFollower: TBoldFollower);
    procedure _InitTreeSubDataList(aGridTree: TphGridTree;
      aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode);override;

    procedure _BeforeMakeUptoDateTree(aBoldFollower: TBoldFollower);



    procedure _AfterMakeCellUptoDate(theFollower:TBoldFollower);
    procedure _BeforeMakeCellUptoDate(theFollower:TBoldFollower);



    procedure PreDrawGetStringAndSetAttributes(theBabCell:TBabCell;var theString:String;var theBoolean:Boolean;var theIsStringEdit:Boolean);override;
    procedure DeInitEditor(theComponent:TComponent;thebabCell:TBabSimpleCell;theText:String;theEscaped:Boolean);override;
    procedure DoOnEditStop(theBabGridView:TBabGridView_Custom;theEditComponent:TComponent;theBabSimpleCellStringData:TBabSimpleCellStringData;var theText:String);
    function  EditorCanModify(theBabCell:TBabCell):boolean;override;
    function  InitEditor(theComponent:TComponent;thebabCell:TBabSimpleCell):String;override;
    procedure FocusChanged(theNewFoucusedCell: TBabCell);override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure DoEndDrag(Target: TObject; X, Y: Integer); override;
    procedure DoStartDrag(var DragObject: TDragObject); override;
    procedure DoSortCell(theBabCell: TBabCell;theUpNotDown:Boolean);override;



    function  CellIconIndex(theBabCell: TBabCell): Integer;override;


    //Tree
    function  IsButtonTerminal(theBabCell: TBabCell): Boolean;override;



  public

    constructor Create(Owner:TComponent);override;
    destructor  Destroy;override;

    //Conversion
    function CellToElement(theBabCell:TBabCell):TBoldElement;
    function CellToRowFollower(theBabCell:TBabCell):TBoldFollower;
    function CellToCellFollower(theBabCell: TBabCell): TBoldFollower;
    function AxisContentItemToRowFollower(theAxisContentItem: TAxisContentItem):TBoldFollower ;

    function CellFollowerToCell(theFollower: TBoldFollower): TBabCell;
    function CellFollowerToGridCell(theFollower: TBoldFollower): TBabGridCell;
    function CellFollowerToAxisContentItem(theFollower: TBoldFollower): TAxisContentItem;
    function CellFollowerToRowFollower(theFollower: TBoldFollower):TBoldFollower;
    function RowFollowerToAxisContentItem(theFollower: TBoldFollower): TAxisContentItem;


    function  GetFirstSelectedObject : TBoldObject;
    function  GetSelectedObjectsCount : integer;
    procedure GetSelectedObjects( theResultBOL : TBoldObjectList );
    procedure GetAllObjects(theResultBOL: TBoldObjectList);

    property Columns_BA:TphGrid_BA_Columns read GetGrid_BA_Columns;
    property SubGrids_BA:TphGrid_BA_SubGrids read GetSubGrids_BA;

    // Property is needed by user when rendering tree lists that depend on parents
    property  CurrentlyExpandningTreeNode:TphDataEntity_GridTreeNode read fCurrentlyExpandningTreeNode;
    property  CurrentlyRenderingTreeNode:TphDataEntity_GridTreeNode read fCurrentlyRenderingTreeNode;
    property  CurrentlyRenderingCell:TBabCell read fCurrentlyRenderingCell;

  published
    property BoldHandle:TBoldAbstractListHandle read GetBoldHandle write SetBoldHandle;

    property BoldProperties: TBoldListAsFollowerListController read fBoldProperties write SetController;

    // Tree behavior
    property BoldTreeProperties: TBoldTreeFollowerController read fBoldTreeProperties write SetBoldTreeProperties;
    property BoldTreeElementHandle: TBoldElementHandle read GetBoldTreeElementHandle write SetBoldTreeElementHandle;
    property InitLevelsInTree:Integer read fInitLevelsInTree write fInitLevelsInTree;
    property ExpandLevelsInTree:Integer read fExpandLevelsInTree write fExpandLevelsInTree;
    property SelectNewObject:Boolean read fSelectNewObject write fSelectNewObject;
    property SelectNewObject_FirstInBatch:Boolean read fSelectNewObject_FirstInBatch write fSelectNewObject_FirstInBatch;

    property OnUserDecideMayModify:TOnUserDecideMayModify read fOnUserDecideMayModify write fOnUserDecideMayModify;
    property OnComboEditApplyValue:TOnComboEditApplyValue read fOnComboEditApplyValue write fOnComboEditApplyValue;
    property OnUserBeforeEnterEdit:TOnUserBeforeEnterEdit read fOnUserBeforeEnterEdit write fOnUserBeforeEnterEdit;
    property OnSelectionChanged;


    property    OnCellContentUpdate_Before:TOnCellEvent read fOnCellContentUpdate_Before write fOnCellContentUpdate_Before;
    property    OnCellContentUpdate_After:TOnCellEvent read fOnCellContentUpdate_After write fOnCellContentUpdate_After;
    property    OnNewTreeRow:TOnTreeRowEvent read fOnNewTreeRow write fOnNewTreeRow;
  end;





  TphGrid_BA_Columns=class(TphGrid_Columns)
  private
    function GetColumn(index: integer): TphGrid_BA_Column;
  protected
  public
    property Columns_BA[index:integer]:TphGrid_BA_Column read GetColumn;default;
  end;

  TphGrid_BA_Column=class(TphGrid_Column)
  private
    fTextAndIconFromTreeDef: Boolean;
    fUseRenderFontNotLayout: Boolean;
    procedure SetBoldProperties_Boolean(
      const Value: TBoldCheckBoxStateFollowerController);
    procedure SetBoldProperties_Text(
      const Value: TBoldStringFollowerController);
    procedure SetBoldProperties_Float(
      const Value: TBoldFloatFollowerController);
    procedure SetBoldComboBox(const Value: TBoldComboBox);
    function GetColumnProperties:TBoldControllerList;
    procedure SetBoldProperties_List(
      const Value: TBoldGenericListController);
    function GetCorrectControllerForSubGrid(
      Name: string): TBoldFollowerController;
    function GetListExpression: TBoldExpression;
    procedure SetListExpression(const Value: TBoldExpression);
    function GetOnGetList: TGetElementEvent;
    procedure SetOnGetList(const Value: TGetElementEvent);
    function GetGrid_BA: TphGrid_BA;
    procedure SetBoldProperties_SubTree(
      const Value: TBoldTreeFollowerController);
  protected
    fBoldProperties_Text: TBoldStringFollowerController;
    fBoldProperties_Boolean: TBoldCheckBoxStateFollowerController;
    fBoldProperties_Float: TBoldFloatFollowerController;

    fBoldProperties_List: TBoldGenericListController;
    fBoldProperties_SubTree: TBoldTreeFollowerController;
    fBoldProperties_Hidden:TBoldFollowerController_Hidden;


    fBoldComboBox:TBoldComboBox;

    procedure SetKind(const Value: TColumnKind);override;
    function GetDisplayName: string; override;
    property BoldProp_ListForSubGrid:TBoldGenericListController read fBoldProperties_List write SetBoldProperties_List;
    procedure SetIndex(Value: Integer); override;
    procedure SetHidden(const Value: Boolean);override;
  public
    constructor Create(theCollection:TCollection);override;
    destructor  Destroy;override;
    procedure Assign(source:TPersistent);override;
    property Grid_BA:TphGrid_BA read GetGrid_BA;
  published
    property BoldProp_Text: TBoldStringFollowerController read fBoldProperties_Text write SetBoldProperties_Text;
    property BoldProp_Boolean: TBoldCheckBoxStateFollowerController read fBoldProperties_Boolean write SetBoldProperties_Boolean;
    property BoldProp_Float: TBoldFloatFollowerController read fBoldProperties_Float write SetBoldProperties_Float;
    property BoldCombo:TBoldComboBox read fBoldComboBox write SetBoldComboBox;
    property SubGridListExpression:TBoldExpression read GetListExpression write SetListExpression;
    property OnGetSubGridList: TGetElementEvent read GetOnGetList write SetOnGetList;
    property BoldProp_SubTree: TBoldTreeFollowerController read fBoldProperties_SubTree write SetBoldProperties_SubTree;
    property TextAndIconFromTreeDef:Boolean read fTextAndIconFromTreeDef write fTextAndIconFromTreeDef default FALSE;
    property UseRenderFontNotLayout:Boolean read fUseRenderFontNotLayout write fUseRenderFontNotLayout default FALSE;
  end;


  TphGrid_BA_SubGrids=class(TphGrid_SubGrids)
  private
    function GetSubGrid_BA(index: integer): TphGrid_BA_SubGrid;
  protected
  public
    property SubGrids_BA[index:integer]:TphGrid_BA_SubGrid read GetSubGrid_BA;default;
  end;

  TphGrid_BA_SubGrid=class(TphGrid_SubGrid)
  private
    fBoldColumnsProperties:TBoldControllerList_COLUMNS;
    fInitLevelsInTree: Integer;
    fExpandLevelsInTree: Integer;
  protected
    procedure DestroyColumns;override;
  public
    constructor Create(theCollection:TCollection);override;
    destructor  Destroy;override;
    procedure Assign(source:TPersistent);override;
  published
    property InitLevelsInTree:Integer read fInitLevelsInTree write fInitLevelsInTree;
    property ExpandLevelsInTree:Integer read fExpandLevelsInTree write fExpandLevelsInTree;
  end;




implementation

uses
  BoldAttributes,
  phDoLater;

type
  TSelectstate=class
    Element:TBoldElement;
    ColIndex:Integer;
  end;

{ TphGrid_BA }


constructor TphGrid_BA.Create(Owner: TComponent);
begin
  inherited;




  fBoldColumnsProperties := TBoldControllerList_COLUMNS.Create(Self);
  fBoldColumnsProperties.OnAfterInsertItem:=_InsertCell;
  fBoldColumnsProperties.OnBeforeDeleteItem:=_DeleteCell;
  fBoldProperties := TBoldListAsFollowerListController.Create(self, fBoldColumnsProperties );
  fBoldProperties.OnAfterInsertItem := _InsertRow;
  fBoldProperties.OnBeforeDeleteItem := _DeleteRow;
  fBoldProperties.OnGetContextType := GetHandleStaticType;
  fHandleFollower:=TBoldListHandleFollower.Create(Owner,fBoldProperties);
  fCursorHandle:=TBoldCursorHandle.Create(nil);
  fDerivedHandle:=TBoldDerivedHandle.Create(nil);
  fDerivedHandle.OnDeriveAndSubscribe:=OnDeriveAndSubscribeMainGridList;
  fCursorHandle.RootHandle:=fDerivedHandle;
  fHandleFollower.BoldHandle:=fCursorHandle;

  // Tree behavior
  fBoldTreeProperties:=TBoldTreeFollowerController.Create(self);
  fBoldTreeProperties.OnAfterInsertItem:=_InsertTreeRow;
  fBoldTreeProperties.OnBeforeDeleteItem:=_DeleteTreeRow;
  fBoldTreeProperties.BeforeMakeUptoDate := _BeforeMakeUptoDateTree;
  fBoldTreeProperties.OnGetContextType:=GetHandleStaticType_Tree;
  fBoldTreeProperties.OnTextChanged:=TreeDefinitionTextOrIconChanged;
  fBoldTreeProperties.OnIconChanged:=TreeDefinitionTextOrIconChanged;

  fBoldTreeHandleFollower:=TBoldElementHandleFollower.Create(self,fBoldTreeProperties);
  fDeletionSubscriber:=TBoldPassthroughSubscriber.Create(OnNodeControllerDeletion);

  BabGridCellForViewer.OnCellDeInit:=OnCellDeInit;


  OnEditStop:=DoOnEditStop;
  TSingleEventListener.Create(BabGridCellForViewer.SelectionChangeEvent,DoOnInternalSelectionChanged,TRUE);

  fRemovedSelectedElements:=TList.Create;
  fInternalReferenceHandle:=TBoldReferenceHandle.Create(nil);

end;


procedure TphGrid_BA.OnCellDeInit(theCell:TBabCell);
begin
  if Assigned(theCell) then
  begin
    if theCell.BabCellData.UserReference is TBoldFollower then
    begin
      (theCell.BabCellData.UserReference as TBoldFollower).ControlData:=nil;
      theCell.BabCellData.UserReference:=nil;
    end;
  end
end;

procedure TphGrid_BA.CleanTreePropsFromColumnRefs(treeController:TBoldTreeFollowerController);
var
  i:integer;
begin
  // Remove Columns from tree definition, we control destruction our selfs
  for i:=treeController.NodeDescriptions.Count-1 downto 0 do
  begin
    CleanNodeFollowerControllerFromColumnRefs(treeController.NodeDescriptions[i].NodeFollowerController);
  end;
end;

procedure TphGrid_BA.CleanNodeFollowerControllerFromColumnRefs(nodeFollowerController:TBoldNodeFollowerController);
var
  i:integer;
begin
  // Remove Columns from tree definition, we control destruction our selfs
  for i:=nodeFollowerController.Count-1 downto 0 do
  begin
    if nodeFollowerController.Items[i] is TBoldControllerList_COLUMNS then
    begin
      nodeFollowerController.Remove(nodeFollowerController.Items[i]);
    end;
  end;
end;

procedure TphGrid_BA.DestroyColumns;
begin
  CleanTreePropsFromColumnRefs(BoldTreeProperties);

  inherited DestroyColumns;


  FreeAndNil(fBoldColumnsProperties);
  FreeAndNil(fBoldProperties);

  FreeAndNil(fHandleFollower);

  FreeAndNil(fBoldTreeProperties);
  FreeAndNil(fBoldTreeHandleFollower);
end;

destructor TphGrid_BA.Destroy;
begin
  Destroying;


  FreeAndNil(fCursorHandle);
  FreeAndNil(fDerivedHandle);



  if Assigned(fLastKnownOrgList) then
    FreeAndNil(fLastKnownOrgList);
  if Assigned(fLastKnownSortedList) then
    FreeAndNil(fLastKnownSortedList);




  RemovedSelectedElements_Clear;
  FreeAndNil(fRemovedSelectedElements);
  TDoLater.NeverMind(ReselectIfOnlyMoved);
  TDoLater.NeverMind(SelectionChanged);
  TDoLater.NeverMind(_ExpandStateRestore_Async);
  FreeAndNil(fDeletionSubscriber);
  TDoLater.NeverMind(SelectLatestCreated_Async);
  FreeAndNil(fInternalReferenceHandle);

  inherited;
end;



procedure TphGrid_BA.OnDeriveAndSubscribeMainGridList(Sender: TComponent;
  RootValue: TBoldElement; ResultElement: TBoldIndirectElement; Subscriber: TBoldSubscriber);
var
  boldList,orgList:TBoldList;
  //listEqual:Boolean;
begin
  boldList:=nil;
  orgList:=nil;

  if Assigned(fInCommingHandle) then
  begin
    orgList:=fInCommingHandle.List;
    if Assigned(orgList) and
    Assigned(orgList.BoldType) then
    begin
      (*listEqual:=CompareList(orgList,fLastKnownOrgList);

      if not listEqual then
      begin
        //Dont sort when we add new rows
        fSortingColumn:=nil;
        fCurrentSortCol:=nil;
      end;*)

      boldList:=CopyListType(orgList);
      boldList.AddList(orgList);

(*      if listEqual and
        Assigned(fLastKnownSortedList) then
      begin
        // If they are equal, then we reuse the lastone
        boldList.AddList(fLastKnownSortedList);
      end
      else
      begin
        boldList.AddList(orgList);
        //SortList(boldList);
      end;*)

      orgList.AddSubscription(Subscriber,beItemAdded,breReEvaluate);
      orgList.AddSubscription(Subscriber,beItemDeleted,breReEvaluate);

      SetLastKnownOrgList(orgList);
      SetLastKnownSortedList(boldList);
    end;
  end;


  ResultElement.SetOwnedValue(boldList);
  fLastDeriveListCount:=0;

  if Assigned(orgList) then
    fLastDeriveListCount:=orgList.Count;
end;




function TphGrid_BA.CopyListType(aBoldList:TBoldList):TBoldList;
begin
  result:=TBoldMemberFactory.CreateMemberFromBoldType( aBoldList.BoldType ) as TBoldList;
  if result is TBoldMemberList then
  begin
    (result as TBoldMemberList).CloneMembers:=FALSE;
  end;
end;



procedure TphGrid_BA.SetLastKnownOrgList(aBoldList:TBoldList);
begin
  if Assigned(fLastKnownOrgList) then
    FreeAndNil(fLastKnownOrgList);
  if Assigned(aBoldList) then
  begin
    fLastKnownOrgList:=CopyListType(aBoldList);
    fLastKnownOrgList.AddList(aBoldList);
  end;
end;

procedure TphGrid_BA.SetLastKnownSortedList(aBoldList:TBoldList);
begin
  if Assigned(fLastKnownSortedList) then
    FreeAndNil(fLastKnownSortedList);
  if Assigned(aBoldList) then
  begin
    fLastKnownSortedList:=CopyListType(aBoldList);
    fLastKnownSortedList.AddList(aBoldList);
  end;
end;



procedure TphGrid_BA.DoOnInternalSelectionChanged(theEventListener:TSingleEventListener);
var
  aRowFollower:TBoldFollower;
begin
  aRowFollower:=CellToRowFollower(theEventListener.CallingMessage as TBabCell);
  if Assigned(aRowFollower)  then
  begin
    aRowFollower.Selected:=(theEventListener.CallingMessage as TBabCell).Selected;
    fInternalReferenceHandle.Value:=aRowFollower.Element;
  end;
  TDoLater.DoLater( SelectionChanged, nil );
end;

procedure TphGrid_BA.SelectionChanged( Data : TObject );
begin
  if Assigned(OnSelectionChanged) then
    OnSelectionChanged(self);
end;

function TphGrid_BA.GetBoldHandle: TBoldAbstractListHandle;
begin
  result:=fInCommingHandle;
end;

function TphGrid_BA.GetHandleStaticType: TBoldElementTypeInfo;
begin
  if assigned( BoldHandle ) then
  begin
    if assigned( BoldHandle.StaticBoldType ) then
      result := BoldHandle.StaticBoldType
    else
      result := BoldHandle.StaticSystemTypeInfo
  end
  else
    result := nil;
end;

function TphGrid_BA.GetHandleStaticType_Tree: TBoldElementTypeInfo;
begin
  if assigned( BoldTreeElementHandle ) then
  begin
    if assigned( BoldTreeElementHandle.StaticBoldType ) then
      result := BoldTreeElementHandle.StaticBoldType
    else
      result := BoldTreeElementHandle.StaticSystemTypeInfo
  end
  else
    result := nil;
end;




procedure TphGrid_BA.SetBoldHandle(const Value: TBoldAbstractListHandle);
var
  i:integer;
begin
  if Editing then
    StopEditing;

  if Assigned(fBoldTreeHandleFollower.BoldHandle) and
      Assigned(Value) then
    raise Exception.Create('Ethier the boldhandle or the tree element handle, not both! ('+Name+')');

  fInCommingHandle:=Value;
  fDerivedHandle.RootHandle:=fInCommingHandle;

  for i:=0 to Columns.Count-1 do
  begin
    if Assigned(Columns_BA[i].BoldCombo) then
    begin
      // Valuereference same as the row we edit
      if (Columns_BA[i].BoldCombo.BoldHandle is TBoldExpressionHandle) then
        (Columns_BA[i].BoldCombo.BoldHandle as TBoldExpressionHandle).RootHandle:=BoldHandle;
    end;
  end;

end;

//TREE

function TphGrid_BA.IsButtonTerminal(theBabCell: TBabCell): Boolean;
begin
  if CellToNode(theBabCell)<>nil then
  begin
    result:=(TBoldFollower(CellToNode(theBabCell).UserReference).
      SubFollowers[BoldNodeListIndex].Controller as TBoldGenericListController).Parts.Count=0;
  end
  else
  begin
    result:=inherited IsButtonTerminal(theBabCell);
  end;
end;

function TphGrid_BA.GetFollowerIndexForColumns: Integer;
begin
  result:=BoldNodeTextIndex+1; // Put the columns after the Text controller
end;

procedure TphGrid_BA._InitTreeSubDataList(aGridTree: TphGridTree;
  aDataEntity_GridTreeNode: TphDataEntity_GridTreeNode);
var
  aFollower:TBoldFollower;
begin
  aFollower:=TBoldFollower(aDataEntity_GridTreeNode.UserReference);
  if not aDataEntity_GridTreeNode.SubDataListInitiated  then
  begin
    if (aFollower.OwningFollower.Controller as TBoldGenericListController).CanHaveSubFollowers then
    begin
      (aFollower.Controller as TBoldNodeFollowerController).SetActiveRange( aFollower, BoldNodeListIndex, GetFollowerIndexForColumns);
      aFollower.EnsureDisplayable;
    end;
  end;

  inherited;
end;




function TphGrid_BA.Internal_ParentNodeFromUninitiatedFollower(theFollower: TBoldFollower):TphDataEntity_GridTreeNode;
begin
  result:=nil;
  if Assigned( theFollower.owningFollower.owningFollower ) and
    (theFollower.owningFollower.owningFollower.ControlData is TphDataEntity_GridTreeNode) then
  begin
    result:=theFollower.OwningFollower.OwningFollower.ControlData as TphDataEntity_GridTreeNode;
  end;
end;

procedure TphGrid_BA._InsertTreeRow_Common(theFollower: TBoldFollower;theGridCell:TBabGridCell;
                                  theColumnsProps:TBoldControllerList);
var
  aParentNode:TphDataEntity_GridTreeNode;
begin
  aParentNode:=Internal_ParentNodeFromUninitiatedFollower(theFollower);

  SetUseTreeInSubGrid(theGridCell,TRUE);
  theFollower.ControlData:=GetTreeInSubGrid(theGridCell).InsertDataEntity(aParentNode,theFollower.index);
  (theFollower.ControlData as TphDataEntity_GridTreeNode).UserReference:=theFollower;
  (theFollower.Controller as TBoldNodeFollowerController).SetActiveRange( theFollower, BoldNodeIconIndex, BoldNodeTextIndex );
  (theFollower.ControlData as TphDataEntity_GridTreeNode).AxisContentItem.Value:=theFollower;

  //Check to see if the columns has been added to this controller
  if (theFollower.Controller as TBoldNodeFollowerController).Count=GetFollowerIndexForColumns then
  begin
    // if not add columns
    (theFollower.Controller as TBoldNodeFollowerController).Add(theColumnsProps);
    (theFollower.Controller as TBoldNodeFollowerController).AddSubscription(fDeletionSubscriber,beDestroying,beDestroying);
  end;
  (theFollower.Controller as TBoldNodeFollowerController).SetActiveRange( theFollower, BoldNodeIconIndex, GetFollowerIndexForColumns);

  theFollower.EnsureDisplayable;

end;

procedure TphGrid_BA.OnNodeControllerDeletion (Originator: TObject; OriginalEvent: TBoldEvent;
    RequestedEvent: TBoldRequestedEvent);

  procedure RemoveTreeRowRecursivly(node:TphDataEntity_GridTreeNode);
  var
    i:integer;
    boldfollower:TBoldFollower;
  begin
    for i:=node.SubDataListCount-1 downto 0 do
    begin
      RemoveTreeRowRecursivly(node.SubDataList[i] as TphDataEntity_GridTreeNode);
    end;
    boldfollower:=AxisContentItemToRowFollower(node.AxisContentItem);
    if Assigned(boldfollower) then
      _DeleteTreeRow(boldfollower);

  end;

var
  i:integer;
  boldfollower:TBoldFollower;
begin
  if (RequestedEvent=beDestroying) and
    (Originator is TBoldNodeFollowerController) then
  begin
    CleanNodeFollowerControllerFromColumnRefs(Originator as TBoldNodeFollowerController);
    //Drop all rows that are still alive and had this controller... (And all
    // followers that has nil as a controller, DROPDROPDROP)



    for i:=BabGridCellForViewer.AxisContentListY.Count-1 downto 0 do
    begin
      boldfollower:=AxisContentItemToRowFollower(BabGridCellForViewer.AxisContentListY.Items[i]);
      if Assigned(boldfollower) then
      begin
        if (boldfollower.Controller=Originator) or
          (boldfollower.Controller=nil) then
        begin
          if boldfollower.ControlData is TphDataEntity_GridTreeNode then
          begin
            RemoveTreeRowRecursivly(boldfollower.ControlData as TphDataEntity_GridTreeNode);
          end;
        end;
      end;
    end;

  end;
end;

procedure TphGrid_BA.TreeRowManipulation(aDataEntity_GridTreeNode:TphDataEntity_GridTreeNode;
                                          aInitLevelsInTree,aExpandLevelsInTree:Integer);
var
  orgVal:Boolean;
begin
  if aInitLevelsInTree>aDataEntity_GridTreeNode.Level then
  begin
    orgVal:=aDataEntity_GridTreeNode.Expanded;
    aDataEntity_GridTreeNode.Expanded:=TRUE;
    aDataEntity_GridTreeNode.Expanded:=orgVal;
  end;

  if aExpandLevelsInTree>aDataEntity_GridTreeNode.Level then
  begin
    aDataEntity_GridTreeNode.Expanded:=TRUE;
  end;
end;

procedure TphGrid_BA.NodeHiding(aDataEntity_GridTreeNode:TphDataEntity_GridTreeNode);
var
  fl:TBoldFollower;
  orgVal:Boolean;
begin
  fl:=AxisContentItemToRowFollower(aDataEntity_GridTreeNode.AxisContentItem);
  if (fl.Controller as TBoldNodeFollowerController).HideNodeWithNoChildren then
  begin
    orgVal:=aDataEntity_GridTreeNode.Expanded;
    aDataEntity_GridTreeNode.Expanded:=TRUE;
    aDataEntity_GridTreeNode.HideNode:=aDataEntity_GridTreeNode.SubDataListCount=0;
    aDataEntity_GridTreeNode.Expanded:=orgVal;
  end;
  if aDataEntity_GridTreeNode.ParentNode<>nil then
    NodeHiding(aDataEntity_GridTreeNode.ParentNode);
end;

procedure TphGrid_BA._InsertTreeRow(theFollower: TBoldFollower);
var
  dataEntity_GridTreeNode:TphDataEntity_GridTreeNode;
begin
  if fNeedEnsureFixed then
    EnsureFixed;
  _InsertTreeRow_Common(theFollower,BabGridCellForViewer,fBoldColumnsProperties);

  dataEntity_GridTreeNode:=AxisContentItemToGridTreeNode(RowFollowerToAxisContentItem(theFollower));
  TreeRowManipulation(dataEntity_GridTreeNode,InitLevelsInTree,ExpandLevelsInTree);

  NodeHiding(dataEntity_GridTreeNode);
  DoAutoSelection(theFollower);
  if Assigned(OnNewTreeRow) then
    OnNewTreeRow(self,theFollower,dataEntity_GridTreeNode);
end;

procedure TphGrid_BA.DoAutoSelection(theFollower: TBoldFollower);
begin
  if SelectNewObject and not SelectNewObject_FirstInBatch then
  begin
    fLatestSeenFollower:=theFollower;
    TDoLater.DoLater(SelectLatestCreated_Async,nil);
  end;
  if SelectNewObject_FirstInBatch and
    not Assigned(fLatestSeenFollower) then
  begin
    fLatestSeenFollower:=theFollower;
    TDoLater.DoLater(SelectLatestCreated_Async,nil);
  end;
end;

procedure TphGrid_BA._DeleteTreeRow(theFollower: TBoldFollower);
var
  p:TphDataEntity_GridTreeNode;
begin
  if theFollower.ControlData is TphDataEntity_GridTreeNode then
  begin
    if theFollower.Selected then
      SaveSelectState_OnDelete(theFollower.Subfollowers[GetFollowerIndexForColumns]);
    p:=(theFollower.ControlData as TphDataEntity_GridTreeNode).ParentNode;
    GetTree.RemoveDataEntity(theFollower.ControlData as TphDataEntity_GridTreeNode);
    if Assigned(p) then
      NodeHiding(p);
    theFollower.ControlData:=nil;
  end;
end;


procedure TphGrid_BA._InsertTreeRowSubGrid(theFollower: TBoldFollower);
var
  column:TphGrid_BA_Column;
  aGridCell:TBabGridcell;
  aParentNode,dataEntity_GridTreeNode:TphDataEntity_GridTreeNode;
  aSubGrid:TphGrid_SubGrid;
begin
  aParentNode:=Internal_ParentNodeFromUninitiatedFollower(theFollower);
  if Assigned(aParentNode) then
    aGridCell:=aParentNode.GridTree.GridCell
  else
  begin
    aGridCell:=(theFollower.OwningFollower.ControlData as TBabGridcell);
    if theFollower.OwningFollower.SubFollowerCount=1 then
    begin
      InitSubGrid(aGridCell);
    end;
  end;

  column:=CellFollowerToColumn(CellToCellFollower(aGridCell));
  _InsertTreeRow_Common(theFollower,aGridCell,column.GetCorrectControllerForSubGrid('') as TBoldControllerList);

  aSubGrid:=ColumnToSubGrid(column);
  if Assigned(aSubGrid) then
  begin
    dataEntity_GridTreeNode:=AxisContentItemToGridTreeNode(RowFollowerToAxisContentItem(theFollower));
    TreeRowManipulation(dataEntity_GridTreeNode,(aSubGrid as TphGrid_BA_SubGrid).InitLevelsInTree,
      (aSubGrid as TphGrid_BA_SubGrid).ExpandLevelsInTree);

    NodeHiding(dataEntity_GridTreeNode);

  end;
end;

procedure TphGrid_BA._DeleteTreeRowSubGrid(theFollower: TBoldFollower);
var
  p:TphDataEntity_GridTreeNode;
begin
  if theFollower.ControlData is TphDataEntity_GridTreeNode then
  begin
    p:=(theFollower.ControlData as TphDataEntity_GridTreeNode).ParentNode;
    (theFollower.ControlData as TphDataEntity_GridTreeNode).GridTree.RemoveDataEntity(
                    theFollower.ControlData as TphDataEntity_GridTreeNode);
    if Assigned(p) then
      NodeHiding(p);
  end;
end;


procedure TphGrid_BA._InsertRow(theFollower: TBoldFollower);
begin
  if fNeedEnsureFixed then
    EnsureFixed;

  theFollower.ControlData:=BabGridCellForViewer.AxisContentListY.InsertNew(theFollower.Index+BabGridCellForViewer.FixedRows,theFollower);

  DoAutoSelection(theFollower);

end;

procedure TphGrid_BA.TreeDefinitionTextOrIconChanged(Follower: TBoldFollower);
begin
  if Follower.OwningFollower.ControlData is TphDataEntity_GridTreeNode then
  begin
    with (Follower.OwningFollower.ControlData as TphDataEntity_GridTreeNode) do
    begin
      if (Follower.Controller is TBoldIntegerFollowerController) then
      begin
        ImageIndex:=(Follower.Controller as TBoldIntegerFollowerController).GetCurrentAsInteger( Follower );
        SelectedIndex:=ImageIndex;
      end
      else
      begin
        CanEdit:=(Follower.Controller as TBoldStringFollowerController).MayModify(Follower);
        UpdateTreeColumnText(Follower.OwningFollower.ControlData as TphDataEntity_GridTreeNode,
          (Follower.Controller as TBoldStringFollowerController).GetCurrentAsString( Follower ));
      end;
    end;
  end;

end;


procedure TphGrid_BA.UpdateTreeColumnText(aNode:TphDataEntity_GridTreeNode;aText:String);
var
  i,x,y:integer;
  column:TphGrid_Column;
  babCell:TBabCell;
begin
  column:=nil;

  if aNode.GridTree.GridCell.AxisContentListX.Count>0 then
    column:=AxisContentItemToColumn(aNode.GridTree.GridCell.AxisContentListX.Items[0]);

  if (not Assigned(column)) and
      (aNode.GridTree.GridCell.AxisContentListX.Count>1) then
      column:=AxisContentItemToColumn(aNode.GridTree.GridCell.AxisContentListX.Items[1]);

  if Assigned(column) then
  begin
    for i:=0 to column.Collection.Count-1 do
    begin
      if (column.Collection.Items[i] as TphGrid_BA_Column).TextAndIconFromTreeDef then
      begin
        y:=aNode.AxisContentItem.ListIndex;
        x:=i+aNode.GridTree.GridCell.FixedCols;
        babCell:=aNode.GridTree.GridCell.CellMatris.getCell(x,y);
        if Assigned(OnCellContentUpdate_Before) then
          OnCellContentUpdate_Before(self,CellToColumn(babCell),babCell);
        UpdateTextInTextCell(babCell,aText);
        if Assigned(OnCellContentUpdate_After) then
          OnCellContentUpdate_After(self,CellToColumn(babCell),babCell);
      end;
    end;
  end;
end;


(*** When a user moves a Item in a Grid, the listRender might suggest a remove
and insert... But this will destroy the selection.... This method fixes this*)
procedure TphGrid_BA.ReselectIfOnlyMoved(theObject:TObject);
var
  i,ii:integer;
  aCell:TBabCell;
  aSelectstate:TSelectstate;
begin
  if (csDestroying in ComponentState) or
    (not Assigned(BabGridCellForViewer)) then
    exit;
  for i:=0 to BabGridCellForViewer.AxisContentListY.Count-1 do
  begin
    if BabGridCellForViewer.AxisContentListY.Items[i].Value is TBoldFollower then
    begin
      for ii:=0 to fRemovedSelectedElements.Count-1 do
      begin
        aSelectstate:=TSelectstate(fRemovedSelectedElements[ii]);
        if aSelectstate.Element=
          (BabGridCellForViewer.AxisContentListY.Items[i].Value as TBoldFollower).Element then
        begin
          aCell:=BabGridCellForViewer.CellMatris.getCell(aSelectstate.ColIndex+BabGridCellForViewer.FixedCols,i);
          if Assigned(aCell) then
            aCell.Selected:=TRUE;
        end;
      end;
    end;
  end;
  RemovedSelectedElements_Clear;
end;


procedure TphGrid_BA.RemovedSelectedElements_Clear;
var
  i:integer;
begin
  if Assigned(fRemovedSelectedElements) then
  begin
    for i:=fRemovedSelectedElements.Count-1 downto 0 do
    begin
      TSelectstate(fRemovedSelectedElements[i]).Free;
    end;
    fRemovedSelectedElements.Clear;
  end;
end;


procedure TphGrid_BA.SaveSelectState_OnDelete(theFollower: TBoldFollower);
var
  i:integer;
  aCell:TBabCell;
  arow:Integer;
  aSelectstate:TSelectstate;
begin
  if theFollower.SubFollowerCount>0 then
  begin
    aCell:=CellFollowerToCell(theFollower.SubFollowers[0]);
    if Assigned(aCell) then
    begin
      arow:=CellFollowerToCell(theFollower.SubFollowers[0]).AxisContentItemY.ListIndex;
      for i:=0 to Columns.Count-1 do
      begin
        if aCell.getGridCell.CellMatris.getCell(aCell.getGridCell.FixedCols+i,aRow).Selected then
        begin
          aSelectstate:=TSelectstate.Create;
          aSelectstate.Element:=theFollower.Element;
          aSelectstate.ColIndex:=i;
          fRemovedSelectedElements.Add(aSelectstate);
        end;
      end;
    end;
  end;
  if (csDestroying in ComponentState) then
    exit;
  TDoLater.DoLater(ReselectIfOnlyMoved,nil);
end;

procedure TphGrid_BA._DeleteRow(theFollower: TBoldFollower);
begin
  if fNeedEnsureFixed then
    EnsureFixed;
  if Editing then
    StopEditing;
  if fTiedUpNilIfDeleteFollower=theFollower then
    fTiedUpNilIfDeleteFollower:=nil;
  if theFollower.Selected then
    SaveSelectState_OnDelete(theFollower);
  (theFollower.ControlData as TAxisContentItem).AxisContentList.Drop((theFollower.ControlData as TAxisContentItem).ListIndex);
end;

function TphGrid_BA.CellFollowerToAxisContentItem(theFollower:TBoldFollower):TAxisContentItem;
begin
  result:=nil;
  if Assigned(theFollower.OwningFollower) and
    Assigned(theFollower.OwningFollower.OwningFollower) and
    (theFollower.OwningFollower.OwningFollower.Controller is TBoldNodeFollowerController) then
  begin
    result:=(theFollower.OwningFollower.OwningFollower.ControlData as
                              TphDataEntity_GridTreeNode).AxisContentItem;
  end
  else
  if theFollower.OwningFollower.Controller is TBoldControllerList then
  begin
    result:=(theFollower.OwningFollower.ControlData as TAxisContentItem);
  end;
end;

function TphGrid_BA.RowFollowerToAxisContentItem(theFollower:TBoldFollower):TAxisContentItem;
begin
  result:=nil;
  if (theFollower.ControlData is TphDataEntity_GridTreeNode) then
  begin
    result:=(theFollower.ControlData as
                              TphDataEntity_GridTreeNode).AxisContentItem;
  end
  else
  if theFollower.ControlData is TAxisContentItem then
  begin
    result:=(theFollower.ControlData as TAxisContentItem);
  end;
end;


function TphGrid_BA.AxisContentItemToRowFollower(
  theAxisContentItem: TAxisContentItem): TBoldFollower;
begin
  result:=theAxisContentItem.Value as TBoldFollower;
end;


function TphGrid_BA.CellFollowerToRowFollower(
  theFollower: TBoldFollower): TBoldFollower;
var
  axisContentItem:TAxisContentItem;
begin
  result:=nil;
  axisContentItem:=CellFollowerToAxisContentItem(theFollower);
  if Assigned(axisContentItem) then
    result:=axisContentItem.Value as TBoldFollower;
end;


function TphGrid_BA.CellFollowerToGridCell(theFollower:TBoldFollower):TBabGridCell;
var
  axisContentItem:TAxisContentItem;
begin
  axisContentItem:=CellFollowerToAxisContentItem(theFollower);
  result:=nil;
  if Assigned(axisContentItem) then
  begin
    result:=axisContentItem.AxisContentList.getGridCell;
  end;
end;

function TphGrid_BA.TieCellAndFollower(theFollower:TBoldFollower):TBabCell;
var
  aBabGridCell:TBabGridCell;
  X,Y:Integer;
begin
  result:=nil;
  aBabGridCell:=CellFollowerToGridCell(theFollower);
  if Assigned(aBabGridCell) then
  begin
    X:=CellFollowerToColumn(theFollower).Index+aBabGridCell.FixedCols;
    Y:=CellFollowerToAxisContentItem(theFollower).ListIndex;
    if aBabGridCell.CellMatris.CountX>X then
    begin
      result:=aBabGridCell.CellMatris.getCell(X,Y);
      result.BabCellData.UserReference:=theFollower;
    end;
    theFollower.ControlData:=result;
  end;
end;

procedure TphGrid_BA.InitializeRenderingCell(theFollower: TBoldFollower);
begin
  fCurrentlyRenderingCell:=CellFollowerToCell(theFollower);
  fCurrentlyRenderingTreeNode:=nil;
  if Assigned(fCurrentlyRenderingCell) and GetUseTreeInSubGrid(fCurrentlyRenderingCell.getGridCell) then
  begin
    fCurrentlyRenderingTreeNode:=AxisContentItemToGridTreeNode(fCurrentlyRenderingCell.AxisContentItemY);
  end;
end;
procedure TphGrid_BA._BeforeMakeCellUptoDate(theFollower: TBoldFollower);
begin
  InitializeRenderingCell(theFollower);
end;

procedure TphGrid_BA.UpdateTextInTextCell(aCell:TBabCell;aText:String);
begin
  (aCell.BabCellData as TBabSimpleCellStringData).IsBoolean:=FALSE;
  (aCell.BabCellData as TBabSimpleCellStringData).Value:=aText;
  if Assigned(aCell.LayoutProp) and
    aCell.LayoutProp.WrapTextAndFit then
  begin
    RecalcExtents;
  end;
  Invalidate;
end;

procedure TphGrid_BA._AfterMakeCellUptoDate(theFollower: TBoldFollower);
var
  aCell:TBabCell;
  someDate: TDate;
  column:TphGrid_BA_Column;
begin
  // Init the cell
  aCell:=TieCellAndFollower(theFollower);
  column:=ColToColBA(CellToColumn(aCell));

  if Assigned(OnCellContentUpdate_Before) then
    OnCellContentUpdate_Before(self,column,aCell);

  if Assigned(aCell) and (aCell.BabCellData is TBabSimpleCellStringData) then
  begin
    if (theFollower.Controller is TBoldCheckBoxStateFollowerController) then
    begin
      (aCell.BabCellData as TBabSimpleCellStringData).IsBoolean:=TRUE;
      if (theFollower.Controller as TBoldCheckBoxStateFollowerController).GetCurrentAsCheckBoxState(theFollower)=cbChecked then
        (aCell.BabCellData as TBabSimpleCellStringData).Value:='TRUE'
      else
        (aCell.BabCellData as TBabSimpleCellStringData).Value:='FALSE';
    end
    else
    if (theFollower.Controller is TBoldStringFollowerController) then
    begin
      if not column.TextAndIconFromTreeDef then
        UpdateTextInTextCell(aCell,(theFollower.Controller as TBoldStringFollowerController).GetCurrentAsString(theFollower));
    end
    else
    if (theFollower.Controller is TBoldFloatFollowerController) then
    begin
      (aCell.BabCellData as TBabSimpleCellStringData).IsBoolean:=FALSE;
      if column.Kind=tckDate then
      begin
        someDate := (theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower);
        if someDate = 0 then
          (aCell.BabCellData as TBabSimpleCellStringData).Value:=''
        else
          (aCell.BabCellData as TBabSimpleCellStringData).Value:=DateToStr(someDate)
      end
      else
        (aCell.BabCellData as TBabSimpleCellStringData).Value:=TimeToStr((theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower));
    end;
  end;
  if Assigned(OnCellContentUpdate_After) then
    OnCellContentUpdate_After(self,column,aCell);
  Invalidate;
end;



procedure TphGrid_BA.SetHasHeaders(const Value: Boolean);
begin
  inherited;
  ReDistributeAllFollowers;
end;

procedure TphGrid_BA.ReDistributeAllFollowers;
begin
  fHandleFollower.BoldHandle:=nil;
  fHandleFollower.DisplayAll;
  fHandleFollower.BoldHandle:=fCursorHandle;
end;

procedure TphGrid_BA.SetHasInfoCol(const Value: Boolean);
begin
  inherited;
  ReDistributeAllFollowers;
end;



function TphGrid_BA.CellToCellFollower(theBabCell: TBabCell):TBoldFollower;
begin
  if Assigned(theBabCell) then
  begin
    result:=theBabCell.BabCellData.UserReference as TBoldFollower
  end
  else
    result:=nil;
end;

function TphGrid_BA.CellFollowerToCell(theFollower:TBoldFollower):TBabCell;
begin
  result:=theFollower.ControlData as TBabCell;
end;


function TphGrid_BA.ColToColBA(theCol:TphGrid_Column):TphGrid_BA_Column;
begin
  result:=theCol as TphGrid_BA_Column;
end;

procedure TphGrid_BA.PreDrawGetStringAndSetAttributes(theBabCell: TBabCell;
  var theString: String; var theBoolean, theIsStringEdit: Boolean);
var
  aCellFollower:TBoldFollower;
  aColumn:TphGrid_BA_Column;
  aColor:TColor;
begin
  inherited PreDrawGetStringAndSetAttributes(theBabCell,theString,theBoolean,theIsStringEdit);

  aColumn := ColToColBA(CellToColumn(theBabCell));
  aCellFollower:=CellToCellFollower(theBabCell);
  if Assigned(aCellFollower) then
  begin
    if Assigned(aColumn) and aColumn.UseRenderFontNotLayout then
    begin
      //SetAttributes on canvas for drawing
      aColumn.BoldProp_Text.SetColor(aColor,clBlack,aCellFollower);
      aColumn.BoldProp_Text.SetFont(OffscreenCanvas.Font,Font,aCellFollower);
      OffscreenCanvas.Font.Color:=aColor;
    end;
  end;

end;


procedure TphGrid_BA.DoOnEditStop(theBabGridView: TBabGridView_Custom;
  theEditComponent: TComponent;
  theBabSimpleCellStringData: TBabSimpleCellStringData;
  var theText: String);

  procedure LocalDoSafeApplyAndOutOfDate(f:TBoldFollower);
  begin
    f.Apply;
    if Assigned(fTiedUpNilIfDeleteFollower) then
      f.MarkValueOutOfDate;
  end;
var
  aIndex:Integer;
  aCellFollower:TBoldFollower;
  aCBs:TCheckboxState;
  aColumn:TphGrid_BA_Column;
  aDateTime:TDatetime;
  aValue:TBoldElement;
  aRowFollower,aTreeNodeTextFollower:TBoldFollower;
begin

  aCellFollower:=CellToCellFollower(theBabSimpleCellStringData.BabCell);
  aColumn:=ColToColBA(CellToColumn(theBabSimpleCellStringData.BabCell));
  if aCellFollower.Element=nil then
    exit;
  fTiedUpNilIfDeleteFollower:=CellFollowerToRowFollower(aCellFollower);
  if aCellFollower.Controller is TBoldStringFollowerController then
  begin
    // Dont set value if combo edit; the combo is responisible for that
    if aColumn.Kind in [tckSimpleEdit,tckMemo] then
    begin
      if aColumn.TextAndIconFromTreeDef then
      begin
        aRowFollower:=CellFollowerToRowFollower(aCellFollower);
        if aRowFollower.Controller is TBoldNodeFollowerController then
        begin
          aTreeNodeTextFollower:=aRowFollower.SubFollowers[BoldNodeTextIndex];
          (aTreeNodeTextFollower.Controller as TBoldStringFollowerController).MayHaveChanged(theText,aTreeNodeTextFollower);
          LocalDoSafeApplyAndOutOfDate(aTreeNodeTextFollower);
        end;
      end
      else
      begin
        (aCellFollower.Controller as TBoldStringFollowerController).MayHaveChanged(theText,aCellFollower);
        LocalDoSafeApplyAndOutOfDate(aCellFollower);
      end;
    end
    else
    if aColumn.Kind in [tckCombo] then
    begin
      if (theEditComponent is TBabInplaceComboEditor) and Assigned(aColumn.BoldCombo) then
      begin
        aColumn.BoldCombo.ItemIndex:=(theEditComponent as TBabInplaceComboEditor).ItemIndex;

        SendMessage(aColumn.BoldCombo.Handle,WM_COMMAND,CBN_SELCHANGE*66536,0);

        aIndex:=aColumn.BoldCombo.ItemIndex;
        aValue:=nil;
        if Assigned(aColumn.BoldCombo.BoldListHandle) and
          Assigned(aColumn.BoldCombo.BoldListHandle.List) and
          (aIndex<aColumn.BoldCombo.BoldListHandle.Count) and
           (aIndex>=0)  then
          aValue:=aColumn.BoldCombo.BoldListHandle.List[aIndex];

        if Assigned(OnComboEditApplyValue) then
          OnComboEditApplyValue(self,aColumn,theBabSimpleCellStringData.BabCell,aCellFollower,aValue);
      end;
    end;
  end
  else
  if aCellFollower.Controller is TBoldCheckBoxStateFollowerController then
  begin
    aCBs:=cbUnChecked;
    if Uppercase(theText)='TRUE' then
      aCBs:=cbChecked;
    (aCellFollower.Controller as TBoldCheckBoxStateFollowerController).MayHaveChanged(aCBs,aCellFollower);
    LocalDoSafeApplyAndOutOfDate(aCellFollower);
  end
  else
  if aCellFollower.Controller is TBoldFloatFollowerController then
  begin
    if theEditComponent is TBabInplaceDateTimeEditor then
    begin
      aDateTime:=0;
      if theText<>'' then
        aDateTime:=StrToDatetime(theText);
      with theEditComponent as TBabInplaceDateTimeEditor do
      begin
        case Kind of
          dtkTime: begin
                    (aCellFollower.Controller as TBoldFloatFollowerController).MayHaveChanged(aDateTime, aCellFollower);
                    LocalDoSafeApplyAndOutOfDate(aCellFollower);
                  end;
          dtkDate:begin
                    (aCellFollower.Controller as TBoldFloatFollowerController).MayHaveChanged(aDateTime, aCellFollower);
                    LocalDoSafeApplyAndOutOfDate(aCellFollower);
                  end;
        end;
        if Assigned(fTiedUpNilIfDeleteFollower) then
          (aCellFollower.Controller as TBoldFloatFollowerController).MayHaveChanged(aDateTime, aCellFollower);
      end;
    end;
  end;
end;

procedure TphGrid_BA.DeInitEditor(theComponent:TComponent;thebabCell:TBabSimpleCell;theText:String;theEscaped:Boolean);
var
  aCellFollower:TBoldFollower;
begin
  fSortingColumn:=nil;
  fSortUpNotDown:=FALSE;

  aCellFollower:=CellToCellFollower(theBabCell);
  if Assigned(aCellFollower) then
  begin
    InitializeRenderingCell(aCellFollower);
    if not theEscaped then
    begin
      fTiedUpNilIfDeleteFollower:=CellFollowerToRowFollower(aCellFollower);
      if Assigned(OnEditStop) then
        OnEditStop(self,theComponent,(thebabCell.BabCellData as TBabSimpleCellStringData),theText);
      if Assigned(fTiedUpNilIfDeleteFollower) then
        _AfterMakeCellUptoDate(aCellFollower);
    end;
  end;
end;


function TphGrid_BA.EditorCanModify(theBabCell:TBabCell): boolean;
var
  aCellFollower:TBoldFollower;
  aColumn:TphGrid_BA_Column;
begin
  result:=FALSE;
  if not Assigned(theBabCell) then
    exit;
  aCellFollower:=CellToCellFollower(theBabCell);
  aColumn := ColToColBA(CellToColumn(theBabCell));
  if aColumn.TextAndIconFromTreeDef and
    Assigned(CellToNode(theBabCell)) then
  begin
    result:=CellToNode(theBabCell).CanEdit;
  end
  else
  begin
    result := Assigned(aCellFollower) and aCellFollower.Controller.MayModify(aCellFollower);
    if Assigned(aColumn) and (aColumn.Kind=tckCombo) and Assigned(aColumn.BoldCombo) then
    begin
      if (aColumn.BoldCombo.BoldHandle is TBoldExpressionHandle) then
      begin
        if Assigned(BoldHandle) then // only assigned if grid not for tree
          (aColumn.BoldCombo.BoldHandle as TBoldExpressionHandle).RootHandle:=BoldHandle
        else
          (aColumn.BoldCombo.BoldHandle as TBoldExpressionHandle).RootHandle:=fInternalReferenceHandle;
      end;

      result := (*result and det som presenteras har inget med editeringen i combon att gra*)
        Assigned(aColumn.BoldCombo.BoldHandle) and
// MICKE *******        Assigned(aColumn.BoldCombo.BoldHandle.value) and
        not aColumn.BoldCombo.ReadOnly (* Konstigt, borde vara effectiveReadOnly, men det funkar kass*);
    end;
    result := result and (not aColumn.ReadOnly);
  end;

  if Assigned(OnUserBeforeEnterEdit) then
    OnUserBeforeEnterEdit(self,aColumn,theBabCell,aCellFollower);

  if Assigned(OnUserDecideMayModify) then
    result:=OnUserDecideMayModify(self,aColumn,theBabCell,aCellFollower,result);
end;


procedure TphGrid_BA.FocusChanged(theNewFoucusedCell: TBabCell);
var
  aCellFollower:TBoldFollower;
begin
  inherited FocusChanged(theNewFoucusedCell);
  if Assigned(theNewFoucusedCell) then
  begin
    if Assigned(BoldHandle) then
    begin
      aCellFollower:=CellToCellFollower(theNewFoucusedCell);
      if Assigned(aCellFollower) then
      begin
        fHandleFollower.BoldHandle.CurrentIndex:=CellFollowerToRowFollower(aCellFollower).Index;
        BoldHandle.CurrentIndex:=BoldHandle.List.IndexOf(fHandleFollower.BoldHandle.Value);
      end;
    end;
  end;
end;

function TphGrid_BA.InitEditor(theComponent: TComponent;
  thebabCell: TBabSimpleCell): String;
var
  i : integer;
  aIndex : integer;
  aNilOffset : integer;
  aBoldCombo:TBoldComboBox;
  element:TBoldElement;
begin
  result:=inherited InitEditor(theComponent,thebabCell);

  if theComponent is TBabInplaceDateTimeEditor then
  begin
    if CellToColumn(thebabCell).Kind=tckTime then
      fInplaceDateTimeEditor.Kind := dtkTime
    else
      fInplaceDateTimeEditor.Kind := dtkDate;
  end
  else
  if theComponent is TBabInplaceComboEditor then
  begin
    aBoldCombo:=ColToColBA(CellToColumn(thebabCell)).BoldCombo;
    if Assigned(aBoldCombo) then
    begin
      (theComponent as TBabInplaceComboEditor).Items.Clear;
      (theComponent as TBabInplaceComboEditor).Items.AddStrings(aBoldCombo.Items);
      if Assigned(aBoldCombo.BoldHandle) and
        Assigned(aBoldCombo.BoldListHandle) then
      begin
        element:=aBoldCombo.BoldHandle.Value;
        if (aBoldCombo.BoldSelectChangeAction=bdcsSetValue) and Assigned(element) then
          element:=element.EvaluateExpressionAsDirectElement(aBoldCombo.BoldSetValueExpression);
        if element is TBoldObjectReference then
          element:=(element as TBoldObjectReference).BoldObject;
        aIndex := aBoldCombo.BoldListHandle.List.IndexOf(element);

        aNilOffset := 0;
        if aBoldCombo.BoldListProperties.NilElementMode in [neInsertFirst] then
          aNilOffset := 1;
        if element is TBAValueSet then
        begin
          for i := 0 to aBoldCombo.BoldListHandle.List.Count - 1 do
          begin
            if aBoldCombo.BoldListHandle.List[i] is TBAValueSet then
              if TBAValueSet(element).AsInteger = TBAValueSet(aBoldCombo.BoldListHandle.List[i]).AsInteger then
              begin
                aIndex := i + aNilOffset;
                Break;
              end;
          end;
        end;
        (theComponent as TBabInplaceComboEditor).ItemIndex := aIndex;
      end;
    end
    else
    begin
    end;
  end;
end;



procedure TphGrid_BA.Notification(AComponent: TComponent;
  Operation: TOperation);
var
  i:integer;
begin
  inherited;
  if Assigned(Columns) then
  begin
    for i:=0 to Columns.Count-1 do
    begin
      if (AComponent=ColToColBA(Columns[i]).BoldCombo) and (Operation=opRemove) then
        ColToColBA(Columns[i]).BoldCombo:=nil;
    end;
  end;

  if (AComponent=BoldHandle) and (Operation=opRemove) then
        BoldHandle:=nil;

  if (AComponent=BoldTreeElementHandle) and (Operation=opRemove) then
        BoldHandle:=nil;

end;



procedure TphGrid_BA.DoEndDrag(Target: TObject; X, Y: Integer);
begin
  inherited DoEndDrag(Target,X, Y);
  BoldGUIHandler.DraggedObjects.Clear;
end;

procedure TphGrid_BA.DoStartDrag(var DragObject: TDragObject);
begin
  inherited DoStartDrag(DragObject);
  GetSelectedObjects(BoldGUIHandler.DraggedObjects);
end;

procedure TphGrid_BA.SetController(
  const Value: TBoldListAsFollowerListController);
begin
  fBoldProperties.Assign(Value);
end;


function TphGrid_BA.CellToElement(theBabCell:TBabCell): TBoldElement;
var
  aFollower : TBoldFollower;
begin
  result := nil;
  if Assigned( theBabCell ) then
  begin
    aFollower := CellToRowFollower(theBABCell);
    if Assigned( aFollower ) then
      result := aFollower.Element;
  end;
end;

function TphGrid_BA.CellToRowFollower(theBabCell:TBabCell): TBoldFollower;
var
  aFollower : TBoldFollower;
begin
  result := nil;
  if Assigned( theBabCell ) then
  begin
    aFollower := CellToCellFollower(theBabCell);
    if Assigned( aFollower ) then
    begin
      result := CellFollowerToRowFollower(aFollower);
    end;
  end;
end;

procedure TphGrid_BA.DoSortCell(theBabCell: TBabCell;theUpNotDown:Boolean);
begin
  inherited DoSortCell(theBabCell,theUpNotDown);
  SetLastKnownSortedList(nil);
  fDerivedHandle.MarkOutOfDate;
end;





(***  *)
function TphGrid_BA.GetSelectedObjectsCount: integer;
var
  aList : TBoldObjectList;
begin
  aList := TBoldObjectList.Create;
  try
    GetSelectedObjects(aList);
    result := aList.Count;
  finally
    aList.Free;
  end;
end;

procedure TphGrid_BA.GetSelectedObjects(theResultBOL: TBoldObjectList);
var
  i : integer;
  aFollower : TBoldFollower;
begin
  for i := 0 to fBabGridCellForViewer.AxisContentListY.Count-1 do
  begin
    aFollower := fBabGridCellForViewer.AxisContentListY.Items[i].Value as TBoldFollower;
    if Assigned(aFollower) and aFollower.Selected then
    begin
      if aFollower.Element is TBoldObject then
        theResultBOL.Add( aFollower.Element as TBoldObject );
    end;
  end;
end;

function TphGrid_BA.GetFirstSelectedObject : TBoldObject;
var
  aBOL : TBoldObjectList;
begin
  result := nil;
  aBOL := TBoldObjectList.Create;
  try
    GetSelectedObjects(aBOL);
    if aBOL.Count > 0 then
      result := aBOL[0];
  finally
    aBOL.Free;
  end;
end;

procedure TphGrid_BA.GetAllObjects(theResultBOL: TBoldObjectList);
var
  i : integer;
  aFollower : TBoldFollower;
begin
  for i := 0 to fBabGridCellForViewer.AxisContentListY.Count-1 do
  begin
    aFollower := fBabGridCellForViewer.AxisContentListY.Items[i].Value as TBoldFollower;
    if Assigned(aFollower) {and aFollower.Selected} then
    begin
      if aFollower.Element is TBoldObject then
        theResultBOL.Add( aFollower.Element as TBoldObject );
    end;
  end;
end;



procedure TphGrid_BA._DeleteRowSubGrid(theFollower: TBoldFollower);
var
  i:integer;
begin
  if fTiedUpNilIfDeleteFollower=theFollower then
    fTiedUpNilIfDeleteFollower:=nil;
  if theFollower.ControlData is TAxisContentItem then
  begin
    for i:=0 to theFollower.SubFollowerCount-1 do
    begin
      theFollower.SubFollowers[i].ControlData:=nil;
    end;
    //aGridCell.AxisContentListY.Drop(theFollower.index+aGridCell.FixedRows); // Index dependent
    (theFollower.ControlData as TAxisContentItem).AxisContentList.Drop((theFollower.ControlData as TAxisContentItem).ListIndex);

    theFollower.ControlData:=nil;
  end;
end;

procedure TphGrid_BA._InsertRowSubGrid(theFollower: TBoldFollower);
var
  aBabCell:TBabcell;
  aGridCell:TBabGridcell;
begin
  aBabCell:=theFollower.OwningFollower.ControlData as TBabcell;

  if (aBabCell is TBabGridCell) then
  begin
    aGridCell:=(aBabCell as TBabGridCell);
    if theFollower.OwningFollower.SubFollowerCount=1 then
    begin
      //Init the subgrid if first row
      InitSubGrid(aBabCell);
    end;
    theFollower.ControlData:=aGridCell.AxisContentListY.InsertNew(theFollower.index+aGridCell.FixedRows,theFollower);
  end;
end;


procedure TphGrid_BA._DeleteCell(theFollower: TBoldFollower);
var
  i:integer;
begin
  if Editing then
    StopEditing;

  if theFollower.ControlData is TBabcell then
  begin

    if theFollower.ControlData is TBabGridcell then
    begin
      // This code is needed since a move operation of a subgridcolumn
      // will add new rows but not remove oldones (some bold issue a think)
      for i:=0 to theFollower.SubfollowerCount-1 do
      begin
        if GetUseTreeInSubGrid(theFollower.ControlData as TBabGridcell) then
          _DeleteTreeRowSubGrid(theFollower.Subfollowers[i])
        else
          _DeleteRowSubGrid(theFollower.Subfollowers[i]);
      end;
    end;


    if (theFollower.ControlData as TBabcell).BabCellData.UserReference=theFollower then
    begin
      (theFollower.ControlData as TBabcell).BabCellData.UserReference:=nil;
      theFollower.ControlData:=nil;
    end;
  end;
end;

procedure TphGrid_BA._InsertCell(theFollower: TBoldFollower);
begin
  if fNeedEnsureFixed then
    EnsureFixed;  // Got to do this to prevent "timing" error

  TieCellAndFollower(theFollower);
  // Cell initiation and follower connection was moved to _AfterMakeCellUptoDate
  // since we found unexplainable strange bold behavior in _InsertCell
  // (Sometimes after a Columns.Clear and adding of new columns they never showed
  // up here)
end;

procedure TphGrid_BA.SelectLatestCreated_Async(sender:TObject);
var
  axisContentItem:TAxisContentItem;
  cell:TBabCell;
begin
  axisContentItem:=RowFollowerToAxisContentItem(fLatestSeenFollower);

  if Assigned(axisContentItem)  then
  begin
    cell:=fBabGridCellForViewer.CellMatris.getCell(fBabGridCellForViewer.FixedCols,axisContentItem.ListIndex);
    fBabGridCellForViewer.UpdateMultiSelect(cell,[]);
    fBabGridCellForViewer.FocusedCell:=cell;
  end;
  fLatestSeenFollower:=nil;
end;

function TphGrid_BA.CellFollowerToColumn(theCellFollower: TBoldFollower):TphGrid_BA_Column;
var
  i,ii:integer;
begin
  result:=nil;
  for i:=0 to fBoldColumnsProperties.Count-1 do
  begin
    if fBoldColumnsProperties[i]=theCellFollower.Controller then
    begin
      result:=ColToColBA(Columns[i]);
      exit;
    end;
  end;

  if not Assigned(result) then
  begin
    for i:=0 to SubGrids.Count-1 do
    begin
      for ii:=0 to SubGrids_BA[i].fBoldColumnsProperties.Count-1 do
      begin
        if SubGrids_BA[i].fBoldColumnsProperties[ii]=theCellFollower.Controller then
        begin
          result:=ColToColBA(SubGrids[i].Columns[ii]);
          exit;
        end;
      end;
    end;
  end;

end;


function TphGrid_BA.CreateColumnsCollection: TphGrid_Columns;
begin
  result:=TphGrid_BA_Columns.Create(TphGrid_BA_Column);
end;

function TphGrid_BA.CreateSubGridsCollection: TphGrid_SubGrids;
begin
  result:=TphGrid_BA_SubGrids.Create(TphGrid_BA_SubGrid);
end;

function TphGrid_BA.GetGrid_BA_Columns: TphGrid_BA_Columns;
begin
  result:=Columns as TphGrid_BA_Columns;
end;



function TphGrid_BA.GetSubGrids_BA: TphGrid_BA_SubGrids;
begin
  result:=SubGrids as TphGrid_BA_SubGrids;
end;


procedure TphGrid_BA.SetBoldTreeProperties(
  const Value: TBoldTreeFollowerController);
begin
  fBoldTreeProperties.Assign(Value);
end;


function TphGrid_BA.GetBoldTreeElementHandle: TBoldElementHandle;
begin
  result:=nil;
  if Assigned(fBoldTreeHandleFollower) then
    result:=fBoldTreeHandleFollower.BoldHandle;
end;

procedure TphGrid_BA.SetBoldTreeElementHandle(
  const Value: TBoldElementHandle);
begin
  if Assigned(fInCommingHandle) and
      Assigned(Value) then
    raise Exception.Create('Ethier the boldhandle or the tree element handle, not both! ('+Name+')');

  fBoldTreeHandleFollower.BoldHandle:=Value;
end;





procedure TphGrid_BA._ExpandStateRestore_Async(aObject: TObject);
begin
  // When a bold tree is re-derived and it contains objects that are
  // created in the derivation -> All expansions will be lost...
  // To avoid this we remember expansion by name and restore them when
  // the derivation is complete
  ExpandedStateRestore(nil);
end;

procedure TphGrid_BA._BeforeMakeUptoDateTree(aBoldFollower: TBoldFollower);
begin
  if Assigned(aBoldFollower.OwningFollower) and
    (aBoldFollower.OwningFollower.ControlData is TphDataEntity_GridTreeNode) then
    fCurrentlyExpandningTreeNode:=aBoldFollower.OwningFollower.ControlData as TphDataEntity_GridTreeNode;

  // When a bold tree is re-derived and it contains objects that are
  // created in the derivation -> All expansions will be lost...
  // To avoid this we remember expansion by name and restore them when
  // the derivation is complete
  if not fIsExpanding then
  begin
    ExpandedStateSave(nil);
    TDoLater.DoLater(_ExpandStateRestore_Async,nil);
  end;
end;


function TphGrid_BA.CellIconIndex(theBabCell: TBabCell): Integer;
var
  column:TphGrid_BA_Column;
begin
  result:=inherited CellIconIndex(theBabCell);
  column:=ColToColBA(CellToColumn(theBabCell));
  if Assigned(column) then
  begin
    if column.TextAndIconFromTreeDef and
      Assigned(CellToNode(theBabCell)) then
      result:=CellToNode(theBabCell).ImageIndex;
  end;
end;

procedure TphGrid_BA.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  aCell:TBabCell;
begin
  inherited;
  aCell:=GetCellAtPixel(X,Y);
  if Assigned(aCell) then
  begin
    if Assigned(CellToCellFollower(aCell)) and
      EditorCanModify(aCell) then
    begin
      Cursor:=crCross;
    end;
  end;
end;


{ TphGrid_BA_Column }

constructor TphGrid_BA_Column.Create(theCollection: TCollection);
begin
  inherited;

  fBoldProperties_Text:=TBoldStringFollowerController.Create(Grid_BA);
  fBoldProperties_Text.BeforeMakeUptoDate := Grid_BA._BeforeMakeCellUptoDate;
  fBoldProperties_Text.AfterMakeUptoDate := Grid_BA._AfterMakeCellUptoDate;
  fBoldProperties_Text.OnGetContextType := Grid_BA.GetHandleStaticType;

  fBoldProperties_Boolean:=TBoldCheckBoxStateFollowerController.Create(Grid_BA);
  fBoldProperties_Boolean.BeforeMakeUptoDate := Grid_BA._BeforeMakeCellUptoDate;
  fBoldProperties_Boolean.AfterMakeUptoDate := Grid_BA._AfterMakeCellUptoDate;
  fBoldProperties_Boolean.OnGetContextType := Grid_BA.GetHandleStaticType;

  fBoldProperties_Float:=TBoldFloatFollowerController.Create(Grid_BA);
  fBoldProperties_Float.BeforeMakeUptoDate := Grid_BA._BeforeMakeCellUptoDate;
  fBoldProperties_Float.AfterMakeUptoDate := Grid_BA._AfterMakeCellUptoDate;
  fBoldProperties_Float.OnGetContextType := Grid_BA.GetHandleStaticType;

  fBoldProperties_List:=TBoldGenericListController.Create(fGrid,GetCorrectControllerForSubGrid);
  fBoldProperties_List.OnAfterInsertItem:=Grid_BA._InsertRowSubGrid;
  fBoldProperties_List.OnBeforeDeleteItem:=Grid_BA._DeleteRowSubGrid;
  fBoldProperties_List.Parts.Add; // Use one single list part to do the sublist
  BoldProp_ListForSubGrid.Parts[0].InterpretAsList:=TRUE;


  fBoldProperties_SubTree:=TBoldTreeFollowerController.Create(fGrid);
  fBoldProperties_SubTree.OnAfterInsertItem:=Grid_BA._InsertTreeRowSubGrid;
  fBoldProperties_SubTree.OnBeforeDeleteItem:=Grid_BA._DeleteTreeRowSubGrid;
  fBoldProperties_SubTree.OnGetContextType:=Grid_BA.GetHandleStaticType_Tree;
  fBoldProperties_SubTree.BeforeMakeUptoDate := Grid_BA._BeforeMakeUptoDateTree;
  fBoldProperties_SubTree.OnTextChanged:=Grid_BA.TreeDefinitionTextOrIconChanged;
  fBoldProperties_SubTree.OnIconChanged:=Grid_BA.TreeDefinitionTextOrIconChanged;

  fBoldProperties_Hidden:=TBoldFollowerController_Hidden.Create(fGrid);

  GetColumnProperties.Add(fBoldProperties_Text);
end;


destructor TphGrid_BA_Column.Destroy;
begin
  Grid_BA.CleanTreePropsFromColumnRefs(fBoldProperties_SubTree);

  GetColumnProperties.Remove(fBoldProperties_Text);
  GetColumnProperties.Remove(fBoldProperties_Boolean);
  GetColumnProperties.Remove(fBoldProperties_Float);
  GetColumnProperties.Remove(fBoldProperties_List);
  GetColumnProperties.Remove(fBoldProperties_SubTree);
  GetColumnProperties.Remove(fBoldProperties_Hidden);


  FreeAndNil(fBoldProperties_Text);
  FreeAndNil(fBoldProperties_Boolean);
  FreeAndNil(fBoldProperties_Float);
  FreeAndNil(fBoldProperties_List);
  FreeAndNil(fBoldProperties_SubTree);
  FreeAndNil(fBoldProperties_Hidden);

  if not (csDestroying in fGrid.ComponentState) then
  begin
    (* Must perform a DisplayAll, otherwise strange error when recreating columns
    in RT, it works fine when destroying the whole grid, but not when one just
    destroys the columns and then recreates new columns... I think the old follwers
    are taken over by new controllers, will not work if different types of renderData though!!! *)
    CleanUpCells;
    inherited;   // Call inherited to let the column disappear from collection before displayAll
    TBoldFollower.DisplayAll;
  end
  else
    inherited;

end;


function TphGrid_BA_Column.GetCorrectControllerForSubGrid( Name: string):TBoldFollowerController;
var
  aSubGrid:TphGrid_BA_SubGrid;
begin
  result:=nil;
  aSubGrid:=fGrid.ColumnToSubGrid(self) as TphGrid_BA_SubGrid;
  if Assigned(aSubGrid) then
    result:=aSubGrid.fBoldColumnsProperties;
end;

function TphGrid_BA_Column.GetDisplayName: string;
begin
  result:='';
  case Kind of
    tckSimpleEdit,tckMemo,tckCombo: result:=BoldProp_Text.Expression;
    tckBool: result:=BoldProp_Boolean.Expression;
    tckSubGrid:
                begin
                  result:='SubGrid:'+fSubGridName;
                end;
    tckSubTree:
                begin
                  result:='SubTree:'+fSubGridName;
                end;
  end;
  if result='' then
    result:=inherited GetDisplayName;
end;




procedure TphGrid_BA_Column.SetBoldComboBox(const Value: TBoldComboBox);
begin
  fBoldComboBox := Value;
  if Assigned(fBoldComboBox) then
  begin
    if Assigned(fGrid) then
      fBoldComboBox.FreeNotification(fGrid);
  end;
end;

procedure TphGrid_BA_Column.SetBoldProperties_Boolean(
  const Value: TBoldCheckBoxStateFollowerController);
begin
  fBoldProperties_Boolean.Assign(Value);
end;


procedure TphGrid_BA_Column.SetBoldProperties_Text(
  const Value: TBoldStringFollowerController);
begin
  fBoldProperties_Text.Assign(Value);
end;

procedure TphGrid_BA_Column.SetBoldProperties_Float(
  const Value: TBoldFloatFollowerController);
begin
  fBoldProperties_Float.Assign(Value);
end;

procedure TphGrid_BA_Column.SetKind(const Value: TColumnKind);
begin
  GetColumnProperties.Remove(fBoldProperties_Text);
  GetColumnProperties.Remove(fBoldProperties_Boolean);
  GetColumnProperties.Remove(fBoldProperties_Float);
  GetColumnProperties.Remove(fBoldProperties_List);
  GetColumnProperties.Remove(fBoldProperties_SubTree);
  GetColumnProperties.Remove(fBoldProperties_Hidden);
  if Hidden then
    GetColumnProperties.Add(fBoldProperties_Hidden)
  else
  begin
    case Value of
      tckSimpleEdit,tckMemo,tckCombo: GetColumnProperties.Add(fBoldProperties_Text);
      tckBool: GetColumnProperties.Add(fBoldProperties_Boolean);
      tckDate, tckTime: GetColumnProperties.Add(fBoldProperties_Float);
      tckSubGrid:
              begin
                GetColumnProperties.Add(fBoldProperties_List);
              end;
      tckSubTree:
              begin
                GetColumnProperties.Add(fBoldProperties_SubTree);
              end;
    end;
  end;
  inherited SetKind(Value);
end;





function TphGrid_BA_Column.GetColumnProperties: TBoldControllerList;
begin
  result:=Grid_BA.fBoldColumnsProperties;
  if Assigned(fSubGrid) then
    result:=(fSubGrid as TphGrid_BA_SubGrid).fBoldColumnsProperties;
end;

procedure TphGrid_BA_Column.SetBoldProperties_List(
  const Value: TBoldGenericListController);
begin
  fBoldProperties_List.Assign(Value);
end;


function TphGrid_BA_Column.GetListExpression: TBoldExpression;
begin
  result:='';
  if BoldProp_ListForSubGrid.Parts.Count>0 then
    result:=BoldProp_ListForSubGrid.Parts.Items[0].ElementExpression;
end;

function TphGrid_BA_Column.GetOnGetList: TGetElementEvent;
begin
  result:=nil;
  if BoldProp_ListForSubGrid.Parts.Count>0 then
    result:=BoldProp_ListForSubGrid.Parts.Items[0].OnGetElement;
end;

procedure TphGrid_BA_Column.SetOnGetList(const Value: TGetElementEvent);
begin
  if BoldProp_ListForSubGrid.Parts.Count>0 then
    BoldProp_ListForSubGrid.Parts.Items[0].OnGetElement:=Value;
end;

procedure TphGrid_BA_Column.SetListExpression(
  const Value: TBoldExpression);
begin
  if BoldProp_ListForSubGrid.Parts.Count>0 then
    BoldProp_ListForSubGrid.Parts.Items[0].ElementExpression:=Value;
end;

function TphGrid_BA_Column.GetGrid_BA: TphGrid_BA;
begin
  result:=fGrid as TphGrid_BA;
end;

procedure TphGrid_BA_Column.SetBoldProperties_SubTree(
  const Value: TBoldTreeFollowerController);
begin
  fBoldProperties_SubTree.Assign(Value);
end;


procedure TphGrid_BA_Column.Assign(source: TPersistent);
var
  co:TphGrid_BA_Column;
begin
  inherited;
  if source is TphGrid_BA_Column then
  begin
    co:=source as TphGrid_BA_Column;

    BoldProp_Text.Assign(co.BoldProp_Text);
    BoldProp_Boolean.Assign(co.BoldProp_Boolean);
    BoldProp_Float.Assign(co.BoldProp_Float);
    BoldProp_SubTree.Assign(co.BoldProp_SubTree);

    BoldCombo:=co.BoldCombo;
    SubGridListExpression:=co.SubGridListExpression;
    OnGetSubGridList:=co.OnGetSubGridList;



  end;
end;

procedure TphGrid_BA_Column.SetIndex(Value: Integer);
var
  old:Integer;
begin
  old:=Index;
  inherited;
  GetColumnProperties.Move(old,Index);
end;

procedure TphGrid_BA_Column.SetHidden(const Value: Boolean);
begin
  if (Value<>(inherited Hidden)) and
    not (csDestroying in fGrid.ComponentState) then
  begin
    inherited;
    SetKind(Kind); // Set fBoldProperties_Hidden
  end
  else
  begin
    inherited;
  end;
end;

{ TphGrid_BA_Columns }

function TphGrid_BA_Columns.GetColumn(index: integer): TphGrid_BA_Column;
begin
  result:=Columns[index] as TphGrid_BA_Column;
end;



function TphGrid_BA_SubGrids.GetSubGrid_BA(
  index: integer): TphGrid_BA_SubGrid;
begin
  result:=SubGrids[index] as TphGrid_BA_SubGrid;
end;



{ TphGrid_BA_SubGrid }

procedure TphGrid_BA_SubGrid.Assign(source: TPersistent);
begin
  inherited;
  if source is TphGrid_BA_SubGrid then
  begin
    InitLevelsInTree:=(source as TphGrid_BA_SubGrid).InitLevelsInTree;
    ExpandLevelsInTree:=(source as TphGrid_BA_SubGrid).ExpandLevelsInTree;
  end;
end;

constructor TphGrid_BA_SubGrid.Create(theCollection: TCollection);
var
  aGrid:TphGrid;
begin
  inherited;
  aGrid:=(Collection as TphGrid_BA_SubGrids).OwningGrid;

  fBoldColumnsProperties:=TBoldControllerList_COLUMNS.Create(aGrid); 
  fBoldColumnsProperties.OnAfterInsertItem:=(aGrid as TphGrid_BA)._InsertCell;
  fBoldColumnsProperties.OnBeforeDeleteItem:=(aGrid as TphGrid_BA)._DeleteCell;
end;

destructor TphGrid_BA_SubGrid.Destroy;
begin

  inherited;
end;

procedure TphGrid_BA_SubGrid.DestroyColumns;
begin
  inherited DestroyColumns;
  FreeAndNil(fBoldColumnsProperties);
end;




{ TBoldControllerList_COLUMNS }

destructor TBoldControllerList_COLUMNS.Destroy;
begin
  inherited;

end;



{ TBoldFollowerController_Hidden }

procedure TBoldFollowerController_Hidden.DoMakeUptodateAndSubscribe(
  Follower: TBoldFollower; Subscribe: Boolean);
begin
  //NADA
end;


(**
$History: phGrid_BA.pas $
 * 
 * *****************  Version 109  *****************
 * User: Dthk         Date: 02-01-17   Time: 11.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Fixat combo i trd
 * 
 * *****************  Version 108  *****************
 * User: Dthk         Date: 02-01-17   Time: 9.47
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Stdat, tagit bort Deprectated properties
 * 
 * *****************  Version 105  *****************
 * User: Dthk         Date: 01-10-04   Time: 17.40
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Fix lingering problem with destruction of tree controllers
 * 
 * *****************  Version 104  *****************
 * User: Dthk         Date: 01-10-04   Time: 13.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Gridden ns frn Gant_BA, 
 * Uppstdning
 * 
 * *****************  Version 103  *****************
 * User: Dthk         Date: 01-10-02   Time: 17.41
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Sm korrigeringar fr att f in grid i gant_BA
 * 
 * *****************  Version 102  *****************
 * User: Dthk         Date: 01-09-17   Time: 15.24
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Olycklig bugg infrd i hierarkiskagriddar, borttagen
 * 
 * *****************  Version 101  *****************
 * User: Dthk         Date: 01-09-14   Time: 17.04
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Optimering
 * 
 * *****************  Version 100  *****************
 * User: Dthk         Date: 01-09-13   Time: 10.24
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * fBoldProperties_Hidden used on hidden columns
 *
 * *****************  Version 99  *****************
 * User: Dthk         Date: 01-08-28   Time: 15.00
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Knepiga stngav buggar
 *
 * *****************  Version 98  *****************
 * User: Dthk         Date: 01-08-21   Time: 17.12
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Kolla destroying innan reselecta
 *
 * *****************  Version 97  *****************
 * User: Dthk         Date: 01-08-21   Time: 15.11
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * SaveSelectState_OnDelete funkar ven fr trd
 *
 * *****************  Version 96  *****************
 * User: Dthk         Date: 01-08-10   Time: 12.50
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Kollar om raden har frsvunnit i apply innan vi gr MarkValueOutOfDate;
 * Botar horrible AVs
 *
 * *****************  Version 95  *****************
 * User: Dthk         Date: 01-08-08   Time: 9.28
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * ph Updates 2.1.4.2
 *
 * *****************  Version 94  *****************
 * User: Dthk         Date: 01-06-26   Time: 15.59
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Display var kass, MarkValueOutOfDate r bttre
 * 
 * *****************  Version 93  *****************
 * User: Dthk         Date: 01-06-26   Time: 15.36
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * En display efter apply, om data har ndrat sig
 * 
 * *****************  Version 92  *****************
 * User: Dtmoo        Date: 01-06-26   Time: 9.12
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg vid editering med combo i kolumn. Om man hade ett nil vrde blev
 * kolumnen read only.
 * 
 * *****************  Version 91  *****************
 * User: Dtkl         Date: 01-06-13   Time: 14.22
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * ndrat till MayHaveChanged och Apply i stllet fr SetAs...
 * 
 * *****************  Version 90  *****************
 * User: Dthk         Date: 01-05-29   Time: 16.42
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * OnNewTreeRow
 * 
 * *****************  Version 89  *****************
 * User: Dthk         Date: 01-05-15   Time: 11.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * 
 * *****************  Version 88  *****************
 * User: Dthk         Date: 01-05-11   Time: 14.51
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Kommer ihg utvik i trdet evn om hrledningarna skapar nya objekt
 * 
 * *****************  Version 87  *****************
 * User: Dthk         Date: 01-05-04   Time: 11.08
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Droppar alla rader som r beroende av en controller nr controllern
 * frstrs, tidigare har vi litat till att followers frstrs vad det
 * lider och drmed tar bort sina rader... Men en upprttning i BOLD brt
 * det beteendet
 * 
 * *****************  Version 86  *****************
 * User: Dthk         Date: 01-04-27   Time: 11.14
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 *  InitializeRenderingCell ropas nu ven efter editering...
 * 
 * *****************  Version 85  *****************
 * User: Dthk         Date: 01-04-05   Time: 16.08
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Liten bugg i kryss funktionalitet
 * 
 * *****************  Version 84  *****************
 * User: Dthk         Date: 01-04-05   Time: 14.08
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Cross when over something editable
 * 
 * *****************  Version 83  *****************
 * User: Dthk         Date: 01-02-27   Time: 15.19
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Iconer frn boldtrdet
 * 
 * *****************  Version 82  *****************
 * User: Dthk         Date: 01-02-16   Time: 17.20
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Anvndande av trddefinitionstext ven fr editering
 * 
 * *****************  Version 81  *****************
 * User: Dthk         Date: 01-02-15   Time: 15.17
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * TextAndIconFromTreeDef kan sttas i en kolumn och d tar man man texten
 * frn trddefinitionen
 * 
 * *****************  Version 80  *****************
 * User: Dthk         Date: 01-02-14   Time: 13.22
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg vid borttag av kolumn, temporr snedhalkning av rendering
 * 
 * *****************  Version 79  *****************
 * User: Dthk         Date: 01-02-08   Time: 9.47
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * RT detsruction och terskapande av kolumner
 * 
 * *****************  Version 78  *****************
 * User: Dthk         Date: 01-02-06   Time: 16.40
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Knepig bugg vid move a subgrid eller subtrd
 * 
 * *****************  Version 77  *****************
 * User: Dthk         Date: 01-01-18   Time: 14.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Diverse rikspunkter tgrdade
 * 
 * *****************  Version 76  *****************
 * User: Dthk         Date: 01-01-10   Time: 8.55
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * OnSelectionChange uppdatering
 * 
 * *****************  Version 75  *****************
 * User: Dthk         Date: 01-01-03   Time: 16.47
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Stdat
 * 
 * *****************  Version 74  *****************
 * User: Dthk         Date: 01-01-03   Time: 13.19
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * CurrentlyRenderingCell, CurrentlyRenderuingTreeNode
 * 
 * *****************  Version 73  *****************
 * User: Dthk         Date: 00-12-20   Time: 14.37
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Oops, fixat bugg
 * 
 * *****************  Version 72  *****************
 * User: Dthk         Date: 00-12-20   Time: 14.31
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * CurrentlyExpandingNode, samma som i trdet
 * 
 * *****************  Version 71  *****************
 * User: Dtbwn        Date: 00-12-18   Time: 17.22
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Om followers tas bort i apply edit, s sket sig anropen till
 * OnAfterCellUpdate... Eftersom CellFollowern vart friad.
 * /Hasse
 * 
 * *****************  Version 70  *****************
 * User: Dthk         Date: 00-12-15   Time: 16.04
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * MultiDrag
 * 
 * *****************  Version 69  *****************
 * User: Dthk         Date: 00-12-15   Time: 10.01
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Flyttat sortering
 *
 * *****************  Version 68  *****************
 * User: Dthk         Date: 00-12-13   Time: 12.53
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Flyttar om Columnproperties nr columnerna flyttas
 * 
 * *****************  Version 67  *****************
 * User: Dthk         Date: 00-12-07   Time: 10.39
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Hide renamed to hidden
 * Assign implemented on CollectionItems
 * 
 * *****************  Version 66  *****************
 * User: Dthk         Date: 00-12-04   Time: 11.45
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Generellkod flyttad till basklass, stdat
 * 
 * *****************  Version 65  *****************
 * User: Dthk         Date: 00-12-01   Time: 11.44
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bttre hantering av noder som har Hidden children
 * Bttre hantering av HideNodeWithNoChildren 
 * 
 * *****************  Version 64  *****************
 * User: Dthk         Date: 00-11-30   Time: 15.50
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bytt till enhetligt stt att f fatt i subgriddar
 * 
 * *****************  Version 63  *****************
 * User: Dthk         Date: 00-11-28   Time: 18.28
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Stdat, rttat buggar, lagt till hiddenNode, PreExpandLevels,
 * InitLevels Enter i subtree
 * 
 * *****************  Version 62  *****************
 * User: Dtkl         Date: 00-11-23   Time: 12.07
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Trd i trd problem/HK
 * 
 * *****************  Version 61  *****************
 * User: Hasse        Date: 00-11-09   Time: 10.49
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Krashade vid om definition av trdet i RT, fixat
 * 
 * *****************  Version 60  *****************
 * User: Hasse        Date: 00-11-07   Time: 17.45
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Sortering
 *
 * *****************  Version 59  *****************
 * User: Hasse        Date: 00-11-07   Time: 14.12
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * SubGriddar kan vara trd
 *
 * *****************  Version 58  *****************
 * User: Hasse        Date: 00-11-03   Time: 15.53
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * SubTRd pbrjat
 * 
 * *****************  Version 57  *****************
 * User: Hasse        Date: 00-11-03   Time: 13.14
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Trdstd
 * 
 * *****************  Version 56  *****************
 * User: Hasse        Date: 00-10-27   Time: 16.00
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Stdat
 * 
 * *****************  Version 55  *****************
 * User: Egil         Date: 00-10-20   Time: 15:53
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Tar hand om valueset's s att de initieras korrekt.
 * 
 * *****************  Version 54  *****************
 * User: Hasse        Date: 00-10-16   Time: 15.49
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Ny parameter p OnUserSort
 * 
 * *****************  Version 53  *****************
 * User: Hasse        Date: 00-10-16   Time: 10.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Brutit isr till en basklass phGrid 
 *
 * *****************  Version 52  *****************
 * User: Egil         Date: 00-10-12   Time: 17:53
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Skickar SelectionChanged som DoLater efter att InternalSelectionChanged
 * har skett (kom flera i stten).
 *
 * *****************  Version 51  *****************
 * User: Hasse        Date: 00-10-10   Time: 17.10
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Grid problem med sortering osv
 * 
 * *****************  Version 50  *****************
 * User: Hasse        Date: 00-10-06   Time: 14.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Uptckte att gridden evaluerade om fr varje ommarkering....
 * 
 * *****************  Version 49  *****************
 * User: Hasse        Date: 00-10-05   Time: 16.48
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Tappar inte selectering vid sortering och kan navigera p tangenttryck
 * 
 * *****************  Version 48  *****************
 * User: Hasse        Date: 00-09-29   Time: 12.43
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg gjorde att sortering uteblev om listan innhller dubletter
 *
 * *****************  Version 47  *****************
 * User: Hasse        Date: 00-09-15   Time: 19.02
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * ndringar fr trdanpassning
 * 
 * *****************  Version 46  *****************
 * User: Hasse        Date: 00-09-08   Time: 13.06
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * En LayoutProp per column
 * 
 * *****************  Version 45  *****************
 * User: Hasse        Date: 00-09-06   Time: 13.22
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Publicerade properties
 * 
 * *****************  Version 44  *****************
 * User: Hasse        Date: 00-08-25   Time: 12.48
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Selectera om elementet om det blir omskapat och dyker upp p ett nytt
 * stlle...
 * 
 * *****************  Version 43  *****************
 * User: Hasse        Date: 00-08-23   Time: 9.43
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg vid borttag av rad i editlge fixad
 * tckTime funkar nu
 * 
 * *****************  Version 42  *****************
 * User: Hasse        Date: 00-08-18   Time: 11.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Events fr sortering
 * 
 * *****************  Version 41  *****************
 * User: Hasse        Date: 00-08-16   Time: 16.51
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Tv nya events; bra fr att stta layoutproperty p rtt stlle
 *     fOnCellContentUpdate_Before: TOnCellEvent;
 *     fOnCellContentUpdate_After: TOnCellEvent;
 * 
 * *****************  Version 40  *****************
 * User: Hasse        Date: 00-08-10   Time: 11.09
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Enusre incomming handle is uptodate
 * 
 * *****************  Version 39  *****************
 * User: Hasse        Date: 00-08-09   Time: 14.56
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Anvnder ID istllet fr index eftersom ID byggs p vid borttagande och
 * tillgg
 * 
 * *****************  Version 38  *****************
 * User: Hasse        Date: 00-08-09   Time: 13.52
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Sorts everything
 * 
 * *****************  Version 37  *****************
 * User: Hasse        Date: 00-08-01   Time: 11.49
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Eftersom Text r default typen p en kolumn s skall
 * fBoldProperties_Text lggas i listan som default
 * 
 * *****************  Version 36  *****************
 * User: Hasse        Date: 00-07-31   Time: 16.52
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg om slog p HasInfoCol i BoldGrid_BA
 * ColumnProperties skall bara en tgngen...
 *
 * *****************  Version 35  *****************
 * User: Hasse        Date: 00-07-25   Time: 11.24
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Oops funkade inte riktigt fr subgriddar
 * 
 * *****************  Version 34  *****************
 * User: Hasse        Date: 00-07-25   Time: 10.36
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Cell initiation and follower connection was moved to
 * _AfterMakeCellUptoDate
 * since we found unexplainable strange bold behavior in _InsertCell
 *  (Sometimes after a Columns.Clear and adding of new columns they never
 * showed up here)
 * 
 * bla i skning dialogen Uris
 *
 * *****************  Version 33  *****************
 * User: Hasse        Date: 00-07-24   Time: 13.27
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Egil hade stdat lite fr myckety. Krash vid anv. av subgrid
 * 
 * *****************  Version 32  *****************
 * User: Egil         Date: 00-06-29   Time: 9:57
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Fler Assigned-kollar samt try..except patchar
 * 
 * *****************  Version 31  *****************
 * User: Egil         Date: 00-06-27   Time: 16:35
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Bugg i Add/Remove av kolumner gav krash - fixat.
 * Lite stdning - anvnder CellToColumn verallt i st f AxisListItem
 * 
 * *****************  Version 30  *****************
 * User: Hasse        Date: 00-06-20   Time: 16.58
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * OnUserBeforeEnterEdit
 * 
 * *****************  Version 29  *****************
 * User: Hasse        Date: 00-06-20   Time: 16.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Combobox events
 * 
 * *****************  Version 28  *****************
 * User: Hasse        Date: 00-06-20   Time: 11.13
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Publicerade events fr rendering
 * 
 * *****************  Version 27  *****************
 * User: Hasse        Date: 00-06-16   Time: 14.23
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 *    property    OnEditStop;
 *     property    OnAfterUserSize;
 *
 *     property    OnTopLeftChanged;
 *     property    OnSelectionChanged;
 * 
 * *****************  Version 26  *****************
 * User: Hasse        Date: 00-06-14   Time: 11.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Assign kollar
 * 
 * *****************  Version 25  *****************
 * User: Hasse        Date: 00-06-05   Time: 10.34
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Subgrid funktionalitet
 *
 * *****************  Version 24  *****************
 * User: Hasse        Date: 00-05-29   Time: 16.15
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Flera buggar med scrollbars tgrdade
 * its ersatt med f
 *
 * *****************  Version 23  *****************
 * User: Hasse        Date: 00-05-19   Time: 16.07
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Registrering flyttad till phRegStuff_BA.pas
 * 
 * *****************  Version 22  *****************
 * User: Egil         Date: 00-05-18   Time: 14:03
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Ny metod fr att f frsta selekterade objektet
 * 
 * *****************  Version 21  *****************
 * User: Hasse        Date: 00-05-04   Time: 15.49
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Problem med apply utav float vrden
 *
 * *****************  Version 20  *****************
 * User: Hasse        Date: 00-04-27   Time: 17.33
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Problem med combon effectivereadonly, gtt tillbaka till REadOnly
 * enbart
 * 
 * *****************  Version 19  *****************
 * User: Egil         Date: 00-04-27   Time: 13:53
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Flyttar inplaceeditorn s att "rtt" item r aktiv i combon.
 * 
 * *****************  Version 18  *****************
 * User: Egil         Date: 00-04-26   Time: 13:15
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Override av DeInitEditor som anropar _AfterMakeCellUptoDate fr att
 * trigga ndringar mha BoldCombo
 * 
 * *****************  Version 17  *****************
 * User: Egil         Date: 00-04-26   Time: 0:09
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Ny version som kontrollerar OnMayModify p ComboEdit
 * 
 * *****************  Version 16  *****************
 * User: Olle         Date: 00-04-17   Time: 16:51
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * La till DateTimePicker som editor fr kolumner som r TDateTime
 * 
 * *****************  Version 15  *****************
 * User: Egil         Date: 00-03-21   Time: 11:22
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Ny metod GetAllObjects som gr livet lite lttare
 * 
 * *****************  Version 14  *****************
 * User: Egil         Date: 00-03-14   Time: 12:37
 * Updated in $/Gemensamt/Tredjepart/PlexityHide/BA
 * Man kan f en lista p de valda/selekterade objekten (endadst rader -
 * ej enskilda celler)
 * 
 * *****************  Version 13  *****************
 * User: Hasse        Date: 00-02-17   Time: 11.17
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Stop_Editing fre man byter boldhandle
 * 
 * *****************  Version 12  *****************
 * User: Egil         Date: 00-02-03   Time: 20:49
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Frsiktigare variant av CellToElement och CellToRowFollower - gav
 * access violations tidigare - nu blir det bara nil tillbaka.
 *
 * *****************  Version 11  *****************
 * User: Hasse        Date: 00-01-27   Time: 12.46
 * Updated in $/Riks/Komp/PlexityHide/BA
 * ReadOnly per kolumn
 *
 * *****************  Version 10  *****************
 * User: Hasse        Date: 00-01-24   Time: 16.11
 * Updated in $/Riks/Komp/PlexityHide/BA
 * Sortering per kolumn
 * Editering via combo pajjat efter boldversionsbyte;rttat
 *
 * *****************  Version 9  *****************
 * User: Hasse        Date: 00-01-20   Time: 15.36
 * Updated in $/Riks/Komp/PlexityHide/BA
 * RowSelect
 * Bugg map dmAutomatic
*)






end.
