unit phGrid_BA_Editor;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,Typinfo,
  {$ifdef D6}
  DesignIntf,DesignEditors;
  {$else}
  DsgnIntf;
  {$endif}


type

  TphGrid_BA_WakeUpGlue = class(TComponentEditor)
  private
  {$ifdef D6}
    procedure Props(const Prop: IProperty);
  {$else}
    procedure Props(Prop: TPropertyEditor);
  {$endif}
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TphGrid_BA_PropertyWakeUpGlue = class(TPropertyEditor)
  private
  public
    procedure Edit; override;
  end;


implementation
uses
  phGrid_BA,BoldNodeControlPack,Dialogs,phTreeNodeDescriptionEditor;



{ TphNodeDescriptionEditor }

  {$ifdef D6}
procedure TphGrid_BA_WakeUpGlue.Props(const Prop: IProperty);
  {$else}
procedure TphGrid_BA_WakeUpGlue.Props(Prop: TPropertyEditor);
  {$endif}
begin
  if Uppercase(Prop.GetName)='COLUMNS' then
  begin
    Prop.Edit;
  end;
end;


procedure TphGrid_BA_WakeUpGlue.ExecuteVerb(Index: Integer);
var
  {$ifdef D6}
  Components: TDesignerSelections;
  {$else}
  Components: TDesignerSelectionList;
  {$endif}
begin
  if index=0 then
    TTreeNodeDescriptionEditor.Edit(Component as TphGrid_BA,
    (Component as TphGrid_BA).BoldTreeProperties, Designer)
  else
  begin
  {$ifdef D6}
    Components := TDesignerSelections.Create;
    try
      (Designer as IDesigner).GetSelections(Components);
  {$else}
    Components := TDesignerSelectionList.Create;
    try
      Components.Add( Component);
  {$endif}
      GetComponentProperties(Components, tkProperties, Designer, Props);
    finally
      Components.Free;
    end;
  end;

  Designer.Modified;
end;

function TphGrid_BA_WakeUpGlue.GetVerb(Index: Integer): string;
begin
  case Index of
    0:Result := '&Edit Node Descriptions...';
    1:Result := 'Columns';
  end;
end;

function TphGrid_BA_WakeUpGlue.GetVerbCount: Integer;
begin
  Result := 2;
end;


{ TphGrid_BA_PropertyWakeUpGlue }

procedure TphGrid_BA_PropertyWakeUpGlue.Edit;
begin
  inherited;
  if GetComponent(0) is TphGrid_BA_Column then
  begin
    TTreeNodeDescriptionEditor.Edit((GetComponent(0) as TphGrid_BA_Column).Grid_BA,
    (GetComponent(0) as TphGrid_BA_Column).BoldProp_SubTree, Designer);
  end;
  Designer.Modified;
end;

end.

