unit phSchema_BA;
(**@TODO:  eventuellt designstd fr kolumner*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, phSchema, BoldAbstractListHandle, BoldListListControlPack, BoldControllerListControlPack,
  BoldListHandleFollower, BoldElements, BoldControlPack, BoldFloatControlPack,
  BoldNumericControlPack,phDataEntityPack,BoldStringControlPack;

type

  TphSchema_BA_Layers=class;
  TphSchema_BA_Layer=class;


  TphSchema_BA = class(TphSchema_ComBasic)
  private
    fLayers: TphSchema_BA_Layers;
    procedure SetLayers(const Value: TphSchema_BA_Layers);
    procedure _OnChangeDataEntity_SchemaTime(theSchema: TphSchema_ComBAsic;
      theDataEntity: TphDataEntity_SchemaTime);
    { Private declarations }
  protected
    { Protected declarations }
    procedure _OnBeforeCanEditItem(theDataEntity: TphDataEntity);override;
  public
    { Public declarations }
    function GetBoldElementFromXY(X,Y:integer) : TBoldElement;
    function ActiveBoldElement : TBoldElement;
    class function DataEntityToElement(theDataEntity: TphDataEntity): TBoldElement;
    class function DataEntityToFollower(theDataEntity: TphDataEntity): TBoldFollower;

    constructor Create(theOwner:TComponent);override;
    destructor Destroy;override;
  published
    { Published declarations }
    property Layers:TphSchema_BA_Layers read fLayers write SetLayers;

    property  FlipView;
    property  OnHeaderFromColumn;
    property  HeaderPopupmenu;
    property  PopupSchema;
    property  SchemaColor;
    property  SchemaPyjamasColor;
    property  StartSnapONOFF;
    property  LengthSnapONOFF;
    property  StartSnap;
    property  LengthSnap;

    property  TextFont1;
    property  TextFont2;
    property  TextFont3;

    property  CollisionDetectBetweenDataList;
    property  CollisionDetect;

    property  ShowBigONOFF;
    property  ResizeAllCol;
    property  MoveInTimeWhenColSwitch;

    property ScalerDateFormat;
    property ScalerTimeFormat;
    property ScalerStart;
    property ScalerStop;
    property ScalerWidth;
    property ScalerHeight;


    property DrawShortLines;


    property OnInitColumnDataObject;
    property OnGetDrawingRect;
    property OnSchemaHintInfo;

    property OnHeaderStartDrag;
    property OnHeaderEndDrag;
    property OnHeaderDragOver;
    property OnHeaderDragDrop;

    property OnUserDecideColSize;
    property OnScalerChange;
    property OnSelectionChanged;
    property OnSwitchCol;
    property OnDrawTimeContent;

    //property OnChangeDataEntity_SchemaTime;
    property OnIsVisible;

    {TPanel stuff}
    property Align;
    property Alignment;
    //property BevelInner;
    //property BevelOuter;
    //property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Color;
    property Ctl3D;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDrag;
    property OnKeyDown;
  end;



  TphSchema_BA_Layers=class(TCollection)
  private
    procedure SetLayers(const Value: TphSchema_BA_Layers);
  protected
    fphSchema:TphSchema_BA;
    fLayers:TphSchema_BA_Layers;
    function GetOwner: TPersistent; override;
  public
    property Layers:TphSchema_BA_Layers read fLayers write SetLayers;
  end;



  TphSchemaTimeTextDef=class(TPersistent)
  private
    fBoldProperties_Text: TBoldStringFollowerController;
    fStyle: integer;
    fy: Integer;
    fx: Integer;
    procedure SetBoldProperties_Text(
      const Value: TBoldStringFollowerController);
  public

  published
    property BoldProp_Text: TBoldStringFollowerController read fBoldProperties_Text write SetBoldProperties_Text;
    property Style:integer read fStyle write fStyle;
    property x:Integer read fx write fx;
    property y:Integer read fy write fy;
  end;

  TphSchema_BA_Layer=class(TCollectionItem)
  private
    fInsetStart: Integer;
    fInsetStop: Integer;
    fColor: TColor;
    fFrameColor: TColor;
    fTextDef1: TphSchemaTimeTextDef;
    fTextDef3: TphSchemaTimeTextDef;
    fTextDef2: TphSchemaTimeTextDef;
    procedure SetBoldProperties_Start(
      const Value: TBoldFloatFollowerController);
    procedure SetBoldProperties_Stop(
      const Value: TBoldFloatFollowerController);
    procedure SetBoldProperties_Column(
      const Value: TBoldIntegerFollowerController);
    function GetBoldHandle: TBoldAbstractListHandle;
    procedure SetBoldHandle(const Value: TBoldAbstractListHandle);
    function GetSchema: TphSchema_BA;
    procedure _Text1Changed(theFollower: TBoldFollower);
    procedure _Text2Changed(theFollower: TBoldFollower);
    procedure _Text3Changed(theFollower: TBoldFollower);
    procedure SetTextDef1(const Value: TphSchemaTimeTextDef);
    procedure SetTextDef2(const Value: TphSchemaTimeTextDef);
    procedure SetTextDef3(const Value: TphSchemaTimeTextDef);
    procedure _TextChanged_Common(theFollower: TBoldFollower;
      theIndex: Integer);
  protected
    fBoldProperties_Start: TBoldFloatFollowerController;
    fBoldProperties_Stop: TBoldFloatFollowerController;
    fBoldProperties_Column: TBoldIntegerFollowerController;
    fHandleFollower:TBoldListHandleFollower;
    fBoldTimeProperties:TBoldControllerList;
    fBoldProperties:TBoldListAsFollowerListController;

    function GetDisplayName: string; override;


    function  GetHandleStaticType: TBoldElementTypeInfo;
    procedure _InsertTimeItem(theFollower:TBoldFollower);
    procedure _DeleteTimeItem(theFollower:TBoldFollower);
    procedure _StartDateChanged(theFollower:TBoldFollower);
    procedure _StopDateChanged(theFollower:TBoldFollower);
    procedure _ColumnChanged(theFollower:TBoldFollower);
    function GetContext: TBoldElementTypeInfo;
  public
    constructor Create(theCollection:TCollection);override;
    destructor  Destroy;override;
  published
    property BoldHandle:TBoldAbstractListHandle read GetBoldHandle write SetBoldHandle;
    property InsetStart:Integer read fInsetStart write fInsetStart;
    property InsetStop:Integer read fInsetStop write fInsetStop;
    property Color:TColor read fColor write fColor;
    property FrameColor:TColor read fFrameColor write fFrameColor;
    property BoldProp_Start: TBoldFloatFollowerController read fBoldProperties_Start write SetBoldProperties_Start;
    property BoldProp_Stop: TBoldFloatFollowerController read fBoldProperties_Stop write SetBoldProperties_Stop;
    property BoldProp_Column: TBoldIntegerFollowerController read fBoldProperties_Column write SetBoldProperties_Column;

    property TextDef1:TphSchemaTimeTextDef read fTextDef1 write SetTextDef1;
    property TextDef2:TphSchemaTimeTextDef read fTextDef2 write SetTextDef2;
    property TextDef3:TphSchemaTimeTextDef read fTextDef3 write SetTextDef3;
  end;





implementation
uses
  Typinfo;


{ TphSchema_BA }

class function TphSchema_BA.DataEntityToElement(
  theDataEntity: TphDataEntity): TBoldElement;
begin
  result:=nil;
  if Assigned(theDataEntity) then
  begin
    result:=TBoldFollower(theDataEntity.UserReference).{(1)FIX: Value}Element;
  end;
end;

class function TphSchema_BA.DataEntityToFollower(
  theDataEntity: TphDataEntity): TBoldFollower;
begin
  result:=nil;
  if Assigned(theDataEntity) then
  begin
    result:=TBoldFollower(theDataEntity.UserReference);
  end;
end;

constructor TphSchema_BA.Create(theOwner: TComponent);
begin
  inherited;
  fLayers:=TphSchema_BA_Layers.Create(TphSchema_BA_Layer);
  fLayers.fphSchema:=self;
  OnChangeDataEntity_SchemaTime:=_OnChangeDataEntity_SchemaTime;
end;


destructor TphSchema_BA.Destroy;
begin
  fLayers.Free;
  inherited;
end;

procedure TphSchema_BA._OnChangeDataEntity_SchemaTime(
  theSchema: TphSchema_ComBAsic; theDataEntity: TphDataEntity_SchemaTime);
var
  aFollower:TBoldFollower;
begin
  aFollower:=TBoldFollower(theDataEntity.UserReference);
  if Assigned(aFollower) then
  begin
    if ((aFollower.SubFollowers[0].RendererData as TBoldFloatRendererData).CurrentFloatValue<>theDataEntity.Start) and
      ((aFollower.Controller as TBoldControllerList).Items[0] as TBoldFloatFollowerController).MayModify(aFollower.SubFollowers[0]) then
      ((aFollower.Controller as TBoldControllerList).Items[0] as TBoldFloatFollowerController).SetAsFloat(theDataEntity.Start,aFollower)
    else
      theDataEntity.Start:=(aFollower.SubFollowers[0].RendererData as TBoldFloatRendererData).CurrentFloatValue;


    if ((aFollower.SubFollowers[1].RendererData as TBoldFloatRendererData).CurrentFloatValue<>theDataEntity.Stop) and
      ((aFollower.Controller as TBoldControllerList).Items[1] as TBoldFloatFollowerController).MayModify(aFollower.SubFollowers[1]) then
      ((aFollower.Controller as TBoldControllerList).Items[1] as TBoldFloatFollowerController).SetAsFloat(theDataEntity.Stop,aFollower)
    else
      theDataEntity.Stop:=(aFollower.SubFollowers[1].RendererData as TBoldFloatRendererData).CurrentFloatValue;

    if ((aFollower.SubFollowers[2].RendererData as TBoldIntegerRendererData).CurrentIntegerValue<>theDataEntity.Col) and
      ((aFollower.Controller as TBoldControllerList).Items[2] as TBoldIntegerFollowerController).MayModify(aFollower.SubFollowers[2]) then
      ((aFollower.Controller as TBoldControllerList).Items[2] as TBoldIntegerFollowerController).SetAsInteger(theDataEntity.Col,aFollower)
    else
      theDataEntity.Col:=(aFollower.SubFollowers[2].RendererData as TBoldIntegerRendererData).CurrentIntegerValue;

  end;
end;


procedure TphSchema_BA.SetLayers(const Value: TphSchema_BA_Layers);
begin
  fLayers.Assign(Value);
end;

procedure TphSchema_BA._OnBeforeCanEditItem(theDataEntity: TphDataEntity);
var
  aFollower:TBoldFollower;
begin
  inherited;
  aFollower:=TBoldFollower(theDataEntity.UserReference);
  // We dont allow Separate CanEdit States, just pick the first one (start time)
  theDataEntity.CanEdit:=(aFollower.SubFollowers[0]).RendererData.MayModify;
end;

{ TphSchema_BA_Layer }

function TphSchema_BA_Layer.GetSchema:TphSchema_BA;
begin
  result:=(Collection as TphSchema_BA_Layers).fphSchema;
end;

constructor TphSchema_BA_Layer.Create(theCollection: TCollection);
begin
  inherited;
  fBoldTimeProperties := TBoldControllerList.Create(GetSchema);
  fBoldProperties := TBoldListAsFollowerListController.Create(GetSchema, fBoldTimeProperties );
  fBoldProperties.OnAfterInsertItem := _InsertTimeItem;
  fBoldProperties.OnBeforeDeleteItem := _DeleteTimeItem;
  fBoldProperties.OnGetContextType := GetHandleStaticType;
  fHandleFollower:=TBoldListHandleFollower.Create(GetSchema.Owner,fBoldProperties);

  fBoldProperties_Start:=TBoldFloatFollowerController.Create(GetSchema.Owner);
  fBoldProperties_Start.AfterMakeUptoDate:=_StartDateChanged;
  fBoldProperties_Start.OnGetContextType := GetContext;
  fBoldTimeProperties.Add( fBoldProperties_Start );

  fBoldProperties_Stop:=TBoldFloatFollowerController.Create(GetSchema.Owner);
  fBoldProperties_Stop.AfterMakeUptoDate:=_StopDateChanged;
  fBoldProperties_Stop.OnGetContextType := GetContext;
  fBoldTimeProperties.Add( fBoldProperties_Stop );


  fBoldProperties_Column:=TBoldIntegerFollowerController.Create(GetSchema.Owner);
  fBoldProperties_Column.AfterMakeUptoDate:=_ColumnChanged;
  fBoldProperties_Column.OnGetContextType := GetContext;
  fBoldTimeProperties.Add( fBoldProperties_Column );

  fTextDef1:=TphSchemaTimeTextDef.Create;
  fTextDef2:=TphSchemaTimeTextDef.Create;
  fTextDef3:=TphSchemaTimeTextDef.Create;

  TextDef1.fBoldProperties_Text:=TBoldStringFollowerController.Create(GetSchema.Owner);
  TextDef1.fBoldProperties_Text.AfterMakeUptoDate:=_Text1Changed;
  TextDef1.fBoldProperties_Text.OnGetContextType := GetContext;

  fBoldTimeProperties.Add( TextDef1.fBoldProperties_Text );

  TextDef2.fBoldProperties_Text:=TBoldStringFollowerController.Create(GetSchema.Owner);
  TextDef2.fBoldProperties_Text.AfterMakeUptoDate:=_Text2Changed;
  TextDef2.fBoldProperties_Text.OnGetContextType := GetContext;
  fBoldTimeProperties.Add( TextDef2.fBoldProperties_Text );

  TextDef3.fBoldProperties_Text:=TBoldStringFollowerController.Create(GetSchema.Owner);
  TextDef3.fBoldProperties_Text.AfterMakeUptoDate:=_Text3Changed;
  TextDef3.fBoldProperties_Text.OnGetContextType := GetContext;
  fBoldTimeProperties.Add( TextDef3.fBoldProperties_Text );

  TextDef1.fStyle:=-1;
  TextDef2.fStyle:=-1;
  TextDef3.fStyle:=-1;

end;

destructor TphSchema_BA_Layer.Destroy;
begin
  FreeAndNil(fBoldTimeProperties);
  FreeAndNil(fBoldProperties);
  FreeAndNil(fHandleFollower);
  FreeAndNil(fTextDef1);
  FreeAndNil(fTextDef2);
  FreeAndNil(fTextDef3);
  inherited;

end;



function TphSchema_BA_Layer.GetDisplayName: string;
var
  aBHName:String;
begin
  if Assigned(BoldHandle) then
    aBHName:=BoldHandle.Name;
  result:=Format('Schema layer:%d presents: %s',[ID,aBHName]);
end;

procedure TphSchema_BA_Layer.SetBoldProperties_Column(
  const Value: TBoldIntegerFollowerController);
begin
  fBoldProperties_Column.Assign(Value);
end;

procedure TphSchema_BA_Layer.SetBoldProperties_Start(
  const Value: TBoldFloatFollowerController);
begin
  fBoldProperties_Start.Assign(Value);
end;

procedure TphSchema_BA_Layer.SetBoldProperties_Stop(
  const Value: TBoldFloatFollowerController);
begin
  fBoldProperties_Stop.Assign(Value);
end;



procedure TphSchema_BA_Layer._DeleteTimeItem(theFollower: TBoldFollower);
begin
  if theFollower.ControlData is TphDataEntity_SchemaTime then
    GetSchema.RemoveSchemaTime(theFollower.ControlData as TphDataEntity_SchemaTime);
end;

procedure TphSchema_BA_Layer._InsertTimeItem(theFollower: TBoldFollower);
var
  dataEntity_SchemaTime:TphDataEntity_SchemaTime;
begin
  dataEntity_SchemaTime:=GetSchema.AddSchemaTime(ID);
  dataEntity_SchemaTime.UserReference:=theFollower;
  theFollower.ControlData:=dataEntity_SchemaTime;
  dataEntity_SchemaTime.LeftInset:=InsetStart;
  dataEntity_SchemaTime.RightInset:=InsetStop;
  dataEntity_SchemaTime.BackColor:=Color;
  dataEntity_SchemaTime.FrameColor:=FrameColor;


  dataEntity_SchemaTime.AddText('',TextDef1.x,TextDef1.y,TextDef1.Style);
  dataEntity_SchemaTime.AddText('',TextDef2.x,TextDef2.y,TextDef2.Style);
  dataEntity_SchemaTime.AddText('',TextDef3.x,TextDef3.y,TextDef3.Style);


  (theFollower.Controller as TBoldControllerList).SetActiveRange( theFollower, 0, 3+3);
  theFollower.EnsureDisplayable;
  GetSchema.itsTA.Invalidate;
end;

function TphSchema_BA.GetBoldElementFromXY(X,Y:integer) : TBoldElement;
begin
  result := DataEntityToElement( GetDataEntityFromXY(X,Y) );
end;

function TphSchema_BA.ActiveBoldElement: TBoldElement;
begin
  result := DataEntityToElement( ActiveDataEntity );
end;

function TphSchema_BA_Layer.GetBoldHandle: TBoldAbstractListHandle;
begin
  result:=fHandleFollower.BoldHandle;
end;

function TphSchema_BA_Layer.GetHandleStaticType: TBoldElementTypeInfo;
begin
  if assigned( BoldHandle ) then
    result := BoldHandle.StaticBoldType
  else
    result := nil;
end;




procedure TphSchema_BA_Layer.SetBoldHandle(const Value: TBoldAbstractListHandle);
begin
  fHandleFollower.BoldHandle:=Value;
end;


procedure TphSchema_BA_Layer._TextChanged_Common(theFollower: TBoldFollower;theIndex:Integer);
var
  dataEntity_SchemaTime:TphDataEntity_SchemaTime;
  textDef:TphSchemaTimeTextDef;
begin
  case theIndex of
    0:textDef:=TextDef1;
    1:textDef:=TextDef2;
    2:textDef:=TextDef3;
  else
    raise Exception.Create('3287');
  end;
  dataEntity_SchemaTime:=TphDataEntity_SchemaTime(theFollower.OwningFollower.ControlData);
  dataEntity_SchemaTime.AlterText(theIndex,(theFollower.Controller as TBoldStringFollowerController).GetCurrentAsString(theFollower),textDef.x,textDef.y,textDef.Style);
  GetSchema.itsTA.Invalidate;
end;

procedure TphSchema_BA_Layer._Text1Changed(theFollower: TBoldFollower);
begin
  _TextChanged_Common(theFollower,0);
end;
procedure TphSchema_BA_Layer._Text2Changed(theFollower: TBoldFollower);
begin
  _TextChanged_Common(theFollower,1);
end;

procedure TphSchema_BA_Layer._Text3Changed(theFollower: TBoldFollower);
begin
  _TextChanged_Common(theFollower,2);
end;

procedure TphSchema_BA_Layer._StartDateChanged(theFollower: TBoldFollower);
var
  dataEntity_SchemaTime:TphDataEntity_SchemaTime;
begin
  dataEntity_SchemaTime:=TphDataEntity_SchemaTime(theFollower.OwningFollower.ControlData);
  dataEntity_SchemaTime.Start:=(theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower);
  GetSchema.itsTA.Invalidate;
  GetSchema.UpdateSubColumns;
end;

procedure TphSchema_BA_Layer._StopDateChanged(theFollower: TBoldFollower);
var
  dataEntity_SchemaTime:TphDataEntity_SchemaTime;
begin
  dataEntity_SchemaTime:=TphDataEntity_SchemaTime(theFollower.OwningFollower.ControlData);
  dataEntity_SchemaTime.Stop:=(theFollower.Controller as TBoldFloatFollowerController).GetCurrentAsFloat(theFollower);
  GetSchema.itsTA.Invalidate;
  GetSchema.UpdateSubColumns;
end;

procedure TphSchema_BA_Layer._ColumnChanged(theFollower: TBoldFollower);
var
  dataEntity_SchemaTime:TphDataEntity_SchemaTime;
begin
  dataEntity_SchemaTime:=TphDataEntity_SchemaTime(theFollower.OwningFollower.ControlData);
  dataEntity_SchemaTime.Col:=(theFollower.Controller as TBoldIntegerFollowerController).GetCurrentAsInteger(theFollower);
  GetSchema.itsTA.Invalidate;
end;


procedure TphSchema_BA_Layer.SetTextDef1(
  const Value: TphSchemaTimeTextDef);
begin
  fTextDef1.Assign(Value);
end;

procedure TphSchema_BA_Layer.SetTextDef2(
  const Value: TphSchemaTimeTextDef);
begin
  fTextDef2.Assign(Value);
end;

procedure TphSchema_BA_Layer.SetTextDef3(
  const Value: TphSchemaTimeTextDef);
begin
  fTextDef3.Assign(Value);
end;

function TphSchema_BA_Layer.GetContext: TBoldElementTypeInfo;
begin
  if assigned(BoldHandle) then
    result := BoldHandle.StaticBoldType
  else
    result := nil;
end;

{ TphSchema_BA_Layers }

function TphSchema_BA_Layers.GetOwner: TPersistent;
begin
  result:=fphSchema;
end;

procedure TphSchema_BA_Layers.SetLayers(const Value: TphSchema_BA_Layers);
begin
  fLayers.Assign(Value);
end;


{ TphSchemaTimeTextDef }

procedure TphSchemaTimeTextDef.SetBoldProperties_Text(
  const Value: TBoldStringFollowerController);
begin
  fBoldProperties_Text.Assign(Value);
end;

end.
