unit phSchema_BA_Editor;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,Typinfo,
  {$ifdef D6}
  DesignIntf,DesignEditors;
  {$else}
  DsgnIntf;
  {$endif}


type
  TphSchemaEditorWakeUpGlue = class(TComponentEditor)
  public
  {$ifdef D6}
    procedure Props(const Prop: IProperty);
  {$else}
    procedure Props(Prop: TPropertyEditor);
  {$endif}
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;


implementation
{ TphSchemaEditorWakeUpGlue }

procedure TphSchemaEditorWakeUpGlue.ExecuteVerb(Index: Integer);
var
  {$ifdef D6}
  Components: TDesignerSelections;
  {$else}
  Components: TDesignerSelectionList;
  {$endif}
begin
  {$ifdef D6}
  Components := TDesignerSelections.Create;
  try
    (Designer as IDesigner).GetSelections(Components);
  {$else}
  Components := TDesignerSelectionList.Create;
  try
    Components.Add( Component);
  {$endif}
    GetComponentProperties(Components, tkProperties, Designer, Props);
  finally
    Components.Free;
  end;
end;

function TphSchemaEditorWakeUpGlue.GetVerb(Index: Integer): string;
begin
  result:='Layers';
end;

function TphSchemaEditorWakeUpGlue.GetVerbCount: Integer;
begin
  result:=1;
end;

  {$ifdef D6}
procedure TphSchemaEditorWakeUpGlue.Props(const Prop: IProperty);
  {$else}
procedure TphSchemaEditorWakeUpGlue.Props(Prop: TPropertyEditor);
  {$endif}
begin
  if Uppercase(Prop.GetName)='LAYERS' then
  begin
    Prop.Edit;
  end;
end;

end.
