unit phTreeNodeDescriptionEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, ExtCtrls,
  {$ifdef D6}
  BoldNodeControlPack,DesignIntf,BoldGenericListControlPack
  {$else}
  BoldNodeControlPack,DsgnIntf,BoldGenericListControlPack
  {$endif};

type
  TTreeNodeDescriptionEditor = class(TForm)
    StringGrid1: TStringGrid;
    PopupMenu1: TPopupMenu;
    AddNodeDesc: TMenuItem;
    Removenodedescription1: TMenuItem;
    Addlistpart1: TMenuItem;
    Removelistpart1: TMenuItem;
    Panel1: TPanel;
    N1: TMenuItem;
    Moveup1: TMenuItem;
    GantItems: TMenuItem;
    Addtimelayer: TMenuItem;
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Removenodedescription1Click(Sender: TObject);
    procedure Addlistpart1Click(Sender: TObject);
    procedure Removelistpart1Click(Sender: TObject);
    procedure AddNodeDescClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Moveup1Click(Sender: TObject);
    procedure AddtimelayerClick(Sender: TObject);
  private
    { Private declarations }
    fBoldTreeFollowerController: TBoldTreeFollowerController;
    fViewComponent:TComponent;
  {$ifdef D6}
    fDesigner:IDesigner;
  {$else}
    fDesigner:IFormDesigner;
  {$endif}

    procedure GetSelObjs(var theBoldNodeDescription:TBoldNodeDescription;var theBoldGenericListPart:TBoldGenericListPart);
    procedure UpdateGrid;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;


  public
    { Public declarations }
  {$ifdef D6}
    class procedure Edit(theViewComponent:TComponent;theBoldTreeFollowerController:TBoldTreeFollowerController;theFormDesigner:IDesigner);
  {$else}
    class procedure Edit(theViewComponent:TComponent;theBoldTreeFollowerController:TBoldTreeFollowerController;theFormDesigner:IFormDesigner);
  {$endif}
  end;

var
  TreeNodeDescriptionEditor: TTreeNodeDescriptionEditor;

implementation
uses
  phGant_BA;
{$R *.DFM}




{ TTreeNodeDescriptionEditor }


{$ifdef D6}
  class procedure TTreeNodeDescriptionEditor.Edit(theViewComponent:TComponent;theBoldTreeFollowerController:TBoldTreeFollowerController;theFormDesigner:IDesigner);
{$else}
  class procedure TTreeNodeDescriptionEditor.Edit(theViewComponent:TComponent;theBoldTreeFollowerController:TBoldTreeFollowerController;theFormDesigner:IFormDesigner);
{$endif}
var
  i:integer;
  aForm:TTreeNodeDescriptionEditor;
begin

  aForm:=nil;
  for i:=0 to Screen.FormCount-1 do
  begin
    if (Screen.Forms[i] is TTreeNodeDescriptionEditor) then
    begin
      with (Screen.Forms[i] as TTreeNodeDescriptionEditor) do
      begin
        if (fBoldTreeFollowerController=theBoldTreeFollowerController) then
        begin
          aForm:=(Screen.Forms[i] as TTreeNodeDescriptionEditor);
          break;
        end;
      end;
    end;
  end;

  if not Assigned(aForm) then
  begin
    aForm:=TTreeNodeDescriptionEditor.Create(nil);
    with aForm do
    begin
      fBoldTreeFollowerController:=theBoldTreeFollowerController;
      fViewComponent:=theViewComponent;
      fDesigner:=theFormDesigner;
      if Assigned(fViewComponent) then
        fViewComponent.FreeNotification(aForm);
    end;
  end;
  aForm.UpdateGrid;
  aForm.Show;
  aForm.BringToFront;

end;

procedure TTreeNodeDescriptionEditor.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (Operation=opRemove) and (AComponent=fViewComponent) then
  begin
    Close;
  end;
end;

procedure TTreeNodeDescriptionEditor.UpdateGrid;
  procedure localDoRow(theDesc:String;theRowNum:Integer;ref1,ref2:TObject);
  begin
    if theRowNum>StringGrid1.RowCount-1 then
      StringGrid1.RowCount:=theRowNum+1;

    StringGrid1.Objects[0,theRowNum]:=ref1;
    StringGrid1.Objects[1,theRowNum]:=ref2;
    StringGrid1.Cells[0,theRowNum]:=theDesc;

  end;
var
  row,i,ii:integer;
begin
  localDoRow('',0,nil,nil);
  row:=1;
  for i:=0 to fBoldTreeFollowerController.Parts.Count-1 do
  begin
    localDoRow('SubNode'(*+IntToStr(fBoldTreeFollowerController.NodeDescriptions.Count)*),row,nil,fBoldTreeFollowerController.Parts[i]);
    inc(row);
  end;

  //ShowMessage(IntToStr(fBoldTreeFollowerController.NodeDescriptions.Count));
  for i:=0 to fBoldTreeFollowerController.NodeDescriptions.Count-1 do
  begin
    localDoRow('',row,fBoldTreeFollowerController.NodeDescriptions[i],nil);
    inc(row);
    for ii:=0 to fBoldTreeFollowerController.NodeDescriptions[i].ListController.Parts.Count-1 do
    begin
      localDoRow('SubNode',row,fBoldTreeFollowerController.NodeDescriptions[i],fBoldTreeFollowerController.NodeDescriptions[i].ListController.Parts[ii]);
      inc(row);
    end;
    if fBoldTreeFollowerController.NodeDescriptions[i] is TBoldGantNodeDescription then
    begin
      for ii:=0 to (fBoldTreeFollowerController.NodeDescriptions[i] as TBoldGantNodeDescription).GantRowListController.Parts.Count-1 do
      begin
        localDoRow('Time',row,fBoldTreeFollowerController.NodeDescriptions[i],(fBoldTreeFollowerController.NodeDescriptions[i] as TBoldGantNodeDescription).GantRowListController.Parts[ii]);
        inc(row);
      end;
    end;
  end;

  if StringGrid1.RowCount>row then
    StringGrid1.RowCount:=row;
end;

procedure TTreeNodeDescriptionEditor.StringGrid1DrawCell(Sender: TObject;
  ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  aNodeName,aPartName:String;
begin
  aNodeName:='Root';
  if StringGrid1.Objects[0,ARow] is TBoldNodeDescription then
  begin
    aNodeName:=(StringGrid1.Objects[0,ARow] as TBoldNodeDescription).DisplayName;
    if aNodeName='' then
      aNodeName:='<NoName>';
  end;
  aPartName:='';
  if StringGrid1.Objects[1,ARow] is TBoldGenericListPart then
  begin
    with (StringGrid1.Objects[1,ARow] as TBoldGenericListPart) do
    begin
      aPartName:=Format('%s - ListExpression:"%s"  ListIdentity:"%s"',[StringGrid1.Cells[0,ARow],ElementExpression,ControllerExpression]);
    end;
    aNodeName:='';
  end;

  if ACol=0 then
  begin
    if aNodeName<>'' then
    begin
      StringGrid1.Canvas.Font.Style:=[fsBold];
      StringGrid1.Canvas.TextRect(Rect,Rect.Left,Rect.Top,aNodeName);
    end
    else
    begin
      StringGrid1.Canvas.Font.Style:=[];
      StringGrid1.Canvas.TextRect(Rect,Rect.Left,Rect.Top,'    '+aPartName);
    end;
  end
  else
  if ACol=1 then
  begin
//    StringGrid1.Canvas.Font.Style:=[];
//    StringGrid1.Canvas.TextRect(Rect,Rect.Left,Rect.Top,aPartName);
  end;

end;

procedure TTreeNodeDescriptionEditor.Removenodedescription1Click(
  Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if Assigned(aBoldNodeDescription) then
    aBoldNodeDescription.Free;
  UpdateGrid;
end;

procedure TTreeNodeDescriptionEditor.Addlistpart1Click(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if Assigned(aBoldNodeDescription) then
    aBoldNodeDescription.ListController.Parts.Add
  else
    fBoldTreeFollowerController.Parts.Add;
  UpdateGrid;
end;

procedure TTreeNodeDescriptionEditor.Removelistpart1Click(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if Assigned(aBoldGenericListPart) then
    aBoldGenericListPart.Free;
  UpdateGrid;
end;

procedure TTreeNodeDescriptionEditor.AddNodeDescClick(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  fBoldTreeFollowerController.NodeDescriptions.Add;
  UpdateGrid;
end;

procedure TTreeNodeDescriptionEditor.GetSelObjs(
  var theBoldNodeDescription: TBoldNodeDescription;
  var theBoldGenericListPart: TBoldGenericListPart);
begin
  theBoldNodeDescription:=nil;
  theBoldGenericListPart:=nil;
  if StringGrid1.Selection.Top>-1 then
  begin
    theBoldNodeDescription:=StringGrid1.Objects[0,StringGrid1.Selection.Top] as TBoldNodeDescription;
    theBoldGenericListPart:=StringGrid1.Objects[1,StringGrid1.Selection.Top] as TBoldGenericListPart;
  end;
end;

procedure TTreeNodeDescriptionEditor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TTreeNodeDescriptionEditor.FormCreate(Sender: TObject);
begin
  StringGrid1.FixedRows:=0;
end;

procedure TTreeNodeDescriptionEditor.PopupMenu1Popup(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  AddNodeDesc.Enabled:=TRUE;
  Removenodedescription1.Enabled:=Assigned(aBoldNodeDescription);
  Addlistpart1.Enabled:=TRUE;
  Removelistpart1.Enabled:=Assigned(aBoldGenericListPart);
  Moveup1.Enabled:=Assigned(aBoldGenericListPart);
  GantItems.Enabled:=fViewComponent is TphGant_BA;
end;

procedure TTreeNodeDescriptionEditor.StringGrid1SelectCell(Sender: TObject;
  ACol, ARow: Integer; var CanSelect: Boolean);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
  aGridRect:TGridRect;
begin
  UpdateGrid; //Refresh everytime we get clicked
  aGridRect.Top:=ARow;
  aGridRect.Left:=0;
  StringGrid1.Selection:=aGridRect;
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if Assigned(fDesigner) then
  begin
    if Assigned(aBoldGenericListPart) then
      fDesigner.SelectComponent(aBoldGenericListPart)
    else
    if Assigned(aBoldNodeDescription) then
      fDesigner.SelectComponent(aBoldNodeDescription);
  end;
end;

procedure TTreeNodeDescriptionEditor.Moveup1Click(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if Assigned(aBoldGenericListPart) and
    (aBoldGenericListPart.Index>0) then
  begin
    aBoldGenericListPart.Index:=aBoldGenericListPart.Index-1;
    UpdateGrid;
  end;
end;


procedure TTreeNodeDescriptionEditor.AddtimelayerClick(Sender: TObject);
var
  aBoldNodeDescription: TBoldNodeDescription;
  aBoldGenericListPart: TBoldGenericListPart;
begin
  GetSelObjs(aBoldNodeDescription,aBoldGenericListPart);
  if aBoldNodeDescription is TBoldGantNodeDescription then
    (aBoldNodeDescription as TBoldGantNodeDescription).GantRowListController.Parts.Add;
  UpdateGrid;
end;

end.
