(****
The sample shows how you hook up an invisible BoldCombo to a grid
column for editing. There are two ways to do this, one is the BOLD way
with element handles and OCL-expression, and the other way is to
use events in the grid for MayModify evaluation and Applying the
choosen value. Use the checkbox "Use gridevents..." to toggle between the
two.

The Sample also shows a column with checkbox edit.


New: Event OnUserBeforeEnterEdit; use it for initialize the combo for example.

*)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, phOffscreenPaint, phBabGridView, phGrid_BA,
  BoldSubscription, BoldHandles, BoldRootedHandles, BoldAbstractListHandle,
  BoldCursorHandle, BoldListHandle, BoldComboBox, BoldExpressionHandle,
  phBabGridContent,BoldControlPack,BoldElements, phGrid;

type
  TForm1 = class(TForm)
    phGrid_BA1: TphGrid_BA;
    Panel1: TPanel;
    Panel2: TPanel;
    phGrid_BA2: TphGrid_BA;
    ButtonTestData: TButton;
    BLHComboValues: TBoldListHandle;
    BLHRowValues: TBoldListHandle;
    BoldComboBox1: TBoldComboBox;
    BEHCombo: TBoldExpressionHandle;
    CheckBox1: TCheckBox;
    procedure ButtonTestDataClick(Sender: TObject);
    function phGrid_BA1UserDecideMayModify(aGrid: TphGrid_BA;
      aColumn: TphGrid_BA_Column; aBabCell: TBabCell;
      aCellFollower: TBoldFollower; aDefaultResult: Boolean): Boolean;
    procedure phGrid_BA1ComboEditApplyValue(aGrid: TphGrid_BA;
      aColumn: TphGrid_BA_Column; aBabCell: TBabCell;
      aCellFollower: TBoldFollower; aValue: TBoldElement);
    procedure CheckBox1Click(Sender: TObject);
  private
    procedure phGrid_BA1UserBeforeEnterEdit(aGrid: TphGrid_BA;
      aColumn: TphGrid_BA_Column; aBabCell: TBabCell;
        aCellFollower: TBoldFollower);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, TestClasses;

{$R *.DFM}

procedure TForm1.ButtonTestDataClick(Sender: TObject);
var
  i:integer;
begin
  for i:=0 to 6 do
  begin
    TRowInCombo.Create(nil).Name:='Combovalue'+IntToStr(i);
  end;

  for i:=0 to 10 do
  begin
    TRowInGrid.Create(nil).Name:='GridRow'+IntToStr(i);
  end;
end;

function TForm1.phGrid_BA1UserDecideMayModify(aGrid: TphGrid_BA;
  aColumn: TphGrid_BA_Column; aBabCell: TBabCell;
  aCellFollower: TBoldFollower; aDefaultResult: Boolean): Boolean;
begin
  result:=aDefaultResult;
  if aColumn=aGrid.Columns[2] then
  begin
    result:=TRUE;
  end;
end;

procedure TForm1.phGrid_BA1ComboEditApplyValue(aGrid: TphGrid_BA;
  aColumn: TphGrid_BA_Column; aBabCell: TBabCell;
  aCellFollower: TBoldFollower; aValue: TBoldElement);
begin
  if aColumn=aGrid.Columns[2] then
  begin
    (aCellFollower.Element as TRowInGrid).rowInCombo:=aValue as TRowInCombo;
  end;
end;

(*** Initialize the Combo before it shows  *)
procedure TForm1.phGrid_BA1UserBeforeEnterEdit(aGrid: TphGrid_BA;
  aColumn: TphGrid_BA_Column; aBabCell: TBabCell; aCellFollower: TBoldFollower);
begin
  if aColumn=aGrid.Columns[2] then
  begin
    aColumn.BoldCombo.ItemIndex:=
      aColumn.BoldCombo.BoldListHandle.List.IndexOf((aCellFollower.Element as TRowInGrid).rowInCombo);
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
    BoldComboBox1.BoldHandle:=nil;
    phGrid_BA1.OnComboEditApplyValue:=phGrid_BA1ComboEditApplyValue;
    phGrid_BA1.OnUserDecideMayModify:=phGrid_BA1UserDecideMayModify;
    phGrid_BA1.OnUserBeforeEnterEdit:=phGrid_BA1UserBeforeEnterEdit;
  end
  else
  begin
    BoldComboBox1.BoldHandle:=BEHCombo;
    phGrid_BA1.OnComboEditApplyValue:=nil;
    phGrid_BA1.OnUserDecideMayModify:=nil;
  end;
end;

end.
 